// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(h) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function ce(e, n) {
        return n.indexOf(e) >= 0;
    }
    function ne(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function K(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = K(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function o(e, n) {
        this.message = e;
        this.defs = n;
    }
    o.prototype = Object.create(Error.prototype);
    o.prototype.constructor = o;
    o.prototype.name = "DefaultsError";
    n(o);
    function te(e, n, t) {
        if (e === true) e = {};
        var i = e || {};
        if (t) for (var r in i) if (ve(i, r) && !ve(n, r)) {
            throw new o("`" + r + "` is not a supported option", n);
        }
        for (var r in n) if (ve(n, r)) {
            i[r] = e && ve(e, r) ? e[r] : n[r];
        }
        return i;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (ve(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function Q() {}
    function le() {
        return false;
    }
    function ee() {
        return true;
    }
    function T() {
        return this;
    }
    function O() {
        return null;
    }
    var pe = function() {
        function e(t, i, r) {
            var o = [], a = [], s;
            function e() {
                var e = i(t[s], s);
                var n = e instanceof l;
                if (n) e = e.v;
                if (e instanceof f) {
                    e = e.v;
                    if (e instanceof c) {
                        a.push.apply(a, r ? e.v.slice().reverse() : e.v);
                    } else {
                        a.push(e);
                    }
                } else if (e !== u) {
                    if (e instanceof c) {
                        o.push.apply(o, r ? e.v.slice().reverse() : e.v);
                    } else {
                        o.push(e);
                    }
                }
                return n;
            }
            if (Array.isArray(t)) {
                if (r) {
                    for (s = t.length; --s >= 0; ) if (e()) break;
                    o.reverse();
                    a.reverse();
                } else {
                    for (s = 0; s < t.length; ++s) if (e()) break;
                }
            } else {
                for (s in t) if (ve(t, s)) if (e()) break;
            }
            return a.concat(o);
        }
        e.at_top = function(e) {
            return new f(e);
        };
        e.splice = function(e) {
            return new c(e);
        };
        e.last = function(e) {
            return new l(e);
        };
        var u = e.skip = {};
        function f(e) {
            this.v = e;
        }
        function c(e) {
            this.v = e;
        }
        function l(e) {
            this.v = e;
        }
        return e;
    }();
    function v(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function $(e, t) {
        return e.replace(/\{(.+?)\}/g, function(e, n) {
            return t && t[n];
        });
    }
    function z(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function de(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function he(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t])) return false;
        return true;
    }
    function M() {
        this._values = Object.create(null);
        this._size = 0;
    }
    M.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new M();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    M.fromObject = function(e) {
        var n = new M();
        n._size = t(n._values, e);
        return n;
    };
    function ve(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function q(e) {
        var n = e.parent(-1);
        for (var t = 0, i; i = e.parent(t++); n = i) {
            if (i.TYPE == "Call") {
                if (i.expression === n) continue;
            } else if (i instanceof fn) {
                if (i.left === n) continue;
            } else if (i instanceof cn) {
                if (i.condition === n) continue;
            } else if (i instanceof tn) {
                if (i.expression === n) continue;
            } else if (i instanceof nn) {
                if (i.expressions[0] === n) continue;
            } else if (i instanceof me) {
                return i.body === n;
            } else if (i instanceof un) {
                if (i.expression === n) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = _e;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var o = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            o.push("this.", e, "=props.", e, ";");
        });
        var a = i && new i();
        if (a && a.initialize || t && t.initialize) o.push("this.initialize();");
        o.push("}}");
        var s = new Function(o.join(""))();
        if (a) {
            s.prototype = a;
            s.BASE = i;
        }
        if (i) i.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var u in t) if (ve(t, u)) {
            if (/^\$/.test(u)) {
                s[u.substr(1)] = t[u];
            } else {
                s.prototype[u] = t[u];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof h !== "undefined") {
            h["AST_" + e] = s;
        }
        return s;
    }
    var j = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var _e = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new nt(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        _walk: function(e) {
            return e._visit(this);
        },
        walk: function(e) {
            return this._walk(e);
        }
    }, null);
    _e.warn = function(e, n) {
        if (_e.warn_function) _e.warn_function($(e, n));
    };
    var me = i("Statement", null, {
        $documentation: "Base class of all statements"
    });
    var ge = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, me);
    var be = i("Directive", "value quote", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
            quote: "[string] the original quote character"
        }
    }, me);
    var ye = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.body._walk(e);
            });
        }
    }, me);
    function H(e, n) {
        var t = e.body;
        if (t instanceof me) {
            t._walk(n);
        } else t.forEach(function(e) {
            e._walk(n);
        });
    }
    var we = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                H(this, e);
            });
        }
    }, me);
    var xe = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, we);
    var Ae = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, me);
    var g = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        }
    }, me);
    var Ee = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.label._walk(e);
                this.body._walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new zn(function(e) {
                    if (e instanceof Re && e.label && e.label.thedef === i) {
                        e.label.thedef = t;
                        t.references.push(e);
                    }
                }));
            }
            return n;
        }
    }, g);
    var ke = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it."
    }, g);
    var De = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        }
    }, ke);
    var Fe = i("Do", null, {
        $documentation: "A `do` statement",
        _walk: function(e) {
            return e._visit(this, function() {
                this.body._walk(e);
                this.condition._walk(e);
            });
        }
    }, De);
    var Ce = i("While", null, {
        $documentation: "A `while` statement",
        _walk: function(e) {
            return e._visit(this, function() {
                this.condition._walk(e);
                this.body._walk(e);
            });
        }
    }, De);
    var Be = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                if (this.init) this.init._walk(e);
                if (this.condition) this.condition._walk(e);
                if (this.step) this.step._walk(e);
                this.body._walk(e);
            });
        }
    }, ke);
    var Se = i("ForIn", "init object", {
        $documentation: "A `for ... in` statement",
        $propdoc: {
            init: "[AST_Node] the `for/in` initialization code",
            object: "[AST_Node] the object that we're looping through"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.init._walk(e);
                this.object._walk(e);
                this.body._walk(e);
            });
        }
    }, ke);
    var Te = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                this.body._walk(e);
            });
        }
    }, g);
    var Oe = i("Scope", "variables functions uses_with uses_eval parent_scope enclosed cname", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            variables: "[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement",
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            cname: "[integer/S] current index for mangling variables (used internally by the mangler)"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.variables) n.variables = this.variables.clone();
            if (this.functions) n.functions = this.functions.clone();
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            return n;
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        }
    }, we);
    var $e = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name -> SymbolDef for all undeclared names"
        },
        wrap_commonjs: function(e) {
            var n = this.body;
            var t = "(function(exports){'$ORIG';})(typeof " + e + "=='undefined'?(" + e + "={}):" + e + ");";
            t = et(t);
            t = t.transform(new nt(function(e) {
                if (e instanceof be && e.value == "$ORIG") {
                    return pe.splice(n);
                }
            }));
            return t;
        },
        wrap_enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return et([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join("")).transform(new nt(function(e) {
                if (e instanceof be && e.value == "$ORIG") {
                    return pe.splice(t);
                }
            }));
        }
    }, Oe);
    var ze = i("Lambda", "name argnames uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            name: "[AST_SymbolDeclaration?] the name of this function",
            argnames: "[AST_SymbolFunarg*] array of function arguments",
            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                if (this.name) this.name._walk(n);
                this.argnames.forEach(function(e) {
                    e._walk(n);
                });
                H(this, n);
            });
        }
    }, Oe);
    var Me = i("Accessor", null, {
        $documentation: "A setter/getter function.  The `name` property is always null."
    }, ze);
    var qe = i("Function", "inlined", {
        $documentation: "A function expression"
    }, ze);
    var je = i("Defun", "inlined", {
        $documentation: "A function definition"
    }, ze);
    var N = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
    }, me);
    var He = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        _walk: function(e) {
            return e._visit(this, this.value && function() {
                this.value._walk(e);
            });
        }
    }, N);
    var Ne = i("Return", null, {
        $documentation: "A `return` statement"
    }, He);
    var ie = i("Throw", null, {
        $documentation: "A `throw` statement"
    }, He);
    var Re = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        _walk: function(e) {
            return e._visit(this, this.label && function() {
                this.label._walk(e);
            });
        }
    }, N);
    var Ie = i("Break", null, {
        $documentation: "A `break` statement"
    }, Re);
    var Ue = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, Re);
    var Pe = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.condition._walk(e);
                this.body._walk(e);
                if (this.alternative) this.alternative._walk(e);
            });
        }
    }, g);
    var Ve = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                H(this, e);
            });
        }
    }, we);
    var R = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches"
    }, we);
    var Le = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, R);
    var Ye = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                H(this, e);
            });
        }
    }, R);
    var We = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                H(this, e);
                if (this.bcatch) this.bcatch._walk(e);
                if (this.bfinally) this.bfinally._walk(e);
            });
        }
    }, we);
    var Ge = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[AST_SymbolCatch] symbol for the exception"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.argname._walk(e);
                H(this, e);
            });
        }
    }, we);
    var Je = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, we);
    var Xe = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.definitions.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    }, me);
    var Ze = i("Var", null, {
        $documentation: "A `var` statement"
    }, Xe);
    var Ke = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.name._walk(e);
                if (this.value) this.value._walk(e);
            });
        }
    });
    var Qe = i("Call", "expression args", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.expression._walk(n);
                this.args.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var en = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, Qe);
    var nn = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.expressions.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var tn = i("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        }
    });
    var rn = i("Dot", null, {
        $documentation: "A dotted property access expression",
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
            });
        }
    }, tn);
    var on = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
                this.property._walk(e);
            });
        }
    }, tn);
    var an = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.expression._walk(e);
            });
        }
    });
    var sn = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, an);
    var un = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, an);
    var fn = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.left._walk(e);
                this.right._walk(e);
            });
        }
    });
    var cn = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.condition._walk(e);
                this.consequent._walk(e);
                this.alternative._walk(e);
            });
        }
    });
    var ln = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`"
    }, fn);
    var pn = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.elements.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var dn = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[AST_ObjectProperty*] array of properties"
        },
        _walk: function(n) {
            return n._visit(this, function() {
                this.properties.forEach(function(e) {
                    e._walk(n);
                });
            });
        }
    });
    var I = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_SymbolAccessor] property name. For ObjectKeyVal this is a string. For getters and setters this is an AST_SymbolAccessor.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        _walk: function(e) {
            return e._visit(this, function() {
                this.value._walk(e);
            });
        }
    });
    var hn = i("ObjectKeyVal", "quote", {
        $documentation: "A key: value object property",
        $propdoc: {
            quote: "[string] the original quote character"
        }
    }, I);
    var re = i("ObjectSetter", null, {
        $documentation: "An object setter property"
    }, I);
    var oe = i("ObjectGetter", null, {
        $documentation: "An object getter property"
    }, I);
    var U = i("Symbol", "scope name thedef", {
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        $documentation: "Base class for all symbols"
    });
    var ae = i("SymbolAccessor", null, {
        $documentation: "The name of a property accessor (setter/getter function)"
    }, U);
    var vn = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, U);
    var _n = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, vn);
    var mn = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, _n);
    var gn = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, vn);
    var bn = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, vn);
    var yn = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, vn);
    var se = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, U);
    var wn = i("SymbolRef", null, {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, U);
    var ue = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, U);
    var xn = i("This", null, {
        $documentation: "The `this` symbol"
    }, U);
    var P = i("Constant", null, {
        $documentation: "Base class for all constants",
        getValue: function() {
            return this.value;
        }
    });
    var An = i("String", "value quote", {
        $documentation: "A string literal",
        $propdoc: {
            value: "[string] the contents of this string",
            quote: "[string] the original quote character"
        }
    }, P);
    var En = i("Number", "value literal", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value",
            literal: "[string] numeric value as string (optional)"
        }
    }, P);
    var kn = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        }
    }, P);
    var a = i("Atom", null, {
        $documentation: "Base class for atoms"
    }, P);
    var Dn = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, a);
    var Fn = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, a);
    var Cn = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, a);
    var Bn = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, a);
    var Sn = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, a);
    var Tn = i("Boolean", null, {
        $documentation: "Base class for booleans"
    }, a);
    var On = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Tn);
    var $n = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Tn);
    function zn(e) {
        this.visit = e;
        this.stack = [];
        this.directives = Object.create(null);
    }
    zn.prototype = {
        _visit: function(e, n) {
            this.push(e);
            var t = this.visit(e, n ? function() {
                n.call(e);
            } : Q);
            if (!t && n) {
                n.call(e);
            }
            this.pop();
            return t;
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof ze) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof be && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            if (this.stack.pop() instanceof ze) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof Oe) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof be)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Ee && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof ke || e instanceof Ie && i instanceof Ve) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof ye || t instanceof cn && t.condition === e || t instanceof De && t.condition === e || t instanceof Be && t.condition === e || t instanceof Pe && t.condition === e || t instanceof sn && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof fn && (t.operator == "&&" || t.operator == "||") || t instanceof cn || t.tail_node() === e) {
                    e = t;
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var fe = "break case catch const continue debugger default delete do else finally for function if in instanceof new return switch throw try typeof var void while with";
    var V = "false null true";
    var b = "abstract boolean byte char class double enum export extends final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield" + " " + V + " " + fe;
    var L = "return new delete throw else case";
    fe = de(fe);
    b = de(b);
    L = de(L);
    V = de(V);
    var Y = de(e("+-*&%=<>!?|~^"));
    var r = /^0x[0-9a-f]+$/i;
    var W = /^0[0-7]+$/;
    var G = de([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=", "&&", "||" ]);
    var J = de(e("  \n\r\t\f\v​           \u2028\u2029  　\ufeff"));
    var X = de(e("\n\r\u2028\u2029"));
    var Z = de(e("[{(,;:"));
    var Mn = de(e("[]{}(),;:"));
    var s = {
        letter: new RegExp("[\\u0041-\\u005A\\u0061-\\u007A\\u00AA\\u00B5\\u00BA\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02C1\\u02C6-\\u02D1\\u02E0-\\u02E4\\u02EC\\u02EE\\u0370-\\u0374\\u0376\\u0377\\u037A-\\u037D\\u037F\\u0386\\u0388-\\u038A\\u038C\\u038E-\\u03A1\\u03A3-\\u03F5\\u03F7-\\u0481\\u048A-\\u052F\\u0531-\\u0556\\u0559\\u0561-\\u0587\\u05D0-\\u05EA\\u05F0-\\u05F2\\u0620-\\u064A\\u066E\\u066F\\u0671-\\u06D3\\u06D5\\u06E5\\u06E6\\u06EE\\u06EF\\u06FA-\\u06FC\\u06FF\\u0710\\u0712-\\u072F\\u074D-\\u07A5\\u07B1\\u07CA-\\u07EA\\u07F4\\u07F5\\u07FA\\u0800-\\u0815\\u081A\\u0824\\u0828\\u0840-\\u0858\\u08A0-\\u08B2\\u0904-\\u0939\\u093D\\u0950\\u0958-\\u0961\\u0971-\\u0980\\u0985-\\u098C\\u098F\\u0990\\u0993-\\u09A8\\u09AA-\\u09B0\\u09B2\\u09B6-\\u09B9\\u09BD\\u09CE\\u09DC\\u09DD\\u09DF-\\u09E1\\u09F0\\u09F1\\u0A05-\\u0A0A\\u0A0F\\u0A10\\u0A13-\\u0A28\\u0A2A-\\u0A30\\u0A32\\u0A33\\u0A35\\u0A36\\u0A38\\u0A39\\u0A59-\\u0A5C\\u0A5E\\u0A72-\\u0A74\\u0A85-\\u0A8D\\u0A8F-\\u0A91\\u0A93-\\u0AA8\\u0AAA-\\u0AB0\\u0AB2\\u0AB3\\u0AB5-\\u0AB9\\u0ABD\\u0AD0\\u0AE0\\u0AE1\\u0B05-\\u0B0C\\u0B0F\\u0B10\\u0B13-\\u0B28\\u0B2A-\\u0B30\\u0B32\\u0B33\\u0B35-\\u0B39\\u0B3D\\u0B5C\\u0B5D\\u0B5F-\\u0B61\\u0B71\\u0B83\\u0B85-\\u0B8A\\u0B8E-\\u0B90\\u0B92-\\u0B95\\u0B99\\u0B9A\\u0B9C\\u0B9E\\u0B9F\\u0BA3\\u0BA4\\u0BA8-\\u0BAA\\u0BAE-\\u0BB9\\u0BD0\\u0C05-\\u0C0C\\u0C0E-\\u0C10\\u0C12-\\u0C28\\u0C2A-\\u0C39\\u0C3D\\u0C58\\u0C59\\u0C60\\u0C61\\u0C85-\\u0C8C\\u0C8E-\\u0C90\\u0C92-\\u0CA8\\u0CAA-\\u0CB3\\u0CB5-\\u0CB9\\u0CBD\\u0CDE\\u0CE0\\u0CE1\\u0CF1\\u0CF2\\u0D05-\\u0D0C\\u0D0E-\\u0D10\\u0D12-\\u0D3A\\u0D3D\\u0D4E\\u0D60\\u0D61\\u0D7A-\\u0D7F\\u0D85-\\u0D96\\u0D9A-\\u0DB1\\u0DB3-\\u0DBB\\u0DBD\\u0DC0-\\u0DC6\\u0E01-\\u0E30\\u0E32\\u0E33\\u0E40-\\u0E46\\u0E81\\u0E82\\u0E84\\u0E87\\u0E88\\u0E8A\\u0E8D\\u0E94-\\u0E97\\u0E99-\\u0E9F\\u0EA1-\\u0EA3\\u0EA5\\u0EA7\\u0EAA\\u0EAB\\u0EAD-\\u0EB0\\u0EB2\\u0EB3\\u0EBD\\u0EC0-\\u0EC4\\u0EC6\\u0EDC-\\u0EDF\\u0F00\\u0F40-\\u0F47\\u0F49-\\u0F6C\\u0F88-\\u0F8C\\u1000-\\u102A\\u103F\\u1050-\\u1055\\u105A-\\u105D\\u1061\\u1065\\u1066\\u106E-\\u1070\\u1075-\\u1081\\u108E\\u10A0-\\u10C5\\u10C7\\u10CD\\u10D0-\\u10FA\\u10FC-\\u1248\\u124A-\\u124D\\u1250-\\u1256\\u1258\\u125A-\\u125D\\u1260-\\u1288\\u128A-\\u128D\\u1290-\\u12B0\\u12B2-\\u12B5\\u12B8-\\u12BE\\u12C0\\u12C2-\\u12C5\\u12C8-\\u12D6\\u12D8-\\u1310\\u1312-\\u1315\\u1318-\\u135A\\u1380-\\u138F\\u13A0-\\u13F4\\u1401-\\u166C\\u166F-\\u167F\\u1681-\\u169A\\u16A0-\\u16EA\\u16EE-\\u16F8\\u1700-\\u170C\\u170E-\\u1711\\u1720-\\u1731\\u1740-\\u1751\\u1760-\\u176C\\u176E-\\u1770\\u1780-\\u17B3\\u17D7\\u17DC\\u1820-\\u1877\\u1880-\\u18A8\\u18AA\\u18B0-\\u18F5\\u1900-\\u191E\\u1950-\\u196D\\u1970-\\u1974\\u1980-\\u19AB\\u19C1-\\u19C7\\u1A00-\\u1A16\\u1A20-\\u1A54\\u1AA7\\u1B05-\\u1B33\\u1B45-\\u1B4B\\u1B83-\\u1BA0\\u1BAE\\u1BAF\\u1BBA-\\u1BE5\\u1C00-\\u1C23\\u1C4D-\\u1C4F\\u1C5A-\\u1C7D\\u1CE9-\\u1CEC\\u1CEE-\\u1CF1\\u1CF5\\u1CF6\\u1D00-\\u1DBF\\u1E00-\\u1F15\\u1F18-\\u1F1D\\u1F20-\\u1F45\\u1F48-\\u1F4D\\u1F50-\\u1F57\\u1F59\\u1F5B\\u1F5D\\u1F5F-\\u1F7D\\u1F80-\\u1FB4\\u1FB6-\\u1FBC\\u1FBE\\u1FC2-\\u1FC4\\u1FC6-\\u1FCC\\u1FD0-\\u1FD3\\u1FD6-\\u1FDB\\u1FE0-\\u1FEC\\u1FF2-\\u1FF4\\u1FF6-\\u1FFC\\u2071\\u207F\\u2090-\\u209C\\u2102\\u2107\\u210A-\\u2113\\u2115\\u2119-\\u211D\\u2124\\u2126\\u2128\\u212A-\\u212D\\u212F-\\u2139\\u213C-\\u213F\\u2145-\\u2149\\u214E\\u2160-\\u2188\\u2C00-\\u2C2E\\u2C30-\\u2C5E\\u2C60-\\u2CE4\\u2CEB-\\u2CEE\\u2CF2\\u2CF3\\u2D00-\\u2D25\\u2D27\\u2D2D\\u2D30-\\u2D67\\u2D6F\\u2D80-\\u2D96\\u2DA0-\\u2DA6\\u2DA8-\\u2DAE\\u2DB0-\\u2DB6\\u2DB8-\\u2DBE\\u2DC0-\\u2DC6\\u2DC8-\\u2DCE\\u2DD0-\\u2DD6\\u2DD8-\\u2DDE\\u2E2F\\u3005-\\u3007\\u3021-\\u3029\\u3031-\\u3035\\u3038-\\u303C\\u3041-\\u3096\\u309D-\\u309F\\u30A1-\\u30FA\\u30FC-\\u30FF\\u3105-\\u312D\\u3131-\\u318E\\u31A0-\\u31BA\\u31F0-\\u31FF\\u3400-\\u4DB5\\u4E00-\\u9FCC\\uA000-\\uA48C\\uA4D0-\\uA4FD\\uA500-\\uA60C\\uA610-\\uA61F\\uA62A\\uA62B\\uA640-\\uA66E\\uA67F-\\uA69D\\uA6A0-\\uA6EF\\uA717-\\uA71F\\uA722-\\uA788\\uA78B-\\uA78E\\uA790-\\uA7AD\\uA7B0\\uA7B1\\uA7F7-\\uA801\\uA803-\\uA805\\uA807-\\uA80A\\uA80C-\\uA822\\uA840-\\uA873\\uA882-\\uA8B3\\uA8F2-\\uA8F7\\uA8FB\\uA90A-\\uA925\\uA930-\\uA946\\uA960-\\uA97C\\uA984-\\uA9B2\\uA9CF\\uA9E0-\\uA9E4\\uA9E6-\\uA9EF\\uA9FA-\\uA9FE\\uAA00-\\uAA28\\uAA40-\\uAA42\\uAA44-\\uAA4B\\uAA60-\\uAA76\\uAA7A\\uAA7E-\\uAAAF\\uAAB1\\uAAB5\\uAAB6\\uAAB9-\\uAABD\\uAAC0\\uAAC2\\uAADB-\\uAADD\\uAAE0-\\uAAEA\\uAAF2-\\uAAF4\\uAB01-\\uAB06\\uAB09-\\uAB0E\\uAB11-\\uAB16\\uAB20-\\uAB26\\uAB28-\\uAB2E\\uAB30-\\uAB5A\\uAB5C-\\uAB5F\\uAB64\\uAB65\\uABC0-\\uABE2\\uAC00-\\uD7A3\\uD7B0-\\uD7C6\\uD7CB-\\uD7FB\\uF900-\\uFA6D\\uFA70-\\uFAD9\\uFB00-\\uFB06\\uFB13-\\uFB17\\uFB1D\\uFB1F-\\uFB28\\uFB2A-\\uFB36\\uFB38-\\uFB3C\\uFB3E\\uFB40\\uFB41\\uFB43\\uFB44\\uFB46-\\uFBB1\\uFBD3-\\uFD3D\\uFD50-\\uFD8F\\uFD92-\\uFDC7\\uFDF0-\\uFDFB\\uFE70-\\uFE74\\uFE76-\\uFEFC\\uFF21-\\uFF3A\\uFF41-\\uFF5A\\uFF66-\\uFFBE\\uFFC2-\\uFFC7\\uFFCA-\\uFFCF\\uFFD2-\\uFFD7\\uFFDA-\\uFFDC]"),
        digit: new RegExp("[\\u0030-\\u0039\\u0660-\\u0669\\u06F0-\\u06F9\\u07C0-\\u07C9\\u0966-\\u096F\\u09E6-\\u09EF\\u0A66-\\u0A6F\\u0AE6-\\u0AEF\\u0B66-\\u0B6F\\u0BE6-\\u0BEF\\u0C66-\\u0C6F\\u0CE6-\\u0CEF\\u0D66-\\u0D6F\\u0DE6-\\u0DEF\\u0E50-\\u0E59\\u0ED0-\\u0ED9\\u0F20-\\u0F29\\u1040-\\u1049\\u1090-\\u1099\\u17E0-\\u17E9\\u1810-\\u1819\\u1946-\\u194F\\u19D0-\\u19D9\\u1A80-\\u1A89\\u1A90-\\u1A99\\u1B50-\\u1B59\\u1BB0-\\u1BB9\\u1C40-\\u1C49\\u1C50-\\u1C59\\uA620-\\uA629\\uA8D0-\\uA8D9\\uA900-\\uA909\\uA9D0-\\uA9D9\\uA9F0-\\uA9F9\\uAA50-\\uAA59\\uABF0-\\uABF9\\uFF10-\\uFF19]"),
        non_spacing_mark: new RegExp("[\\u0300-\\u036F\\u0483-\\u0487\\u0591-\\u05BD\\u05BF\\u05C1\\u05C2\\u05C4\\u05C5\\u05C7\\u0610-\\u061A\\u064B-\\u065E\\u0670\\u06D6-\\u06DC\\u06DF-\\u06E4\\u06E7\\u06E8\\u06EA-\\u06ED\\u0711\\u0730-\\u074A\\u07A6-\\u07B0\\u07EB-\\u07F3\\u0816-\\u0819\\u081B-\\u0823\\u0825-\\u0827\\u0829-\\u082D\\u0900-\\u0902\\u093C\\u0941-\\u0948\\u094D\\u0951-\\u0955\\u0962\\u0963\\u0981\\u09BC\\u09C1-\\u09C4\\u09CD\\u09E2\\u09E3\\u0A01\\u0A02\\u0A3C\\u0A41\\u0A42\\u0A47\\u0A48\\u0A4B-\\u0A4D\\u0A51\\u0A70\\u0A71\\u0A75\\u0A81\\u0A82\\u0ABC\\u0AC1-\\u0AC5\\u0AC7\\u0AC8\\u0ACD\\u0AE2\\u0AE3\\u0B01\\u0B3C\\u0B3F\\u0B41-\\u0B44\\u0B4D\\u0B56\\u0B62\\u0B63\\u0B82\\u0BC0\\u0BCD\\u0C3E-\\u0C40\\u0C46-\\u0C48\\u0C4A-\\u0C4D\\u0C55\\u0C56\\u0C62\\u0C63\\u0CBC\\u0CBF\\u0CC6\\u0CCC\\u0CCD\\u0CE2\\u0CE3\\u0D41-\\u0D44\\u0D4D\\u0D62\\u0D63\\u0DCA\\u0DD2-\\u0DD4\\u0DD6\\u0E31\\u0E34-\\u0E3A\\u0E47-\\u0E4E\\u0EB1\\u0EB4-\\u0EB9\\u0EBB\\u0EBC\\u0EC8-\\u0ECD\\u0F18\\u0F19\\u0F35\\u0F37\\u0F39\\u0F71-\\u0F7E\\u0F80-\\u0F84\\u0F86\\u0F87\\u0F90-\\u0F97\\u0F99-\\u0FBC\\u0FC6\\u102D-\\u1030\\u1032-\\u1037\\u1039\\u103A\\u103D\\u103E\\u1058\\u1059\\u105E-\\u1060\\u1071-\\u1074\\u1082\\u1085\\u1086\\u108D\\u109D\\u135F\\u1712-\\u1714\\u1732-\\u1734\\u1752\\u1753\\u1772\\u1773\\u17B7-\\u17BD\\u17C6\\u17C9-\\u17D3\\u17DD\\u180B-\\u180D\\u18A9\\u1920-\\u1922\\u1927\\u1928\\u1932\\u1939-\\u193B\\u1A17\\u1A18\\u1A56\\u1A58-\\u1A5E\\u1A60\\u1A62\\u1A65-\\u1A6C\\u1A73-\\u1A7C\\u1A7F\\u1B00-\\u1B03\\u1B34\\u1B36-\\u1B3A\\u1B3C\\u1B42\\u1B6B-\\u1B73\\u1B80\\u1B81\\u1BA2-\\u1BA5\\u1BA8\\u1BA9\\u1C2C-\\u1C33\\u1C36\\u1C37\\u1CD0-\\u1CD2\\u1CD4-\\u1CE0\\u1CE2-\\u1CE8\\u1CED\\u1DC0-\\u1DE6\\u1DFD-\\u1DFF\\u20D0-\\u20DC\\u20E1\\u20E5-\\u20F0\\u2CEF-\\u2CF1\\u2DE0-\\u2DFF\\u302A-\\u302F\\u3099\\u309A\\uA66F\\uA67C\\uA67D\\uA6F0\\uA6F1\\uA802\\uA806\\uA80B\\uA825\\uA826\\uA8C4\\uA8E0-\\uA8F1\\uA926-\\uA92D\\uA947-\\uA951\\uA980-\\uA982\\uA9B3\\uA9B6-\\uA9B9\\uA9BC\\uAA29-\\uAA2E\\uAA31\\uAA32\\uAA35\\uAA36\\uAA43\\uAA4C\\uAAB0\\uAAB2-\\uAAB4\\uAAB7\\uAAB8\\uAABE\\uAABF\\uAAC1\\uABE5\\uABE8\\uABED\\uFB1E\\uFE00-\\uFE0F\\uFE20-\\uFE26]"),
        space_combining_mark: new RegExp("[\\u0903\\u093E-\\u0940\\u0949-\\u094C\\u094E\\u0982\\u0983\\u09BE-\\u09C0\\u09C7\\u09C8\\u09CB\\u09CC\\u09D7\\u0A03\\u0A3E-\\u0A40\\u0A83\\u0ABE-\\u0AC0\\u0AC9\\u0ACB\\u0ACC\\u0B02\\u0B03\\u0B3E\\u0B40\\u0B47\\u0B48\\u0B4B\\u0B4C\\u0B57\\u0BBE\\u0BBF\\u0BC1\\u0BC2\\u0BC6-\\u0BC8\\u0BCA-\\u0BCC\\u0BD7\\u0C01-\\u0C03\\u0C41-\\u0C44\\u0C82\\u0C83\\u0CBE\\u0CC0-\\u0CC4\\u0CC7\\u0CC8\\u0CCA\\u0CCB\\u0CD5\\u0CD6\\u0D02\\u0D03\\u0D3E-\\u0D40\\u0D46-\\u0D48\\u0D4A-\\u0D4C\\u0D57\\u0D82\\u0D83\\u0DCF-\\u0DD1\\u0DD8-\\u0DDF\\u0DF2\\u0DF3\\u0F3E\\u0F3F\\u0F7F\\u102B\\u102C\\u1031\\u1038\\u103B\\u103C\\u1056\\u1057\\u1062-\\u1064\\u1067-\\u106D\\u1083\\u1084\\u1087-\\u108C\\u108F\\u109A-\\u109C\\u17B6\\u17BE-\\u17C5\\u17C7\\u17C8\\u1923-\\u1926\\u1929-\\u192B\\u1930\\u1931\\u1933-\\u1938\\u19B0-\\u19C0\\u19C8\\u19C9\\u1A19-\\u1A1B\\u1A55\\u1A57\\u1A61\\u1A63\\u1A64\\u1A6D-\\u1A72\\u1B04\\u1B35\\u1B3B\\u1B3D-\\u1B41\\u1B43\\u1B44\\u1B82\\u1BA1\\u1BA6\\u1BA7\\u1BAA\\u1C24-\\u1C2B\\u1C34\\u1C35\\u1CE1\\u1CF2\\uA823\\uA824\\uA827\\uA880\\uA881\\uA8B4-\\uA8C3\\uA952\\uA953\\uA983\\uA9B4\\uA9B5\\uA9BA\\uA9BB\\uA9BD-\\uA9C0\\uAA2F\\uAA30\\uAA33\\uAA34\\uAA4D\\uAA7B\\uABE3\\uABE4\\uABE6\\uABE7\\uABE9\\uABEA\\uABEC]"),
        connector_punctuation: new RegExp("[\\u005F\\u203F\\u2040\\u2054\\uFE33\\uFE34\\uFE4D-\\uFE4F\\uFF3F]")
    };
    function u(e) {
        return e >= 97 && e <= 122 || e >= 65 && e <= 90 || e >= 170 && s.letter.test(String.fromCharCode(e));
    }
    function qn(e) {
        if (typeof e == "string") e = e.charCodeAt(0);
        return e >= 55296 && e <= 56319;
    }
    function jn(e) {
        if (typeof e == "string") e = e.charCodeAt(0);
        return e >= 56320 && e <= 57343;
    }
    function Hn(e) {
        return e >= 48 && e <= 57;
    }
    function Nn(e) {
        return Hn(e) || u(e);
    }
    function f(e) {
        return s.digit.test(String.fromCharCode(e));
    }
    function c(e) {
        return s.non_spacing_mark.test(e) || s.space_combining_mark.test(e);
    }
    function l(e) {
        return s.connector_punctuation.test(e);
    }
    function p(e) {
        return !b[e] && /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Rn(e) {
        return e == 36 || e == 95 || u(e);
    }
    function In(e) {
        var n = e.charCodeAt(0);
        return Rn(n) || Hn(n) || n == 8204 || n == 8205 || c(e) || l(e) || f(n);
    }
    function Un(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Pn(e) {
        if (r.test(e)) {
            return parseInt(e.substr(2), 16);
        } else if (W.test(e)) {
            return parseInt(e.substr(1), 8);
        } else {
            var n = parseFloat(e);
            if (n == e) return n;
        }
    }
    function Vn(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    Vn.prototype = Object.create(Error.prototype);
    Vn.prototype.constructor = Vn;
    Vn.prototype.name = "SyntaxError";
    n(Vn);
    function Ln(e, n, t, i, r) {
        throw new Vn(e, n, t, i, r);
    }
    function Yn(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var Wn = {};
    function Gn(r, o, a, s) {
        var u = {
            text: r,
            filename: o,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: []
        };
        function f() {
            return u.text.charAt(u.pos);
        }
        function c(e, n) {
            var t = u.text.charAt(u.pos++);
            if (e && !t) throw Wn;
            if (X[t]) {
                u.newline_before = u.newline_before || !n;
                ++u.line;
                u.col = 0;
                if (!n && t == "\r" && f() == "\n") {
                    ++u.pos;
                    t = "\n";
                }
            } else {
                ++u.col;
            }
            return t;
        }
        function l(e) {
            while (e-- > 0) c();
        }
        function p(e) {
            return u.text.substr(u.pos, e.length) == e;
        }
        function d() {
            var e = u.text;
            for (var n = u.pos, t = u.text.length; n < t; ++n) {
                var i = e[n];
                if (X[i]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = u.text.indexOf(e, u.pos);
            if (n && t == -1) throw Wn;
            return t;
        }
        function h() {
            u.tokline = u.line;
            u.tokcol = u.col;
            u.tokpos = u.pos;
        }
        var v = false;
        function _(e, n, t) {
            u.regex_allowed = e == "operator" && !Xn[n] || e == "keyword" && L[n] || e == "punc" && Z[n];
            if (e == "punc" && n == ".") {
                v = true;
            } else if (!t) {
                v = false;
            }
            var i = {
                type: e,
                value: n,
                line: u.tokline,
                col: u.tokcol,
                pos: u.tokpos,
                endline: u.line,
                endcol: u.col,
                endpos: u.pos,
                nlb: u.newline_before,
                file: o
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = u.comments_before;
                i.comments_after = u.comments_before = [];
            }
            u.newline_before = false;
            return new j(i);
        }
        function m() {
            while (J[f()]) c();
        }
        function t(e) {
            var n = "", t, i = 0;
            while ((t = f()) && e(t, i++)) n += c();
            return n;
        }
        function g(e) {
            Ln(e, o, u.tokline, u.tokcol, u.tokpos);
        }
        function b(i) {
            var r = false, o = false, a = false, s = i == ".";
            var e = t(function(e, n) {
                var t = e.charCodeAt(0);
                switch (t) {
                  case 120:
                  case 88:
                    return a ? false : a = true;

                  case 101:
                  case 69:
                    return a ? true : r ? false : r = o = true;

                  case 45:
                    return o || n == 0 && !i;

                  case 43:
                    return o;

                  case o = false, 46:
                    return !s && !a && !r ? s = true : false;
                }
                return Nn(t);
            });
            if (i) e = i + e;
            if (W.test(e) && T.has_directive("use strict")) {
                g("Legacy octal literals are not allowed in strict mode");
            }
            var n = Pn(e);
            if (!isNaN(n)) {
                return _("num", n);
            } else {
                g("Invalid syntax: " + e);
            }
        }
        function y(e) {
            var n = c(true, e);
            switch (n.charCodeAt(0)) {
              case 110:
                return "\n";

              case 114:
                return "\r";

              case 116:
                return "\t";

              case 98:
                return "\b";

              case 118:
                return "\v";

              case 102:
                return "\f";

              case 120:
                return String.fromCharCode(x(2));

              case 117:
                return String.fromCharCode(x(4));

              case 10:
                return "";

              case 13:
                if (f() == "\n") {
                    c(true, e);
                    return "";
                }
            }
            if (n >= "0" && n <= "7") return w(n);
            return n;
        }
        function w(e) {
            var n = f();
            if (n >= "0" && n <= "7") {
                e += c(true);
                if (e[0] <= "3" && (n = f()) >= "0" && n <= "7") e += c(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && T.has_directive("use strict")) g("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        function x(e) {
            var n = 0;
            for (;e > 0; --e) {
                var t = parseInt(c(true), 16);
                if (isNaN(t)) g("Invalid hex-character pattern in string");
                n = n << 4 | t;
            }
            return n;
        }
        var A = n("Unterminated string constant", function(e) {
            var n = c(), t = "";
            for (;;) {
                var i = c(true, true);
                if (i == "\\") i = y(true); else if (X[i]) g("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = _("string", t);
            r.quote = e;
            return r;
        });
        function E(e) {
            var n = u.regex_allowed;
            var t = d(), i;
            if (t == -1) {
                i = u.text.substr(u.pos);
                u.pos = u.text.length;
            } else {
                i = u.text.substring(u.pos, t);
                u.pos = t;
            }
            u.col = u.tokcol + (u.pos - u.tokpos);
            u.comments_before.push(_(e, i, true));
            u.regex_allowed = n;
            return T;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = u.regex_allowed;
            var n = i("*/", true);
            var t = u.text.substring(u.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            l(t.length + 2);
            u.comments_before.push(_("comment2", t, true));
            u.regex_allowed = e;
            return T;
        });
        function k() {
            var e = false, n = "", t, i = false, r;
            while ((t = f()) != null) {
                if (!e) {
                    if (t == "\\") i = e = true, c(); else if (In(t)) n += c(); else break;
                } else {
                    if (t != "u") g("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = y();
                    if (!In(t)) g("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (fe[n] && i) {
                r = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(r.length) + r + n.slice(1);
            }
            return n;
        }
        var D = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = c(true)) if (X[t]) {
                g("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = k();
            try {
                var o = new RegExp(e, r);
                o.raw_source = e;
                return _("regexp", o);
            } catch (e) {
                g(e.message);
            }
        });
        function F(e) {
            function t(e) {
                if (!f()) return e;
                var n = e + f();
                if (G[n]) {
                    c();
                    return t(n);
                } else {
                    return e;
                }
            }
            return _("operator", t(e || c()));
        }
        function C() {
            c();
            switch (f()) {
              case "/":
                c();
                return E("comment1");

              case "*":
                c();
                return e();
            }
            return u.regex_allowed ? D("") : F("/");
        }
        function B() {
            c();
            return Hn(f().charCodeAt(0)) ? b(".") : _("punc", ".");
        }
        function S() {
            var e = k();
            if (v) return _("name", e);
            return V[e] ? _("atom", e) : !fe[e] ? _("name", e) : G[e] ? _("operator", e) : _("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === Wn) g(n); else throw e;
                }
            };
        }
        function T(e) {
            if (e != null) return D(e);
            if (s && u.pos == 0 && p("#!")) {
                h();
                l(2);
                E("comment5");
            }
            for (;;) {
                m();
                h();
                if (a) {
                    if (p("\x3c!--")) {
                        l(4);
                        E("comment3");
                        continue;
                    }
                    if (p("--\x3e") && u.newline_before) {
                        l(3);
                        E("comment4");
                        continue;
                    }
                }
                var n = f();
                if (!n) return _("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return A(n);

                  case 46:
                    return B();

                  case 47:
                    {
                        var i = C();
                        if (i === T) continue;
                        return i;
                    }
                }
                if (Hn(t)) return b();
                if (Mn[n]) return _("punc", c());
                if (Y[n]) return F();
                if (t == 92 || Rn(t)) return S();
                break;
            }
            g("Unexpected character '" + n + "'");
        }
        T.context = function(e) {
            if (e) u = e;
            return u;
        };
        T.add_directive = function(e) {
            u.directive_stack[u.directive_stack.length - 1].push(e);
            if (u.directives[e] === undefined) {
                u.directives[e] = 1;
            } else {
                u.directives[e]++;
            }
        };
        T.push_directives_stack = function() {
            u.directive_stack.push([]);
        };
        T.pop_directives_stack = function() {
            var e = u.directive_stack[u.directive_stack.length - 1];
            for (var n = 0; n < e.length; n++) {
                u.directives[e[n]]--;
            }
            u.directive_stack.pop();
        };
        T.has_directive = function(e) {
            return u.directives[e] > 0;
        };
        return T;
    }
    var Jn = de([ "typeof", "void", "delete", "--", "++", "!", "~", "-", "+" ]);
    var Xn = de([ "--", "++" ]);
    var Zn = de([ "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=" ]);
    var Kn = function(e, n) {
        for (var t = 0; t < e.length; ++t) {
            var i = e[t];
            for (var r = 0; r < i.length; ++r) {
                n[i[r]] = t + 1;
            }
        }
        return n;
    }([ [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ] ], {});
    var Qn = de([ "atom", "num", "string", "regexp", "name" ]);
    function et(e, u) {
        u = te(u, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var f = {
            input: typeof e == "string" ? Gn(e, u.filename, u.html5_comments, u.shebang) : e,
            token: null,
            prev: null,
            peeked: null,
            in_function: 0,
            in_directives: true,
            in_loop: 0,
            labels: []
        };
        f.token = p();
        function c(e, n) {
            return Yn(f.token, e, n);
        }
        function l() {
            return f.peeked || (f.peeked = f.input());
        }
        function p() {
            f.prev = f.token;
            if (f.peeked) {
                f.token = f.peeked;
                f.peeked = null;
            } else {
                f.token = f.input();
            }
            f.in_directives = f.in_directives && (f.token.type == "string" || c("punc", ";"));
            return f.token;
        }
        function d() {
            return f.prev;
        }
        function h(e, n, t, i) {
            var r = f.input.context();
            Ln(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function t(e, n) {
            h(n, e.line, e.col);
        }
        function v(e) {
            if (e == null) e = f.token;
            t(e, "Unexpected token: " + e.type + " (" + e.value + ")");
        }
        function _(e, n) {
            if (c(e, n)) {
                return p();
            }
            t(f.token, "Unexpected token " + f.token.type + " «" + f.token.value + "»" + ", expected " + e + " «" + n + "»");
        }
        function m(e) {
            return _("punc", e);
        }
        function g(e) {
            return e.nlb || !he(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function b() {
            return !u.strict && (c("eof") || c("punc", "}") || g(f.token));
        }
        function y(e) {
            if (c("punc", ";")) p(); else if (!e && !b()) v();
        }
        function w() {
            m("(");
            var e = Q(true);
            m(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = f.token;
                var n = i.apply(null, arguments);
                var t = d();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function x() {
            if (c("operator", "/") || c("operator", "/=")) {
                f.peeked = null;
                f.token = f.input(f.token.value.substr(1));
            }
        }
        var A = n(function(e) {
            x();
            switch (f.token.type) {
              case "string":
                if (f.in_directives) {
                    var n = l();
                    if (f.token.raw.indexOf("\\") == -1 && (Yn(n, "punc", ";") || Yn(n, "punc", "}") || g(n) || Yn(n, "eof"))) {
                        f.input.add_directive(f.token.value);
                    } else {
                        f.in_directives = false;
                    }
                }
                var t = f.in_directives, i = k();
                return t ? new be(i.body) : i;

              case "num":
              case "regexp":
              case "operator":
              case "atom":
                return k();

              case "name":
                return Yn(l(), "punc", ":") ? E() : k();

              case "punc":
                switch (f.token.value) {
                  case "{":
                    return new xe({
                        start: f.token,
                        body: S(),
                        end: d()
                    });

                  case "[":
                  case "(":
                    return k();

                  case ";":
                    f.in_directives = false;
                    p();
                    return new Ae();

                  default:
                    v();
                }

              case "keyword":
                switch (f.token.value) {
                  case "break":
                    p();
                    return D(Ie);

                  case "continue":
                    p();
                    return D(Ue);

                  case "debugger":
                    p();
                    y();
                    return new ge();

                  case "do":
                    p();
                    var r = ee(A);
                    _("keyword", "while");
                    var o = w();
                    y(true);
                    return new Fe({
                        body: r,
                        condition: o
                    });

                  case "while":
                    p();
                    return new Ce({
                        condition: w(),
                        body: ee(A)
                    });

                  case "for":
                    p();
                    return F();

                  case "function":
                    if (!e && f.input.has_directive("use strict")) {
                        h("In strict mode code, functions can only be declared at top level or immediately within another function.");
                    }
                    p();
                    return C(je);

                  case "if":
                    p();
                    return B();

                  case "return":
                    if (f.in_function == 0 && !u.bare_returns) h("'return' outside of function");
                    p();
                    var a = null;
                    if (c("punc", ";")) {
                        p();
                    } else if (!b()) {
                        a = Q(true);
                        y();
                    }
                    return new Ne({
                        value: a
                    });

                  case "switch":
                    p();
                    return new Ve({
                        expression: w(),
                        body: ee(T)
                    });

                  case "throw":
                    p();
                    if (g(f.token)) h("Illegal newline after 'throw'");
                    var a = Q(true);
                    y();
                    return new ie({
                        value: a
                    });

                  case "try":
                    p();
                    return O();

                  case "var":
                    p();
                    var s = $();
                    y();
                    return s;

                  case "with":
                    if (f.input.has_directive("use strict")) {
                        h("Strict mode may not include a with statement");
                    }
                    p();
                    return new Te({
                        expression: w(),
                        body: A()
                    });
                }
            }
            v();
        });
        function E() {
            var n = P(se);
            if (!he(f.labels, function(e) {
                return e.name != n.name;
            })) {
                h("Label " + n.name + " defined twice");
            }
            m(":");
            f.labels.push(n);
            var e = A();
            f.labels.pop();
            if (!(e instanceof ke)) {
                n.references.forEach(function(e) {
                    if (e instanceof Ue) {
                        e = e.label.start;
                        h("Continue label `" + n.name + "` refers to non-IterationStatement.", e.line, e.col, e.pos);
                    }
                });
            }
            return new Ee({
                body: e,
                label: n
            });
        }
        function k(e) {
            return new ye({
                body: (e = Q(true), y(), e)
            });
        }
        function D(e) {
            var n = null, t;
            if (!b()) {
                n = P(ue, true);
            }
            if (n != null) {
                t = ne(function(e) {
                    return e.name == n.name;
                }, f.labels);
                if (!t) h("Undefined label " + n.name);
                n.thedef = t;
            } else if (f.in_loop == 0) h(e.TYPE + " not inside a loop or switch");
            y();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function F() {
            m("(");
            var e = null;
            if (!c("punc", ";")) {
                e = c("keyword", "var") ? (p(), $(true)) : Q(true, true);
                if (c("operator", "in")) {
                    if (e instanceof Ze) {
                        if (e.definitions.length > 1) h("Only one variable declaration allowed in for..in loop", e.start.line, e.start.col, e.start.pos);
                    } else if (!Z(e)) {
                        h("Invalid left-hand side in for..in loop", e.start.line, e.start.col, e.start.pos);
                    }
                    p();
                    return r(e);
                }
            }
            return i(e);
        }
        function i(e) {
            m(";");
            var n = c("punc", ";") ? null : Q(true);
            m(";");
            var t = c("punc", ")") ? null : Q(true);
            m(")");
            return new Be({
                init: e,
                condition: n,
                step: t,
                body: ee(A)
            });
        }
        function r(e) {
            var n = Q(true);
            m(")");
            return new Se({
                init: e,
                object: n,
                body: ee(A)
            });
        }
        var C = function(e) {
            var n = e === je;
            var t = c("name") ? P(n ? gn : bn) : null;
            if (n && !t) v();
            if (t && e !== Me && !(t instanceof vn)) v(d());
            m("(");
            var i = [];
            for (var r = true; !c("punc", ")"); ) {
                if (r) r = false; else m(",");
                i.push(P(mn));
            }
            p();
            var o = f.in_loop;
            var a = f.labels;
            ++f.in_function;
            f.in_directives = true;
            f.input.push_directives_stack();
            f.in_loop = 0;
            f.labels = [];
            var s = S(true);
            if (f.input.has_directive("use strict")) {
                if (t) U(t);
                i.forEach(U);
            }
            f.input.pop_directives_stack();
            --f.in_function;
            f.in_loop = o;
            f.labels = a;
            return new e({
                name: t,
                argnames: i,
                body: s
            });
        };
        function B() {
            var e = w(), n = A(), t = null;
            if (c("keyword", "else")) {
                p();
                t = A();
            }
            return new Pe({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function S(e) {
            m("{");
            var n = [];
            while (!c("punc", "}")) {
                if (c("eof")) v();
                n.push(A(e));
            }
            p();
            return n;
        }
        function T() {
            m("{");
            var e = [], n = null, t = null, i;
            while (!c("punc", "}")) {
                if (c("eof")) v();
                if (c("keyword", "case")) {
                    if (t) t.end = d();
                    n = [];
                    t = new Ye({
                        start: (i = f.token, p(), i),
                        expression: Q(true),
                        body: n
                    });
                    e.push(t);
                    m(":");
                } else if (c("keyword", "default")) {
                    if (t) t.end = d();
                    n = [];
                    t = new Le({
                        start: (i = f.token, p(), m(":"), i),
                        body: n
                    });
                    e.push(t);
                } else {
                    if (!n) v();
                    n.push(A());
                }
            }
            if (t) t.end = d();
            p();
            return e;
        }
        function O() {
            var e = S(), n = null, t = null;
            if (c("keyword", "catch")) {
                var i = f.token;
                p();
                m("(");
                var r = P(yn);
                m(")");
                n = new Ge({
                    start: i,
                    argname: r,
                    body: S(),
                    end: d()
                });
            }
            if (c("keyword", "finally")) {
                var i = f.token;
                p();
                t = new Je({
                    start: i,
                    body: S(),
                    end: d()
                });
            }
            if (!n && !t) h("Missing catch/finally blocks");
            return new We({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function o(e) {
            var n = [];
            for (;;) {
                n.push(new Ke({
                    start: f.token,
                    name: P(_n),
                    value: c("operator", "=") ? (p(), Q(false, e)) : null,
                    end: d()
                }));
                if (!c("punc", ",")) break;
                p();
            }
            return n;
        }
        var $ = function(e) {
            return new Ze({
                start: d(),
                definitions: o(e),
                end: d()
            });
        };
        var s = function(e) {
            var n = f.token;
            _("operator", "new");
            var t = a(false), i;
            if (c("punc", "(")) {
                p();
                i = M(")");
            } else {
                i = [];
            }
            var r = new en({
                start: n,
                expression: t,
                args: i,
                end: d()
            });
            V(r);
            return L(r, e);
        };
        function z() {
            var e = f.token, n;
            switch (e.type) {
              case "name":
                n = I(wn);
                break;

              case "num":
                n = new En({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "string":
                n = new An({
                    start: e,
                    end: e,
                    value: e.value,
                    quote: e.quote
                });
                break;

              case "regexp":
                n = new kn({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "atom":
                switch (e.value) {
                  case "false":
                    n = new On({
                        start: e,
                        end: e
                    });
                    break;

                  case "true":
                    n = new $n({
                        start: e,
                        end: e
                    });
                    break;

                  case "null":
                    n = new Dn({
                        start: e,
                        end: e
                    });
                    break;
                }
                break;
            }
            p();
            return n;
        }
        var a = function(e) {
            if (c("operator", "new")) {
                return s(e);
            }
            var n = f.token;
            if (c("punc")) {
                switch (n.value) {
                  case "(":
                    p();
                    var t = Q(true);
                    var i = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = i;
                    if (i == 0 && n.comments_before.length > 0) {
                        var r = n.comments_before[0];
                        if (!r.nlb) {
                            r.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    m(")");
                    var o = d();
                    o.comments_before = t.end.comments_before;
                    [].push.apply(t.end.comments_after, o.comments_after);
                    o.comments_after = t.end.comments_after;
                    t.end = o;
                    if (t instanceof Qe) V(t);
                    return L(t, e);

                  case "[":
                    return L(q(), e);

                  case "{":
                    return L(H(), e);
                }
                v();
            }
            if (c("keyword", "function")) {
                p();
                var a = C(qe);
                a.start = n;
                a.end = d();
                return L(a, e);
            }
            if (Qn[f.token.type]) {
                return L(z(), e);
            }
            v();
        };
        function M(e, n, t) {
            var i = true, r = [];
            while (!c("punc", e)) {
                if (i) i = false; else m(",");
                if (n && c("punc", e)) break;
                if (c("punc", ",") && t) {
                    r.push(new Bn({
                        start: f.token,
                        end: f.token
                    }));
                } else {
                    r.push(Q(false));
                }
            }
            p();
            return r;
        }
        var q = n(function() {
            m("[");
            return new pn({
                elements: M("]", !u.strict, true)
            });
        });
        var j = n(function() {
            return C(Me);
        });
        var H = n(function() {
            m("{");
            var e = true, n = [];
            while (!c("punc", "}")) {
                if (e) e = false; else m(",");
                if (!u.strict && c("punc", "}")) break;
                var t = f.token;
                var i = t.type;
                var r = N();
                if (i == "name" && !c("punc", ":")) {
                    var o = new ae({
                        start: f.token,
                        name: "" + N(),
                        end: d()
                    });
                    if (r == "get") {
                        n.push(new oe({
                            start: t,
                            key: o,
                            value: j(),
                            end: d()
                        }));
                        continue;
                    }
                    if (r == "set") {
                        n.push(new re({
                            start: t,
                            key: o,
                            value: j(),
                            end: d()
                        }));
                        continue;
                    }
                }
                m(":");
                n.push(new hn({
                    start: t,
                    quote: t.quote,
                    key: "" + r,
                    value: Q(false),
                    end: d()
                }));
            }
            p();
            return new dn({
                properties: n
            });
        });
        function N() {
            var e = f.token;
            switch (e.type) {
              case "operator":
                if (!fe[e.value]) v();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                p();
                return e.value;

              default:
                v();
            }
        }
        function R() {
            var e = f.token;
            if (e.type != "name") v();
            p();
            return e.value;
        }
        function I(e) {
            var n = f.token.value;
            return new (n == "this" ? xn : e)({
                name: String(n),
                start: f.token,
                end: f.token
            });
        }
        function U(e) {
            if (e.name == "arguments" || e.name == "eval") h("Unexpected " + e.name + " in strict mode", e.start.line, e.start.col, e.start.pos);
        }
        function P(e, n) {
            if (!c("name")) {
                if (!n) h("Name expected");
                return null;
            }
            var t = I(e);
            if (f.input.has_directive("use strict") && t instanceof vn) {
                U(t);
            }
            p();
            return t;
        }
        function V(e) {
            var n = e.start;
            var t = n.comments_before;
            var i = ve(n, "comments_before_length") ? n.comments_before_length : t.length;
            while (--i >= 0) {
                var r = t[i];
                if (/[@#]__PURE__/.test(r.value)) {
                    e.pure = r;
                    break;
                }
            }
        }
        var L = function(e, n) {
            var t = e.start;
            if (c("punc", ".")) {
                p();
                return L(new rn({
                    start: t,
                    expression: e,
                    property: R(),
                    end: d()
                }), n);
            }
            if (c("punc", "[")) {
                p();
                var i = Q(true);
                m("]");
                return L(new on({
                    start: t,
                    expression: e,
                    property: i,
                    end: d()
                }), n);
            }
            if (n && c("punc", "(")) {
                p();
                var r = new Qe({
                    start: t,
                    expression: e,
                    args: M(")"),
                    end: d()
                });
                V(r);
                return L(r, true);
            }
            return e;
        };
        var Y = function(e) {
            var n = f.token;
            if (c("operator") && Jn[n.value]) {
                p();
                x();
                var t = W(sn, n, Y(e));
                t.start = n;
                t.end = d();
                return t;
            }
            var i = a(e);
            while (c("operator") && Xn[f.token.value] && !g(f.token)) {
                i = W(un, f.token, i);
                i.start = n;
                i.end = f.token;
                p();
            }
            return i;
        };
        function W(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!Z(t)) h("Invalid use of " + i + " operator", n.line, n.col, n.pos);
                break;

              case "delete":
                if (t instanceof wn && f.input.has_directive("use strict")) h("Calling delete on expression not allowed in strict mode", t.start.line, t.start.col, t.start.pos);
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        var G = function(e, n, t) {
            var i = c("operator") ? f.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? Kn[i] : null;
            if (r != null && r > n) {
                p();
                var o = G(Y(true), r, t);
                return G(new fn({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: o,
                    end: o.end
                }), n, t);
            }
            return e;
        };
        function J(e) {
            return G(Y(true), 0, e);
        }
        var X = function(e) {
            var n = f.token;
            var t = J(e);
            if (c("operator", "?")) {
                p();
                var i = Q(false);
                m(":");
                return new cn({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: Q(false, e),
                    end: d()
                });
            }
            return t;
        };
        function Z(e) {
            return e instanceof tn || e instanceof wn;
        }
        var K = function(e) {
            var n = f.token;
            var t = X(e), i = f.token.value;
            if (c("operator") && Zn[i]) {
                if (Z(t)) {
                    p();
                    return new ln({
                        start: n,
                        left: t,
                        operator: i,
                        right: K(e),
                        end: d()
                    });
                }
                h("Invalid assignment");
            }
            return t;
        };
        var Q = function(e, n) {
            var t = f.token;
            var i = [];
            while (true) {
                i.push(K(n));
                if (!e || !c("punc", ",")) break;
                p();
                e = true;
            }
            return i.length == 1 ? i[0] : new nn({
                start: t,
                expressions: i,
                end: l()
            });
        };
        function ee(e) {
            ++f.in_loop;
            var n = e();
            --f.in_loop;
            return n;
        }
        if (u.expression) {
            return Q(true);
        }
        return function() {
            var e = f.token;
            var n = [];
            f.input.push_directives_stack();
            while (!c("eof")) n.push(A(true));
            f.input.pop_directives_stack();
            var t = d();
            var i = u.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new $e({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function nt(e, n) {
        zn.call(this);
        this.before = e;
        this.after = n;
    }
    nt.prototype = new zn();
    (function(e) {
        function t(e, n) {
            return pe(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(_e, Q);
        e(Ee, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(ye, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(we, function(e, n) {
            e.body = t(e.body, n);
        });
        e(Fe, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(Ce, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(Be, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(Se, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(Te, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(He, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(Re, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(Pe, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(Ve, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Ye, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(We, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(Ge, function(e, n) {
            e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(Xe, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(Ke, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(ze, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            e.body = t(e.body, n);
        });
        e(Qe, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(nn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(rn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(on, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(an, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(fn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(cn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(pn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(dn, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(I, function(e, n) {
            e.value = e.value.transform(n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function d(e, n, t) {
        this.name = n.name;
        this.orig = [ n ];
        this.init = t;
        this.eliminated = 0;
        this.scope = e;
        this.references = [];
        this.replaced = 0;
        this.global = false;
        this.mangled_name = null;
        this.undeclared = false;
        this.id = d.next_id++;
    }
    d.next_id = 1;
    d.prototype = {
        unmangleable: function(e) {
            if (!e) e = {};
            return this.global && !e.toplevel || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof bn || this.orig[0] instanceof gn);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t;
                if (t = this.redefined()) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = m(this.scope, e, this);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            return this.defun && this.defun.variables.get(this.name);
        }
    };
    $e.DEFMETHOD("figure_out_scope", function(a) {
        a = te(a, {
            cache: null,
            ie8: false
        });
        var o = this;
        var s = o.parent_scope = null;
        var u = null;
        var f = new zn(function(e, n) {
            if (e instanceof Ge) {
                var t = s;
                s = new Oe(e);
                s.init_scope_vars(t);
                n();
                s = t;
                return true;
            }
            if (e instanceof Oe) {
                e.init_scope_vars(s);
                var t = s;
                var i = u;
                u = s = e;
                n();
                s = t;
                u = i;
                return true;
            }
            if (e instanceof Te) {
                for (var r = s; r; r = r.parent_scope) r.uses_with = true;
                return;
            }
            if (e instanceof U) {
                e.scope = s;
            }
            if (e instanceof se) {
                e.thedef = e;
                e.references = [];
            }
            if (e instanceof gn) {
                (e.scope = u.parent_scope.resolve()).def_function(e, u);
            } else if (e instanceof bn) {
                var o = u.def_function(e, e.name == "arguments" ? undefined : u);
                if (a.ie8) o.defun = u.parent_scope.resolve();
            } else if (e instanceof _n) {
                u.def_variable(e, e.TYPE == "SymbolVar" ? null : undefined);
                if (u !== s) {
                    e.mark_enclosed(a);
                    var o = s.find_variable(e);
                    if (e.thedef !== o) {
                        e.thedef = o;
                    }
                    e.reference(a);
                }
            } else if (e instanceof yn) {
                s.def_variable(e).defun = u;
            }
        });
        o.walk(f);
        o.globals = new M();
        var f = new zn(function(e) {
            if (e instanceof Re) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof wn) {
                var n = e.name;
                if (n == "eval" && f.parent() instanceof Qe) {
                    for (var t = e.scope; t && !t.uses_eval; t = t.parent_scope) {
                        t.uses_eval = true;
                    }
                }
                var i = e.scope.find_variable(n);
                if (!i) {
                    i = o.def_global(e);
                } else if (i.scope instanceof ze && n == "arguments") {
                    i.scope.uses_arguments = true;
                }
                e.thedef = i;
                e.reference(a);
                return true;
            }
            if (e instanceof yn) {
                var r = e.definition().redefined();
                if (r) for (var t = e.scope; t; t = t.parent_scope) {
                    v(t.enclosed, r);
                    if (t === r.scope) break;
                }
                return true;
            }
        });
        o.walk(f);
        if (a.ie8) o.walk(new zn(function(e) {
            if (e instanceof yn) {
                t(e, e.thedef.defun);
                return true;
            }
            if (e instanceof bn) {
                var n = e.thedef;
                if (n.orig.length == 1) {
                    t(e, e.scope.parent_scope);
                    e.thedef.init = n.init;
                }
                return true;
            }
        }));
        function t(e, n) {
            var t = e.name;
            var i = e.thedef.references;
            var r = n.find_variable(t) || o.globals.get(t) || n.def_variable(e);
            i.forEach(function(e) {
                e.thedef = r;
                e.reference(a);
            });
            e.thedef = r;
            e.reference(a);
        }
    });
    $e.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = new d(this, e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    Oe.DEFMETHOD("init_scope_vars", function(e) {
        this.variables = new M();
        this.functions = new M();
        this.uses_with = false;
        this.uses_eval = false;
        this.parent_scope = e;
        this.enclosed = [];
        this.cname = -1;
    });
    ze.DEFMETHOD("init_scope_vars", function() {
        Oe.prototype.init_scope_vars.apply(this, arguments);
        this.uses_arguments = false;
        this.def_variable(new mn({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
    });
    U.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            v(t.enclosed, n);
            if (e.keep_fnames) {
                t.functions.each(function(e) {
                    v(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    U.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    Oe.DEFMETHOD("find_variable", function(e) {
        if (e instanceof U) e = e.name;
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    Oe.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof je) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    Oe.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init && (t.scope !== e.scope || t.init instanceof qe)) {
                t.init = n;
            }
        } else {
            t = new d(this, e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    ze.DEFMETHOD("resolve", T);
    Oe.DEFMETHOD("resolve", function() {
        return this.parent_scope;
    });
    $e.DEFMETHOD("resolve", T);
    function _(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.names_in_use = t = Object.create(e.mangled_names || null);
            e.cname_holes = [];
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
            });
        }
        return t;
    }
    function m(e, i, n) {
        var t = _(e, i);
        var r = e.cname_holes;
        var o = Object.create(null);
        var a = [ e ];
        n.references.forEach(function(e) {
            var n = e.scope;
            do {
                if (a.indexOf(n) < 0) {
                    for (var t in _(n, i)) {
                        o[t] = true;
                    }
                    a.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var u = 0, f = r.length; u < f; u++) {
            s = w(r[u]);
            if (o[s]) continue;
            r.splice(u, 1);
            e.names_in_use[s] = true;
            return s;
        }
        while (true) {
            s = w(++e.cname);
            if (t[s] || !p(s) || i.reserved.has[s]) continue;
            if (!o[s]) break;
            r.push(e.cname);
        }
        e.names_in_use[s] = true;
        return s;
    }
    U.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    se.DEFMETHOD("unmangleable", le);
    U.DEFMETHOD("unreferenced", function() {
        return !this.definition().references.length && !this.scope.pinned();
    });
    U.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    U.DEFMETHOD("global", function() {
        return this.definition().global;
    });
    function y(e) {
        e = te(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        v(e.reserved, "arguments");
        e.reserved.has = de(e.reserved);
        return e;
    }
    $e.DEFMETHOD("mangle_names", function(s) {
        s = y(s);
        var u = -1;
        if (s.cache && s.cache.props) {
            var n = this.mangled_names = Object.create(null);
            s.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var f = [];
        var e = new zn(function(e, n) {
            if (e instanceof Ee) {
                var t = u;
                n();
                u = t;
                return true;
            }
            if (e instanceof Oe) {
                n();
                if (s.cache && e instanceof $e) {
                    e.globals.each(c);
                }
                e.variables.each(c);
                return true;
            }
            if (e instanceof se) {
                var i;
                do {
                    i = w(++u);
                } while (!p(i));
                e.mangled_name = i;
                return true;
            }
            if (!s.ie8 && e instanceof Ge) {
                var r = e.argname.definition();
                var o = r.redefined();
                if (o) {
                    f.push(r);
                    a(e.argname);
                    r.references.forEach(a);
                }
                n();
                if (!o) c(r);
                return true;
            }
            function a(e) {
                e.thedef = o;
                e.reference(s);
                e.thedef = r;
            }
        });
        this.walk(e);
        f.forEach(c);
        function c(e) {
            if (s.reserved.has[e.name]) return;
            e.mangle(s);
        }
    });
    $e.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(null);
        t.reserved.forEach(r);
        this.globals.each(o);
        this.walk(new zn(function(e) {
            if (e instanceof Oe) e.variables.each(o);
            if (e instanceof yn) o(e.definition());
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function o(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    $e.DEFMETHOD("expand_names", function(t) {
        w.reset();
        w.sort();
        t = y(t);
        var n = this.find_colliding_names(t);
        var i = 0;
        this.globals.each(o);
        this.walk(new zn(function(e) {
            if (e instanceof Oe) e.variables.each(o);
            if (e instanceof yn) o(e.definition());
        }));
        function r() {
            var e;
            do {
                e = w(i++);
            } while (n[e] || !p(e));
            return e;
        }
        function o(n) {
            if (n.global && t.cache) return;
            if (n.unmangleable(t)) return;
            if (t.reserved.has[n.name]) return;
            var e = n.redefined();
            n.name = e ? e.name : r();
            n.orig.forEach(function(e) {
                e.name = n.name;
            });
            n.references.forEach(function(e) {
                e.name = n.name;
            });
        }
    });
    _e.DEFMETHOD("tail_node", T);
    nn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    $e.DEFMETHOD("compute_char_frequency", function(t) {
        t = y(t);
        w.reset();
        try {
            _e.prototype.print = function(e, n) {
                this._print(e, n);
                if (this instanceof U && !this.unmangleable(t)) {
                    w.consider(this.name, -1);
                } else if (t.properties) {
                    if (this instanceof rn) {
                        w.consider(this.property, -1);
                    } else if (this instanceof on) {
                        i(this.property);
                    }
                }
            };
            w.consider(this.print_to_string(), 1);
        } finally {
            _e.prototype.print = _e.prototype._print;
        }
        w.sort();
        function i(e) {
            if (e instanceof An) {
                w.consider(e.value, -1);
            } else if (e instanceof cn) {
                i(e.consequent);
                i(e.alternative);
            } else if (e instanceof nn) {
                i(e.tail_node());
            }
        }
    });
    var w = function() {
        var o = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0, i = e.length; t < i; t++) {
                var r = e[t];
                n.push(r);
                o[r] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, r;
        function a() {
            r = Object.create(o);
        }
        u.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                r[e[t]] += n;
            }
        };
        function s(e, n) {
            return r[n] - r[e];
        }
        u.sort = function() {
            i = t.sort(s).concat(n.sort(s));
        };
        u.reset = a;
        a();
        function u(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += i[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return u;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var tt = /^$|[;{][\s\n]*$/;
    function it(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function rt(s) {
        var e = !s;
        s = te(s, {
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = le;
        if (s.comments) {
            var n = s.comments;
            if (typeof s.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(s.comments)) {
                var t = s.comments.lastIndexOf("/");
                n = new RegExp(s.comments.substr(1, t - 1), s.comments.substr(t + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = it;
            } else {
                u = ee;
            }
        }
        var r = 0;
        var o = 0;
        var a = 1;
        var f = 0;
        var c = "";
        var l = s.ascii_only ? function(e, t) {
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = e.length; t < i; t++) {
                if (qn(e[t]) && !jn(e[t + 1]) || jn(e[t]) && !qn(e[t - 1])) {
                    n += "\\u" + e.charCodeAt(t).toString(16);
                } else {
                    n += e[t];
                }
            }
            return n;
        };
        function i(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return s.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            function n() {
                return "'" + t.replace(/\x27/g, "\\'") + "'";
            }
            function o() {
                return '"' + t.replace(/\x22/g, '\\"') + '"';
            }
            t = l(t);
            switch (s.quote_style) {
              case 1:
                return n();

              case 2:
                return o();

              case 3:
                return e == "'" ? n() : o();

              default:
                return i > r ? n() : o();
            }
        }
        function p(e, n) {
            var t = i(e, n);
            if (s.inline_script) {
                t = t.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                t = t.replace(/\x3c!--/g, "\\x3c!--");
                t = t.replace(/--\x3e/g, "--\\x3e");
            }
            return t;
        }
        function d(e) {
            e = e.toString();
            e = l(e, true);
            return e;
        }
        function h(e) {
            return K(" ", s.indent_start + r - e * s.indent_level);
        }
        var v = false;
        var _ = 0;
        var m = true;
        var g = false;
        var b = false;
        var y = false;
        var w = false;
        var x = -1;
        var A = "";
        var E, k, D = s.source_map && [];
        var F = D ? function(n, t) {
            D.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Q;
        var C = D ? function() {
            D.forEach(function(n) {
                try {
                    s.source_map.add(n.token.file, n.line, n.col, n.token.line, n.token.col, !n.name && n.token.type == "name" ? n.token.value : n.name);
                } catch (e) {
                    _e.warn("Couldn't figure out mapping for {file}:{line},{col} → {cline},{ccol} [{name}]", {
                        file: n.token.file,
                        line: n.token.line,
                        col: n.token.col,
                        cline: n.line,
                        ccol: n.col,
                        name: n.name || ""
                    });
                }
            });
            D = [];
        } : Q;
        function B(e) {
            var n = c.lastIndexOf("\n");
            if (_ < n) _ = n;
            var t = c.slice(0, _);
            var i = c.slice(_);
            F(e, i.length - o);
            a += e;
            f += e;
            o = i.length;
            c = t;
            while (e--) c += "\n";
            c += i;
        }
        var S = s.max_line_len ? function() {
            if (m) {
                if (o > s.max_line_len) {
                    _e.warn("Output exceeds {max_line_len} characters", s);
                }
                return;
            }
            if (o > s.max_line_len) B(1);
            m = true;
            C();
        } : Q;
        var T = de("( [ + * / - , .");
        function O(e) {
            e = String(e);
            var n = e.charAt(0);
            if (y && n) {
                y = false;
                if (n != "\n") {
                    O("\n");
                    z();
                }
            }
            if (w && n) {
                w = false;
                if (!/[\s;})]/.test(n)) {
                    $();
                }
            }
            x = -1;
            var t = A.charAt(A.length - 1);
            if (b) {
                b = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (s.semicolons || T[n]) {
                        c += ";";
                        o++;
                        f++;
                    } else {
                        S();
                        c += "\n";
                        f++;
                        a++;
                        o = 0;
                        if (/^\s+$/.test(e)) {
                            b = true;
                        }
                    }
                    if (!s.beautify) g = false;
                }
            }
            if (g) {
                if (In(t) && (In(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == A) {
                    c += " ";
                    o++;
                    f++;
                }
                g = false;
            }
            if (E) {
                D.push({
                    token: E,
                    name: k,
                    line: a,
                    col: o
                });
                E = false;
                if (m) C();
            }
            c += e;
            v = e[e.length - 1] == "(";
            f += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            a += r;
            o += i[0].length;
            if (r > 0) {
                S();
                o = i[r].length;
            }
            A = e;
        }
        var $ = s.beautify ? function() {
            O(" ");
        } : function() {
            g = true;
        };
        var z = s.beautify ? function(e) {
            if (s.beautify) {
                O(h(e ? .5 : 0));
            }
        } : Q;
        var M = s.beautify ? function(e, n) {
            if (e === true) e = R();
            var t = r;
            r = e;
            var i = n();
            r = t;
            return i;
        } : function(e, n) {
            return n();
        };
        var q = s.max_line_len || s.preserve_line ? function() {
            S();
            _ = c.length;
            m = false;
        } : Q;
        var j = s.beautify ? function() {
            if (x < 0) return O("\n");
            if (c[x] != "\n") {
                c = c.slice(0, x) + "\n" + c.slice(x);
                f++;
                a++;
            }
            x++;
        } : q;
        var H = s.beautify ? function() {
            O(";");
        } : function() {
            b = true;
        };
        function N() {
            b = false;
            O(";");
        }
        function R() {
            return r + s.indent_level;
        }
        function I(e) {
            var n;
            O("{");
            j();
            M(R(), function() {
                n = e();
            });
            z();
            O("}");
            return n;
        }
        function U(e) {
            O("(");
            q();
            var n = e();
            q();
            O(")");
            return n;
        }
        function P(e) {
            O("[");
            q();
            var n = e();
            q();
            O("]");
            return n;
        }
        function V() {
            q();
            O(",");
            q();
            $();
        }
        function L() {
            O(":");
            $();
        }
        var Y = D ? function(e, n) {
            E = e;
            k = n;
        } : Q;
        function W() {
            if (!m) S();
            return c;
        }
        function G() {
            var e = c.lastIndexOf("\n");
            return /^ *$/.test(c.slice(e + 1));
        }
        function J(e) {
            var i = this;
            var n = e.start;
            if (!n) return;
            if (n.comments_before && n.comments_before._dumped === i) return;
            var r = n.comments_before;
            if (!r) {
                r = n.comments_before = [];
            }
            r._dumped = i;
            if (e instanceof He && e.value) {
                var o = new zn(function(e) {
                    var n = o.parent();
                    if (n instanceof He || n instanceof fn && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof cn && n.condition === e || n instanceof rn && n.expression === e || n instanceof nn && n.expressions[0] === e || n instanceof on && n.expression === e || n instanceof un) {
                        var t = e.start.comments_before;
                        if (t && t._dumped !== i) {
                            t._dumped = i;
                            r = r.concat(t);
                        }
                    } else {
                        return true;
                    }
                });
                o.push(e);
                e.value.walk(o);
            }
            if (f == 0) {
                if (r.length > 0 && s.shebang && r[0].type == "comment5") {
                    O("#!" + r.shift().value + "\n");
                    z();
                }
                var t = s.preamble;
                if (t) {
                    O(t.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            r = r.filter(u, e);
            if (r.length == 0) return;
            var a = G();
            r.forEach(function(e, n) {
                if (!a) {
                    if (e.nlb) {
                        O("\n");
                        z();
                        a = true;
                    } else if (n > 0) {
                        $();
                    }
                }
                if (/comment[134]/.test(e.type)) {
                    O("//" + e.value.replace(/[@#]__PURE__/g, " ") + "\n");
                    z();
                    a = true;
                } else if (e.type == "comment2") {
                    O("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    a = false;
                }
            });
            if (!a) {
                if (n.nlb) {
                    O("\n");
                    z();
                } else {
                    $();
                }
            }
        }
        function X(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof me || he(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var o = c.length;
            r.filter(u, e).forEach(function(e, n) {
                w = false;
                if (y) {
                    O("\n");
                    z();
                    y = false;
                } else if (e.nlb && (n > 0 || !G())) {
                    O("\n");
                    z();
                } else if (n > 0 || !t) {
                    $();
                }
                if (/comment[134]/.test(e.type)) {
                    O("//" + e.value.replace(/[@#]__PURE__/g, " "));
                    y = true;
                } else if (e.type == "comment2") {
                    O("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    w = true;
                }
            });
            if (c.length > o) x = o;
        }
        var Z = [];
        return {
            get: W,
            toString: W,
            indent: z,
            indentation: function() {
                return r;
            },
            current_width: function() {
                return o - r;
            },
            should_break: function() {
                return s.width && this.current_width() >= s.width;
            },
            has_parens: function() {
                return v;
            },
            newline: j,
            print: O,
            space: $,
            comma: V,
            colon: L,
            last: function() {
                return A;
            },
            semicolon: H,
            force_semicolon: N,
            to_utf8: l,
            print_name: function(e) {
                O(d(e));
            },
            print_string: function(e, n, t) {
                var i = p(e, n);
                if (t === true && i.indexOf("\\") === -1) {
                    if (!tt.test(c)) {
                        N();
                    }
                    N();
                }
                O(i);
            },
            encode_string: p,
            next_indent: R,
            with_indent: M,
            with_block: I,
            with_parens: U,
            with_square: P,
            add_mapping: Y,
            option: function(e) {
                return s[e];
            },
            prepend_comments: e ? Q : J,
            append_comments: e || u === le ? Q : X,
            line: function() {
                return a;
            },
            col: function() {
                return o;
            },
            pos: function() {
                return f;
            },
            push_node: function(e) {
                Z.push(e);
            },
            pop_node: s.preserve_line ? function() {
                var e = Z.pop();
                if (e.start && e.start.line > a) {
                    B(e.start.line - a);
                }
            } : function() {
                Z.pop();
            },
            parent: function(e) {
                return Z[Z.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var o = false;
        var a = null;
        var s = null;
        _e.DEFMETHOD("print", function(e, n) {
            var t = this, i = t._codegen;
            if (t instanceof Oe) {
                a = t;
            } else if (!s && t instanceof be && t.value == "use asm") {
                s = a;
            }
            function r() {
                e.prepend_comments(t);
                t.add_source_map(e);
                i(t, e);
                e.append_comments(t);
            }
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(r);
            } else {
                r();
            }
            e.pop_node();
            if (t === s) {
                s = null;
            }
        });
        _e.DEFMETHOD("_print", _e.prototype.print);
        _e.DEFMETHOD("print_to_string", function(e) {
            var n = rt(e);
            this.print(n);
            return n.get();
        });
        function t(e, n) {
            if (Array.isArray(e)) {
                e.forEach(function(e) {
                    t(e, n);
                });
            } else {
                e.DEFMETHOD("needs_parens", n);
            }
        }
        t(_e, le);
        t(qe, function(e) {
            if (!e.has_parens() && q(e)) return true;
            if (e.option("webkit")) {
                var n = e.parent();
                if (n instanceof tn && n.expression === this) return true;
            }
            if (e.option("wrap_iife")) {
                var n = e.parent();
                if (n instanceof Qe && n.expression === this) return true;
            }
        });
        t(dn, function(e) {
            return !e.has_parens() && q(e);
        });
        t(an, function(e) {
            var n = e.parent();
            return n instanceof tn && n.expression === this || n instanceof Qe && n.expression === this;
        });
        t(nn, function(e) {
            var n = e.parent();
            return n instanceof Qe || n instanceof an || n instanceof fn || n instanceof Ke || n instanceof tn || n instanceof pn || n instanceof I || n instanceof cn;
        });
        t(fn, function(e) {
            var n = e.parent();
            if (n instanceof Qe && n.expression === this) return true;
            if (n instanceof an) return true;
            if (n instanceof tn && n.expression === this) return true;
            if (n instanceof fn) {
                var t = n.operator, i = Kn[t];
                var r = this.operator, o = Kn[r];
                if (i > o || i == o && this === n.right) {
                    return true;
                }
            }
        });
        t(tn, function(e) {
            var n = e.parent();
            if (n instanceof en && n.expression === this) {
                var t = false;
                this.walk(new zn(function(e) {
                    if (t || e instanceof Oe) return true;
                    if (e instanceof Qe) {
                        t = true;
                        return true;
                    }
                }));
                return t;
            }
        });
        t(Qe, function(e) {
            var n = e.parent();
            if (n instanceof en && n.expression === this) return true;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof qe && n instanceof tn && n.expression === this && t instanceof ln && t.left === n;
            }
        });
        t(en, function(e) {
            var n = e.parent();
            if (!h(this, e) && (n instanceof tn || n instanceof Qe && n.expression === this)) return true;
        });
        t(En, function(e) {
            var n = e.parent();
            if (n instanceof tn && n.expression === this) {
                var t = this.getValue();
                if (t < 0 || /^0/.test(_(t))) {
                    return true;
                }
            }
        });
        t([ ln, cn ], function(e) {
            var n = e.parent();
            if (n instanceof an) return true;
            if (n instanceof fn && !(n instanceof ln)) return true;
            if (n instanceof Qe && n.expression === this) return true;
            if (n instanceof cn && n.condition === this) return true;
            if (n instanceof tn && n.expression === this) return true;
        });
        e(be, function(e, n) {
            n.print_string(e.value, e.quote);
            n.semicolon();
        });
        e(ge, function(e, n) {
            n.print("debugger");
            n.semicolon();
        });
        function i(e, t, i, n) {
            var r = e.length - 1;
            o = n;
            e.forEach(function(e, n) {
                if (o === true && !(e instanceof be || e instanceof Ae || e instanceof ye && e.body instanceof An)) {
                    o = false;
                }
                if (!(e instanceof Ae)) {
                    i.indent();
                    e.print(i);
                    if (!(n == r && t)) {
                        i.newline();
                        if (t) i.newline();
                    }
                }
                if (o === true && e instanceof ye && e.body instanceof An) {
                    o = false;
                }
            });
            o = false;
        }
        g.DEFMETHOD("_do_print_body", function(e) {
            d(this.body, e);
        });
        e(me, function(e, n) {
            e.body.print(n);
            n.semicolon();
        });
        e($e, function(e, n) {
            i(e.body, true, n, true);
            n.print("");
        });
        e(Ee, function(e, n) {
            e.label.print(n);
            n.colon();
            e.body.print(n);
        });
        e(ye, function(e, n) {
            e.body.print(n);
            n.semicolon();
        });
        function r(e, n) {
            n.print("{");
            n.with_indent(n.next_indent(), function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function u(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    i(e.body, false, n, t);
                });
            } else r(e, n);
        }
        e(xe, function(e, n) {
            u(e, n);
        });
        e(Ae, function(e, n) {
            n.semicolon();
        });
        e(Fe, function(e, n) {
            n.print("do");
            n.space();
            m(e.body, n);
            n.space();
            n.print("while");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.semicolon();
        });
        e(Ce, function(e, n) {
            n.print("while");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        e(Be, function(e, n) {
            n.print("for");
            n.space();
            n.with_parens(function() {
                if (e.init) {
                    if (e.init instanceof Xe) {
                        e.init.print(n);
                    } else {
                        l(e.init, n, true);
                    }
                    n.print(";");
                    n.space();
                } else {
                    n.print(";");
                }
                if (e.condition) {
                    e.condition.print(n);
                    n.print(";");
                    n.space();
                } else {
                    n.print(";");
                }
                if (e.step) {
                    e.step.print(n);
                }
            });
            n.space();
            e._do_print_body(n);
        });
        e(Se, function(e, n) {
            n.print("for");
            n.space();
            n.with_parens(function() {
                e.init.print(n);
                n.space();
                n.print("in");
                n.space();
                e.object.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        e(Te, function(e, n) {
            n.print("with");
            n.space();
            n.with_parens(function() {
                e.expression.print(n);
            });
            n.space();
            e._do_print_body(n);
        });
        ze.DEFMETHOD("_do_print", function(t, e) {
            var n = this;
            if (!e) {
                t.print("function");
            }
            if (n.name) {
                t.space();
                n.name.print(t);
            }
            t.with_parens(function() {
                n.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            u(n, t, true);
        });
        e(ze, function(e, n) {
            e._do_print(n);
        });
        function f(e, n, t) {
            e.print(n);
            if (t) {
                e.space();
                t.print(e);
            }
            e.semicolon();
        }
        e(Ne, function(e, n) {
            f(n, "return", e.value);
        });
        e(ie, function(e, n) {
            f(n, "throw", e.value);
        });
        e(Ie, function(e, n) {
            f(n, "break", e.label);
        });
        e(Ue, function(e, n) {
            f(n, "continue", e.label);
        });
        function c(e, n) {
            var t = e.body;
            if (n.option("braces") || n.option("ie8") && t instanceof Fe) return m(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof Pe) {
                    if (!t.alternative) {
                        m(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof g) {
                    t = t.body;
                } else break;
            }
            d(e.body, n);
        }
        e(Pe, function(e, n) {
            n.print("if");
            n.space();
            n.with_parens(function() {
                e.condition.print(n);
            });
            n.space();
            if (e.alternative) {
                c(e, n);
                n.space();
                n.print("else");
                n.space();
                if (e.alternative instanceof Pe) e.alternative.print(n); else d(e.alternative, n);
            } else {
                e._do_print_body(n);
            }
        });
        e(Ve, function(e, t) {
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) r(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        R.DEFMETHOD("_do_print_body", function(n) {
            n.newline();
            this.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        });
        e(Le, function(e, n) {
            n.print("default:");
            e._do_print_body(n);
        });
        e(Ye, function(e, n) {
            n.print("case");
            n.space();
            e.expression.print(n);
            n.print(":");
            e._do_print_body(n);
        });
        e(We, function(e, n) {
            n.print("try");
            n.space();
            u(e, n);
            if (e.bcatch) {
                n.space();
                e.bcatch.print(n);
            }
            if (e.bfinally) {
                n.space();
                e.bfinally.print(n);
            }
        });
        e(Ge, function(e, n) {
            n.print("catch");
            n.space();
            n.with_parens(function() {
                e.argname.print(n);
            });
            n.space();
            u(e, n);
        });
        e(Je, function(e, n) {
            n.print("finally");
            n.space();
            u(e, n);
        });
        e(Ze, function(e, t) {
            t.print("var");
            t.space();
            e.definitions.forEach(function(e, n) {
                if (n) t.comma();
                e.print(t);
            });
            var n = t.parent();
            if (n && n.init !== e || !(n instanceof Be || n instanceof Se)) t.semicolon();
        });
        function l(e, n, t) {
            var i = false;
            if (t) e.walk(new zn(function(e) {
                if (i || e instanceof Oe) return true;
                if (e instanceof fn && e.operator == "in") {
                    i = true;
                    return true;
                }
            }));
            e.print(n, i);
        }
        e(Ke, function(e, n) {
            e.name.print(n);
            if (e.value) {
                n.space();
                n.print("=");
                n.space();
                var t = n.parent(1);
                var i = t instanceof Be || t instanceof Se;
                l(e.value, n, i);
            }
        });
        e(Qe, function(e, t) {
            e.expression.print(t);
            if (e instanceof en && !h(e, t)) return;
            if (e.expression instanceof Qe || e.expression instanceof ze) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        });
        e(en, function(e, n) {
            n.print("new");
            n.space();
            Qe.prototype._codegen(e, n);
        });
        e(nn, function(e, t) {
            e.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(rn, function(e, n) {
            var t = e.expression;
            t.print(n);
            var i = e.property;
            if (n.option("ie8") && b[i]) {
                n.print("[");
                n.add_mapping(e.end);
                n.print_string(i);
                n.print("]");
            } else {
                if (t instanceof En && t.getValue() >= 0) {
                    if (!/[xa-f.)]/i.test(n.last())) {
                        n.print(".");
                    }
                }
                n.print(".");
                n.add_mapping(e.end);
                n.print_name(i);
            }
        });
        e(on, function(e, n) {
            e.expression.print(n);
            n.print("[");
            e.property.print(n);
            n.print("]");
        });
        e(sn, function(e, n) {
            var t = e.operator;
            n.print(t);
            if (/^[a-z]/i.test(t) || /[+-]$/.test(t) && e.expression instanceof sn && /^[+-]/.test(e.expression.operator)) {
                n.space();
            }
            e.expression.print(n);
        });
        e(un, function(e, n) {
            e.expression.print(n);
            n.print(e.operator);
        });
        e(fn, function(e, n) {
            var t = e.operator;
            e.left.print(n);
            if (t[0] == ">" && e.left instanceof un && e.left.operator == "--") {
                n.print(" ");
            } else {
                n.space();
            }
            n.print(t);
            if ((t == "<" || t == "<<") && e.right instanceof sn && e.right.operator == "!" && e.right.expression instanceof sn && e.right.expression.operator == "--") {
                n.print(" ");
            } else {
                n.space();
            }
            e.right.print(n);
        });
        e(cn, function(e, n) {
            e.condition.print(n);
            n.space();
            n.print("?");
            n.space();
            e.consequent.print(n);
            n.space();
            n.colon();
            e.alternative.print(n);
        });
        e(pn, function(n, i) {
            i.with_square(function() {
                var e = n.elements, t = e.length;
                if (t > 0) i.space();
                e.forEach(function(e, n) {
                    if (n) i.comma();
                    e.print(i);
                    if (n === t - 1 && e instanceof Bn) i.comma();
                });
                if (t > 0) i.space();
            });
        });
        e(dn, function(e, t) {
            if (e.properties.length > 0) t.with_block(function() {
                e.properties.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else r(e, t);
        });
        function p(e, n, t) {
            if (t.option("quote_keys")) {
                t.print_string(e);
            } else if ("" + +e == e && e >= 0) {
                t.print(_(e));
            } else if (b[e] ? !t.option("ie8") : Un(e)) {
                if (n && t.option("keep_quoted_props")) {
                    t.print_string(e, n);
                } else {
                    t.print_name(e);
                }
            } else {
                t.print_string(e, n);
            }
        }
        e(hn, function(e, n) {
            p(e.key, e.quote, n);
            n.colon();
            e.value.print(n);
        });
        I.DEFMETHOD("_print_getter_setter", function(e, n) {
            n.print(e);
            n.space();
            p(this.key.name, this.quote, n);
            this.value._do_print(n, true);
        });
        e(re, function(e, n) {
            e._print_getter_setter("set", n);
        });
        e(oe, function(e, n) {
            e._print_getter_setter("get", n);
        });
        e(U, function(e, n) {
            var t = e.definition();
            n.print_name(t ? t.mangled_name || t.name : e.name);
        });
        e(Bn, Q);
        e(xn, function(e, n) {
            n.print("this");
        });
        e(P, function(e, n) {
            n.print(e.getValue());
        });
        e(An, function(e, n) {
            n.print_string(e.getValue(), e.quote, o);
        });
        e(En, function(e, n) {
            if (s && e.start && e.start.raw != null) {
                n.print(e.start.raw);
            } else {
                n.print(_(e.getValue()));
            }
        });
        e(kn, function(e, n) {
            var t = e.getValue();
            var i = t.toString();
            if (t.raw_source) {
                i = "/" + t.raw_source + i.slice(i.lastIndexOf("/"));
            }
            i = n.to_utf8(i);
            n.print(i);
            var r = n.parent();
            if (r instanceof fn && /^in/.test(r.operator) && r.left === e) n.print(" ");
        });
        function d(e, n) {
            if (n.option("braces")) {
                m(e, n);
            } else {
                if (!e || e instanceof Ae) n.force_semicolon(); else e.print(n);
            }
        }
        function h(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function v(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function _(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, o;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                o = n.slice(r);
                t.push(o + "e-" + (o.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return v(t);
        }
        function m(e, n) {
            if (!e || e instanceof Ae) n.print("{}"); else if (e instanceof xe) e.print(n); else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function n(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        n([ _e, Ee, $e ], Q);
        n([ pn, xe, Ge, P, ge, Xe, be, Je, N, ze, en, dn, g, U, Ve, R, We ], function(e) {
            e.add_mapping(this.start);
        });
        n([ oe, re ], function(e) {
            e.add_mapping(this.start, this.key.name);
        });
        n([ I ], function(e) {
            e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ot(e, n) {
        if (!(this instanceof ot)) return new ot(e, n);
        nt.call(this, this.before, this.after);
        this.options = te(e, {
            arguments: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            global_defs: false,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: true,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            negate_iife: !n,
            passes: 1,
            properties: !n,
            pure_getters: !n && "strict",
            pure_funcs: null,
            reduce_funcs: !n,
            reduce_vars: !n,
            sequences: !n,
            side_effects: !n,
            switches: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            warnings: false
        }, true);
        var t = this.options["global_defs"];
        if (typeof t == "object") for (var i in t) {
            if (/^@/.test(i) && ve(t, i)) {
                t[i.slice(1)] = et(t[i], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        var r = this.options["pure_funcs"];
        if (typeof r == "function") {
            this.pure_funcs = r;
        } else {
            this.pure_funcs = r ? function(e) {
                return r.indexOf(e.expression.print_to_string()) < 0;
            } : ee;
        }
        var o = this.options["top_retain"];
        if (o instanceof RegExp) {
            this.top_retain = function(e) {
                return o.test(e.name);
            };
        } else if (typeof o == "function") {
            this.top_retain = o;
        } else if (o) {
            if (typeof o == "string") {
                o = o.split(/,/);
            }
            this.top_retain = function(e) {
                return o.indexOf(e.name) >= 0;
            };
        }
        var a = this.options["toplevel"];
        this.toplevel = typeof a == "string" ? {
            funcs: /funcs/.test(a),
            vars: /vars/.test(a)
        } : {
            funcs: a,
            vars: a
        };
        var s = this.options["sequences"];
        this.sequences_limit = s == 1 ? 800 : s | 0;
        this.warnings_produced = {};
    }
    ot.prototype = new nt();
    t(ot.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.global) for (var n = 0, t = e.orig.length; n < t; n++) if (!this.toplevel[e.orig[n] instanceof gn ? "funcs" : "vars"]) return true;
            return false;
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie8: this.option("ie8")
            };
            for (var o = 0; o < n; o++) {
                e.figure_out_scope(r);
                if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var a = 0;
                    e.walk(new zn(function() {
                        a++;
                    }));
                    this.info("pass " + o + ": last_count: " + t + ", count: " + a);
                    if (a < t) {
                        t = a;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        info: function() {
            if (this.options.warnings == "verbose") {
                _e.warn.apply(_e, arguments);
            }
        },
        warn: function(e, n) {
            if (this.options.warnings) {
                var t = $(e, n);
                if (!(t in this.warnings_produced)) {
                    this.warnings_produced[t] = true;
                    _e.warn.apply(_e, arguments);
                }
            }
        },
        clear_warnings: function() {
            this.warnings_produced = {};
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof Oe;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i) {
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(_e, function(e, n) {
            return e;
        });
        _e.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        Oe.DEFMETHOD("process_expression", function(i, r) {
            var o = this;
            var a = new nt(function(e) {
                if (i && e instanceof ye) {
                    return oe(Ne, e, {
                        value: e.body
                    });
                }
                if (!i && e instanceof Ne) {
                    if (r) {
                        var n = e.value && e.value.drop_side_effect_free(r, true);
                        return n ? oe(ye, e, {
                            body: n
                        }) : oe(Ae, e);
                    }
                    return oe(ye, e, {
                        body: e.value || oe(sn, e, {
                            operator: "void",
                            expression: oe(En, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof ze && e !== o) {
                    return e;
                }
                if (e instanceof we) {
                    var t = e.body.length - 1;
                    if (t >= 0) {
                        e.body[t] = e.body[t].transform(a);
                    }
                } else if (e instanceof Pe) {
                    e.body = e.body.transform(a);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(a);
                    }
                } else if (e instanceof Te) {
                    e.body = e.body.transform(a);
                }
                return e;
            });
            o.transform(a);
        });
        function m(e, n) {
            n = d(n);
            if (n instanceof _e) return;
            var t;
            if (e instanceof pn) {
                var i = e.elements;
                if (n == "length") return L(i.length, e);
                if (typeof n == "number" && n in i) t = i[n];
            } else if (e instanceof dn) {
                n = "" + n;
                var r = e.properties;
                for (var o = r.length; --o >= 0; ) {
                    var a = r[o];
                    if (!(a instanceof hn)) return;
                    if (!t && r[o].key === n) t = r[o].value;
                }
            }
            return t instanceof wn && t.fixed_value() || t;
        }
        function ie(e, n, t, i, r, o) {
            var a = n.parent(r);
            var s = fe(t, a);
            if (s) return s;
            if (!o && a instanceof Qe && a.expression === t && !a.is_expr_pure(e) && (!(i instanceof qe) || !(a instanceof en) && i.contains_this())) {
                return true;
            }
            if (a instanceof pn) {
                return ie(e, n, a, a, r + 1);
            }
            if (a instanceof hn && t === a.value) {
                var u = n.parent(r + 1);
                return ie(e, n, u, u, r + 2);
            }
            if (a instanceof tn && a.expression === t) {
                var f = m(i, a.property);
                return !o && ie(e, n, a, f, r + 1);
            }
        }
        (function(e) {
            e(_e, Q);
            function i(e, n, t) {
                t.assignments = 0;
                t.chained = false;
                t.direct_access = false;
                t.escaped = false;
                t.fixed = !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof qe && t.init !== t.scope) && t.init;
                if (t.fixed instanceof je && !he(t.references, function(e) {
                    var n = e.scope;
                    do {
                        if (t.scope === n) return true;
                    } while (n instanceof qe && (n = n.parent_scope));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function a(n, t, e) {
                e.variables.each(function(e) {
                    i(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        l(n, e, true);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        l(n, e, true);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = Q;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (e.init instanceof je && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
            }
            function s(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var i = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!i) return t.fixed;
                    } else if (i) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!p(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function u(n, e) {
                e.functions.each(function(e) {
                    if (e.init instanceof je && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function f(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function c(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function l(e, n, t) {
                e.safe_ids[n.id] = t;
            }
            function p(e, n) {
                if (n.single_use == "m") return false;
                if (e.safe_ids[n.id]) {
                    if (n.fixed == null) {
                        var t = n.orig[0];
                        if (t instanceof mn || t.name == "arguments") return false;
                        n.fixed = oe(Cn, t);
                    }
                    return true;
                }
                return n.fixed instanceof je;
            }
            function d(e, n, t, i) {
                if (n.fixed === undefined) return true;
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (!ve(e.safe_ids, n.id)) return false;
                if (!p(e, n)) return false;
                if (n.fixed === false) return false;
                if (n.fixed != null && (!i || n.references.length > n.assignments)) return false;
                if (n.fixed instanceof je) {
                    return i instanceof _e && n.fixed.parent_scope === t;
                }
                return he(n.orig, function(e) {
                    return !(e instanceof gn || e instanceof bn);
                });
            }
            function h(e, n, t) {
                return n.option("unused") && !t.scope.pinned() && t.references.length - t.recursive_refs == 1 && e.loop_ids[t.id] === e.in_loop;
            }
            function v(e) {
                if (!e) return false;
                return e.is_constant() || e instanceof ze || e instanceof xn;
            }
            function _(e, n, t, i, r, o, a) {
                var s = e.parent(o);
                if (r && r.is_constant()) return;
                if (s instanceof ln && s.operator == "=" && i === s.right || s instanceof Qe && (i !== s.expression || s instanceof en) || s instanceof He && i === s.value && i.scope !== n.scope || s instanceof Ke && i === s.value) {
                    if (a > 1 && !(r && r.is_constant_expression(t))) a = 1;
                    if (!n.escaped || n.escaped > a) n.escaped = a;
                    return;
                } else if (s instanceof pn || s instanceof fn && ue[s.operator] || s instanceof cn && i !== s.condition || s instanceof nn && i === s.tail_node()) {
                    _(e, n, t, s, s, o + 1, a);
                } else if (s instanceof hn && i === s.value) {
                    var u = e.parent(o + 1);
                    _(e, n, t, u, u, o + 2, a);
                } else if (s instanceof tn && i === s.expression) {
                    r = m(r, s.property);
                    _(e, n, t, s, r, o + 1, a + 1);
                    if (r) return;
                }
                if (o > 0) return;
                if (s instanceof nn && i !== s.tail_node()) return;
                if (s instanceof ye) return;
                n.direct_access = true;
            }
            var t = new zn(function(e) {
                if (!(e instanceof U)) return;
                var n = e.definition();
                if (!n) return;
                if (e instanceof wn) n.references.push(e);
                n.fixed = false;
            });
            e(Me, function(e, n, t) {
                f(e);
                a(e, t, this);
                n();
                c(e);
                u(e, this);
                return true;
            });
            e(ln, function(e, n, t) {
                var i = this;
                var r = i.left;
                if (!(r instanceof wn)) return;
                var o = r.definition();
                var a = d(e, o, r.scope, i.right);
                o.assignments++;
                if (!a) return;
                var s = o.fixed;
                if (!s && i.operator != "=") return;
                var u = i.operator == "=";
                var f = u ? i.right : i;
                if (ie(t, e, i, f, 0)) return;
                o.references.push(r);
                if (!u) o.chained = true;
                o.fixed = u ? function() {
                    return i.right;
                } : function() {
                    return oe(fn, i, {
                        operator: i.operator.slice(0, -1),
                        left: s instanceof _e ? s : s(),
                        right: i.right
                    });
                };
                l(e, o, false);
                i.right.walk(e);
                l(e, o, true);
                _(e, o, r.scope, i, f, 0, 1);
                return true;
            });
            e(fn, function(e) {
                if (!ue[this.operator]) return;
                this.left.walk(e);
                f(e);
                this.right.walk(e);
                c(e);
                return true;
            });
            e(Qe, function(e, n) {
                e.find_parent(Oe).may_call_this();
                var t = this.expression;
                if (!(t instanceof wn)) return;
                var i = t.definition();
                if (!(i.fixed instanceof je)) return;
                var r = s(e, i);
                if (!r) return;
                n();
                r.walk(e);
                return true;
            });
            e(Ye, function(e) {
                f(e);
                this.expression.walk(e);
                c(e);
                f(e);
                H(this, e);
                c(e);
                return true;
            });
            e(cn, function(e) {
                this.condition.walk(e);
                f(e);
                this.consequent.walk(e);
                c(e);
                f(e);
                this.alternative.walk(e);
                c(e);
                return true;
            });
            e(Le, function(e, n) {
                f(e);
                n();
                c(e);
                return true;
            });
            e(je, function(e, n, t) {
                var i = this.name.definition().id;
                if (e.defun_visited[i]) return true;
                if (e.defun_ids[i] !== e.safe_ids) return true;
                e.defun_visited[i] = true;
                this.inlined = false;
                f(e);
                a(e, t, this);
                n();
                c(e);
                u(e, this);
                return true;
            });
            e(Fe, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                f(e);
                this.body.walk(e);
                if (w(this)) {
                    c(e);
                    f(e);
                }
                this.condition.walk(e);
                c(e);
                e.in_loop = n;
                return true;
            });
            e(Be, function(e) {
                if (this.init) this.init.walk(e);
                var n = e.in_loop;
                e.in_loop = this;
                f(e);
                if (this.condition) this.condition.walk(e);
                this.body.walk(e);
                if (this.step) {
                    if (w(this)) {
                        c(e);
                        f(e);
                    }
                    this.step.walk(e);
                }
                c(e);
                e.in_loop = n;
                return true;
            });
            e(Se, function(e) {
                this.init.walk(t);
                this.object.walk(e);
                var n = e.in_loop;
                e.in_loop = this;
                f(e);
                this.body.walk(e);
                c(e);
                e.in_loop = n;
                return true;
            });
            e(qe, function(i, e, n) {
                var r = this;
                r.inlined = false;
                f(i);
                a(i, n, r);
                var o;
                if (!r.name && (o = i.parent()) instanceof Qe && o.expression === r) {
                    r.argnames.forEach(function(e, n) {
                        var t = e.definition();
                        if (t.fixed === undefined && (!r.uses_arguments || i.has_directive("use strict"))) {
                            t.fixed = function() {
                                return o.args[n] || oe(Cn, o);
                            };
                            i.loop_ids[t.id] = i.in_loop;
                            l(i, t, true);
                        } else {
                            t.fixed = false;
                        }
                    });
                }
                e();
                c(i);
                u(i, r);
                return true;
            });
            e(Pe, function(e) {
                this.condition.walk(e);
                f(e);
                this.body.walk(e);
                c(e);
                if (this.alternative) {
                    f(e);
                    this.alternative.walk(e);
                    c(e);
                }
                return true;
            });
            e(Ee, function(e) {
                f(e);
                this.body.walk(e);
                c(e);
                return true;
            });
            e(yn, function() {
                this.definition().fixed = false;
            });
            e(wn, function(e, n, t) {
                var i = this.definition();
                i.references.push(this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof gn) {
                    e.loop_ids[i.id] = e.in_loop;
                }
                var r;
                if (i.fixed === undefined || !p(e, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    r = this.fixed_value();
                    if (r instanceof ze && Z(e, i)) {
                        i.recursive_refs++;
                    } else if (r && h(e, t, i)) {
                        i.single_use = r instanceof ze && !r.pinned() || i.scope === this.scope && r.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (ie(t, e, this, r, 0, v(r))) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = false;
                        }
                    }
                }
                _(e, i, this.scope, this, r, 0, 1);
                var o;
                if (i.fixed instanceof je && !((o = e.parent()) instanceof Qe && o.expression === this)) {
                    var a = s(e, i);
                    if (a) a.walk(e);
                }
            });
            e($e, function(n, e, t) {
                this.globals.each(function(e) {
                    i(n, t, e);
                });
                f(n);
                a(n, t, this);
                e();
                c(n);
                u(n, this);
                return true;
            });
            e(We, function(e) {
                f(e);
                H(this, e);
                c(e);
                if (this.bcatch) {
                    f(e);
                    this.bcatch.walk(e);
                    c(e);
                }
                if (this.bfinally) this.bfinally.walk(e);
                return true;
            });
            e(an, function(e, n) {
                var t = this;
                if (t.operator != "++" && t.operator != "--") return;
                var i = t.expression;
                if (!(i instanceof wn)) return;
                var r = i.definition();
                var o = d(e, r, i.scope, true);
                r.assignments++;
                if (!o) return;
                var a = r.fixed;
                if (!a) return;
                r.references.push(i);
                r.chained = true;
                r.fixed = function() {
                    return oe(fn, t, {
                        operator: t.operator.slice(0, -1),
                        left: oe(sn, t, {
                            operator: "+",
                            expression: a instanceof _e ? a : a()
                        }),
                        right: oe(En, t, {
                            value: 1
                        })
                    });
                };
                l(e, r, true);
                return true;
            });
            e(Ke, function(e, n) {
                var t = this;
                var i = t.name.definition();
                if (t.value) {
                    if (d(e, i, t.name.scope, t.value)) {
                        i.fixed = function() {
                            return t.value;
                        };
                        e.loop_ids[i.id] = e.in_loop;
                        l(e, i, false);
                        n();
                        l(e, i, true);
                        return true;
                    } else {
                        i.fixed = false;
                    }
                }
            });
            e(Ce, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                f(e);
                n();
                c(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        $e.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new zn(t.option("reduce_vars") ? function(e, n) {
                e._squeezed = false;
                e._optimized = false;
                return e.reduce_vars(i, n, t);
            } : function(e) {
                e._squeezed = false;
                e._optimized = false;
            });
            i.defun_ids = Object.create(null);
            i.defun_visited = Object.create(null);
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
        });
        U.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (!e || e instanceof _e) return e;
            return e();
        });
        wn.DEFMETHOD("is_immutable", function() {
            var e = this.definition().orig;
            return e.length == 1 && e[0] instanceof bn;
        });
        function re(e) {
            if (e instanceof xn) return true;
            if (e instanceof wn) return e.definition().orig[0] instanceof bn;
            if (e instanceof tn) {
                e = e.expression;
                if (e instanceof wn) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return re(e);
            }
            return false;
        }
        function o(e, n) {
            var t, i = 0;
            while (t = e.parent(i++)) {
                if (t instanceof Oe) break;
                if (t instanceof Ge) {
                    t = t.argname.definition().scope;
                    break;
                }
            }
            return t.find_variable(n);
        }
        function oe(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function V(e, n) {
            if (n.length == 1) return n[0];
            return oe(nn, e, {
                expressions: n.reduce(h, [])
            });
        }
        function L(e, n) {
            switch (typeof e) {
              case "string":
                return oe(An, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return oe(Fn, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? oe(sn, n, {
                        operator: "-",
                        expression: oe(En, n, {
                            value: -e
                        })
                    }) : oe(En, n, {
                        value: e
                    });
                }
                return e < 0 ? oe(sn, n, {
                    operator: "-",
                    expression: oe(Sn, n)
                }) : oe(Sn, n);

              case "boolean":
                return oe(e ? $n : On, n);

              case "undefined":
                return oe(Cn, n);

              default:
                if (e === null) {
                    return oe(Dn, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return oe(kn, n, {
                        value: e
                    });
                }
                throw new Error($("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function a(e, n) {
            return n instanceof tn || e.has_directive("use strict") && G(n) && n.name == "eval";
        }
        function ae(e, n, t, i) {
            if (n instanceof sn && n.operator == "delete" || n.TYPE == "Call" && n.expression === t && a(e, i)) {
                return V(t, [ oe(En, t, {
                    value: 0
                }), i ]);
            }
            return i;
        }
        function h(e, n) {
            if (n instanceof nn) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function x(e) {
            if (e === null) return [];
            if (e instanceof xe) return e.body;
            if (e instanceof Ae) return [];
            if (e instanceof me) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function Y(e) {
            if (e === null) return true;
            if (e instanceof Ae) return true;
            if (e instanceof xe) return e.body.length == 0;
            return false;
        }
        function A(e) {
            if (e instanceof ke) {
                return e.body instanceof xe ? e.body : e;
            }
            return e;
        }
        function se(e) {
            while (e instanceof tn) e = e.expression;
            return e;
        }
        function W(e) {
            if (e.TYPE != "Call") return false;
            return e.expression instanceof qe || W(e.expression);
        }
        function G(e) {
            return e instanceof wn && e.definition().undeclared;
        }
        var n = de("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        wn.DEFMETHOD("is_declared", function(e) {
            return !this.definition().undeclared || e.option("unsafe") && n[this.name];
        });
        var J = de("Infinity NaN undefined");
        function s(e) {
            return e instanceof Sn || e instanceof Fn || e instanceof Cn;
        }
        function i(e, u) {
            var Q, ee, ne;
            t();
            var te, n = 10;
            do {
                te = false;
                r(e);
                if (u.option("dead_code")) {
                    a(e, u);
                }
                if (u.option("if_return")) {
                    o(e, u);
                }
                if (u.sequences_limit > 0) {
                    s(e, u);
                    f(e, u);
                }
                if (u.option("join_vars")) {
                    d(e);
                }
                if (u.option("collapse_vars")) {
                    i(e, u);
                }
            } while (te && n-- > 0);
            function t() {
                var e = u.self(), n = 0;
                do {
                    if (e instanceof Ge || e instanceof Je) {
                        n++;
                    } else if (e instanceof ke) {
                        Q = true;
                    } else if (e instanceof Oe) {
                        ne = e;
                        break;
                    } else if (e instanceof We) {
                        ee = true;
                    }
                } while (e = u.parent(n++));
            }
            function i(t, u) {
                if (ne.pinned()) return t;
                var f;
                var c = [];
                var o = t.length;
                var a = new nt(function(e) {
                    if (E) return e;
                    if (!A) {
                        if (e !== s[l]) return e;
                        l++;
                        if (l < s.length) return S(e);
                        A = true;
                        h = q(e, 0);
                        if (h === e) E = true;
                        return e;
                    }
                    var n = a.parent();
                    if (T(e, n)) {
                        E = true;
                        return e;
                    }
                    if (!v && O(e, n)) {
                        v = n;
                    }
                    var t, i;
                    if (D && !(e instanceof vn) && (m && (t = _.equivalent_to(e)) || g && (i = g(e, this)))) {
                        if (v && (i || !y || !w)) {
                            E = true;
                            return e;
                        }
                        if (fe(e, n)) {
                            if (d) k++;
                            return e;
                        } else {
                            k++;
                            if (d && p instanceof Ke) return e;
                        }
                        te = E = true;
                        u.info("Collapsing {name} [{file}:{line},{col}]", {
                            name: e.print_to_string(),
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (p instanceof un) {
                            return oe(sn, p, p);
                        }
                        if (p instanceof Ke) {
                            var r = p.name.definition();
                            if (r.references.length - r.replaced == 1 && !u.exposed(r)) {
                                r.replaced++;
                                return ae(u, n, e, p.value);
                            }
                            return oe(ln, p, {
                                operator: "=",
                                left: oe(wn, p.name, p.name),
                                right: p.value
                            });
                        }
                        p.write_only = false;
                        return p;
                    }
                    var o;
                    if ($(e, n) || x(e)) {
                        h = e;
                        if (e instanceof Oe) E = true;
                    }
                    return S(e);
                }, function(e) {
                    if (E) return;
                    if (h === e) E = true;
                    if (v === e) v = null;
                });
                var n = new nt(function(e) {
                    if (E) return e;
                    if (!A) {
                        if (e !== s[l]) return e;
                        l++;
                        if (l < s.length) return;
                        A = true;
                        return e;
                    }
                    if (e instanceof wn && e.name == B.name) {
                        if (!--k) E = true;
                        if (fe(e, n.parent())) return e;
                        B.replaced++;
                        d.replaced--;
                        return p.value.clone();
                    }
                    if (e instanceof Le || e instanceof Oe) return e;
                });
                while (--o >= 0) {
                    if (o == 0 && u.option("unused")) z();
                    var s = [];
                    M(t[o]);
                    while (c.length > 0) {
                        s = c.pop();
                        var l = 0;
                        var p = s[s.length - 1];
                        var d = null;
                        var h = null;
                        var v = null;
                        var _ = H(p);
                        var i = N(p);
                        var r = _ && _.has_side_effects(u);
                        var m = _ && !r && !re(_);
                        var g = i && U(i);
                        if (!m && !g) continue;
                        var b = L(p);
                        var y = W(_);
                        if (!r) r = G(p);
                        var w = J();
                        var x = p.may_throw(u) ? ee ? function(e) {
                            return e.has_side_effects(u);
                        } : K : le;
                        var e = p.name instanceof mn;
                        var A = e;
                        var E = false, k = 0, D = !f || !A;
                        if (!D) {
                            for (var F = u.self().argnames.lastIndexOf(p.name) + 1; !E && F < f.length; F++) {
                                f[F].transform(a);
                            }
                            D = true;
                        }
                        for (var C = o; !E && C < t.length; C++) {
                            t[C].transform(a);
                        }
                        if (d) {
                            var B = p.name.definition();
                            if (E && B.references.length - B.replaced > k) k = false; else {
                                E = false;
                                l = 0;
                                A = e;
                                for (var C = o; !E && C < t.length; C++) {
                                    t[C].transform(n);
                                }
                                d.single_use = false;
                            }
                        }
                        if (k && !Y(p)) t.splice(o, 1);
                    }
                }
                function S(e) {
                    if (e instanceof Oe) return e;
                    if (e instanceof Ve) {
                        e.expression = e.expression.transform(a);
                        for (var n = 0, t = e.body.length; !E && n < t; n++) {
                            var i = e.body[n];
                            if (i instanceof Ye) {
                                if (!A) {
                                    if (i !== s[l]) continue;
                                    l++;
                                }
                                i.expression = i.expression.transform(a);
                                if (!w) break;
                            }
                        }
                        E = true;
                        return e;
                    }
                }
                function T(e, n) {
                    if (n instanceof Be) return e !== n.init;
                    if (e instanceof ln) {
                        return e.operator != "=" && _.equivalent_to(e.left);
                    }
                    if (e instanceof Qe) {
                        return _ instanceof tn && _.equivalent_to(e.expression);
                    }
                    if (e instanceof ge) return true;
                    if (e instanceof ke) return !(e instanceof Be);
                    if (e instanceof Re) return true;
                    if (e instanceof We) return true;
                    if (e instanceof Te) return true;
                    if (w) return false;
                    return e instanceof wn && !e.is_declared(u);
                }
                function O(e, n) {
                    if (n instanceof fn) return ue[n.operator] && n.left !== e;
                    if (n instanceof cn) return n.condition !== e;
                    return n instanceof Pe && n.condition !== e;
                }
                function $(e, n) {
                    if (e instanceof Qe) return true;
                    if (e instanceof He) {
                        return r || _ instanceof tn || Z(_);
                    }
                    if (e instanceof qe) {
                        return u.option("ie8") && e.name && e.name.name in b;
                    }
                    if (e instanceof tn) {
                        return r || e.expression.may_throw_on_access(u);
                    }
                    if (e instanceof wn) {
                        if (X(e, n)) {
                            return !n || n.operator != "=" || n.left !== e;
                        }
                        return r && Z(e);
                    }
                    if (e instanceof xn) return X(e, n);
                    if (e instanceof Ke) {
                        if (!e.value) return false;
                        return e.name.name in b || r && Z(e.name);
                    }
                    var t = fe(e.left, e);
                    if (t && t.name in b) return true;
                    if (t instanceof tn) return true;
                }
                function z() {
                    var e, t = u.self();
                    if (t instanceof qe && !t.name && !t.uses_arguments && !t.pinned() && (e = u.parent()) instanceof Qe && e.expression === t) {
                        var i = u.has_directive("use strict");
                        if (i && !ce(i, t.body)) i = false;
                        var n = t.argnames.length;
                        f = e.args.slice(n);
                        var r = Object.create(null);
                        for (var o = n; --o >= 0; ) {
                            var a = t.argnames[o];
                            var s = e.args[o];
                            f.unshift(oe(Ke, a, {
                                name: a,
                                value: s
                            }));
                            if (a.name in r) continue;
                            r[a.name] = true;
                            if (!s) {
                                s = oe(Cn, a).transform(u);
                            } else if (s instanceof ze && s.pinned()) {
                                s = null;
                            } else {
                                s.walk(new zn(function(e) {
                                    if (!s) return true;
                                    if (e instanceof wn && t.variables.has(e.name)) {
                                        var n = e.definition().scope;
                                        if (n !== ne) while (n = n.parent_scope) {
                                            if (n === ne) return true;
                                        }
                                        s = null;
                                    }
                                    if (e instanceof xn && (i || !this.find_parent(Oe))) {
                                        s = null;
                                        return true;
                                    }
                                }));
                            }
                            if (s) c.unshift([ oe(Ke, a, {
                                name: a,
                                value: s
                            }) ]);
                        }
                    }
                }
                function M(e) {
                    s.push(e);
                    if (e instanceof ln) {
                        c.push(s.slice());
                        M(e.right);
                    } else if (e instanceof fn) {
                        M(e.left);
                        M(e.right);
                    } else if (e instanceof Qe) {
                        M(e.expression);
                        e.args.forEach(M);
                    } else if (e instanceof Ye) {
                        M(e.expression);
                    } else if (e instanceof cn) {
                        M(e.condition);
                        M(e.consequent);
                        M(e.alternative);
                    } else if (e instanceof Xe) {
                        e.definitions.forEach(M);
                    } else if (e instanceof De) {
                        M(e.condition);
                        if (!(e.body instanceof we)) {
                            M(e.body);
                        }
                    } else if (e instanceof He) {
                        if (e.value) M(e.value);
                    } else if (e instanceof Be) {
                        if (e.init) M(e.init);
                        if (e.condition) M(e.condition);
                        if (e.step) M(e.step);
                        if (!(e.body instanceof we)) {
                            M(e.body);
                        }
                    } else if (e instanceof Se) {
                        M(e.object);
                        if (!(e.body instanceof we)) {
                            M(e.body);
                        }
                    } else if (e instanceof Pe) {
                        M(e.condition);
                        if (!(e.body instanceof we)) {
                            M(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof we)) {
                            M(e.alternative);
                        }
                    } else if (e instanceof nn) {
                        e.expressions.forEach(M);
                    } else if (e instanceof ye) {
                        M(e.body);
                    } else if (e instanceof Ve) {
                        M(e.expression);
                        e.body.forEach(M);
                    } else if (e instanceof an) {
                        if (e.operator == "++" || e.operator == "--") {
                            c.push(s.slice());
                        } else {
                            M(e.expression);
                        }
                    } else if (e instanceof Ke) {
                        if (e.value) {
                            var n = e.name.definition();
                            if (n.references.length > n.replaced) {
                                c.push(s.slice());
                            }
                            M(e.value);
                        }
                    }
                    s.pop();
                }
                function q(e, n, t) {
                    var i = a.parent(n);
                    if (i instanceof ln) {
                        if (t && !(i.left instanceof tn || i.left.name in b)) {
                            return q(i, n + 1, t);
                        }
                        return e;
                    }
                    if (i instanceof fn) {
                        if (t && (!ue[i.operator] || i.left === e)) {
                            return q(i, n + 1, t);
                        }
                        return e;
                    }
                    if (i instanceof Qe) return e;
                    if (i instanceof Ye) return e;
                    if (i instanceof cn) {
                        if (t && i.condition === e) {
                            return q(i, n + 1, t);
                        }
                        return e;
                    }
                    if (i instanceof Xe) {
                        return q(i, n + 1, true);
                    }
                    if (i instanceof He) {
                        return t ? q(i, n + 1, t) : e;
                    }
                    if (i instanceof Pe) {
                        if (t && i.condition === e) {
                            return q(i, n + 1, t);
                        }
                        return e;
                    }
                    if (i instanceof ke) return e;
                    if (i instanceof nn) {
                        return q(i, n + 1, i.tail_node() !== e);
                    }
                    if (i instanceof ye) {
                        return q(i, n + 1, true);
                    }
                    if (i instanceof Ve) return e;
                    if (i instanceof an) return e;
                    if (i instanceof Ke) return e;
                    return null;
                }
                function j(e) {
                    var n = e.value;
                    if (!(n instanceof wn)) return;
                    if (n.name == "arguments") return;
                    var t = n.definition();
                    if (t.undeclared) return;
                    return d = t;
                }
                function H(e) {
                    if (e instanceof Ke) {
                        var n = e.name.definition();
                        if (!ce(e.name, n.orig)) return;
                        var t = n.references.length - n.replaced;
                        var i = n.orig.length - n.eliminated;
                        if (i > 1 && !(e.name instanceof mn) || (t > 1 ? j(e) : !u.exposed(n))) {
                            return oe(wn, e.name, e.name);
                        }
                    } else {
                        return e[e instanceof ln ? "left" : "expression"];
                    }
                }
                function N(e) {
                    return p instanceof ln && p.operator == "=" && p.right;
                }
                function R(e) {
                    return e[e instanceof ln ? "right" : "value"];
                }
                function I(e) {
                    if (e instanceof pn) return false;
                    if (e instanceof fn && ue[e.operator]) {
                        return I(e.left) && I(e.right);
                    }
                    if (e instanceof Qe) return false;
                    if (e instanceof cn) {
                        return I(e.consequent) && I(e.alternative);
                    }
                    if (e instanceof dn) return false;
                    return !e.has_side_effects(u);
                }
                function U(e) {
                    if (e instanceof wn) {
                        var n = e.evaluate(u);
                        if (n === e) return P;
                        return V(n, P);
                    }
                    if (e instanceof xn) return P;
                    if (e.is_truthy()) return V(true, le);
                    if (e.is_constant()) {
                        return V(e.evaluate(u), P);
                    }
                    if (!(_ instanceof wn)) return false;
                    if (!I(e)) return false;
                    var t;
                    var i = _.definition();
                    e.walk(new zn(function(e) {
                        if (t) return true;
                        if (e instanceof wn && e.definition() === i) {
                            t = true;
                        }
                    }));
                    return !t && P;
                }
                function P(e) {
                    return i.equivalent_to(e);
                }
                function V(t, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (t && e.is_truthy() && !e.has_side_effects(u)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                return !e.evaluate(u) == !t;
                            }
                        }
                        return i(e);
                    };
                }
                function L(e) {
                    var t = Object.create(null);
                    if (p instanceof Ke) {
                        t[p.name.name] = _;
                    }
                    var i = new zn(function(e) {
                        var n = se(e);
                        if (n instanceof wn || n instanceof xn) {
                            t[n.name] = t[n.name] || ie(u, i, e, e, 0);
                        }
                    });
                    e.walk(i);
                    return t;
                }
                function Y(i) {
                    if (i.name instanceof mn) {
                        var e = u.self().argnames.indexOf(i.name);
                        var n = u.parent().args;
                        if (n[e]) n[e] = oe(En, n[e], {
                            value: 0
                        });
                        return true;
                    }
                    var r = false;
                    return t[o].transform(new nt(function(e, n, t) {
                        if (r) return e;
                        if (e === i || e.body === i) {
                            r = true;
                            if (e instanceof Ke) {
                                e.value = null;
                                return e;
                            }
                            return t ? pe.skip : null;
                        }
                    }, function(e) {
                        if (e instanceof nn) switch (e.expressions.length) {
                          case 0:
                            return null;

                          case 1:
                            return e.expressions[0];
                        }
                    }));
                }
                function W(e) {
                    var n = se(e);
                    return n instanceof wn && n.definition().scope === ne && !(Q && (n.name in b && b[n.name] !== e || p instanceof an || p instanceof ln && p.operator != "="));
                }
                function G(e) {
                    if (e instanceof an) return false;
                    return R(e).has_side_effects(u);
                }
                function J() {
                    if (r) return false;
                    if (d) return true;
                    if (_ instanceof wn) {
                        var e = _.definition();
                        if (e.references.length - e.replaced == (p instanceof Ke ? 1 : 2)) {
                            return true;
                        }
                    }
                    return false;
                }
                function X(e, n) {
                    var t = b[e.name];
                    if (!t) return;
                    if (t !== _) return !(n instanceof Qe);
                    g = false;
                }
                function Z(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof gn) return false;
                    if (n.scope !== ne) return true;
                    return !he(n.references, function(e) {
                        return e.scope.resolve() === ne;
                    });
                }
                function K(e, n) {
                    if (e instanceof ln) return K(e.left, true);
                    if (e instanceof an) return K(e.expression, true);
                    if (e instanceof Ke) return e.value && K(e.value);
                    if (n) {
                        if (e instanceof rn) return K(e.expression, true);
                        if (e instanceof on) return K(e.expression, true);
                        if (e instanceof wn) return e.definition().scope !== ne;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof xe) {
                        te = true;
                        r(i.body);
                        [].splice.apply(e, [ t, 1 ].concat(i.body));
                        t += i.body.length;
                    } else if (i instanceof Ae) {
                        te = true;
                        e.splice(t, 1);
                    } else if (i instanceof be) {
                        if (n.indexOf(i.value) < 0) {
                            t++;
                            n.push(i.value);
                        } else {
                            te = true;
                            e.splice(t, 1);
                        }
                    } else t++;
                }
            }
            function o(r, t) {
                var i = t.self();
                var e = h(r);
                var o = i instanceof ze;
                for (var n = r.length; --n >= 0; ) {
                    var a = r[n];
                    var s = b(n);
                    var u = r[s];
                    if (o && !u && a instanceof Ne) {
                        if (!a.value) {
                            te = true;
                            r.splice(n, 1);
                            continue;
                        }
                        if (a.value instanceof sn && a.value.operator == "void") {
                            te = true;
                            r[n] = oe(ye, a, {
                                body: a.value.expression
                            });
                            continue;
                        }
                    }
                    if (a instanceof Pe) {
                        var f = E(a.body);
                        if (_(f)) {
                            if (f.label) {
                                z(f.label.thedef.references, f);
                            }
                            te = true;
                            a = a.clone();
                            a.condition = a.condition.negate(t);
                            var c = g(a.body, f);
                            a.body = oe(xe, a, {
                                body: x(a.alternative).concat(m())
                            });
                            a.alternative = oe(xe, a, {
                                body: c
                            });
                            r[n] = a.transform(t);
                            continue;
                        }
                        if (f && !a.alternative && a.body instanceof xe && u instanceof N) {
                            var l = a.condition.negate(t);
                            if (l.print_to_string().length <= a.condition.print_to_string().length) {
                                te = true;
                                a = a.clone();
                                a.condition = l;
                                r[s] = a.body;
                                a.body = u;
                                r[n] = a.transform(t);
                                continue;
                            }
                        }
                        var f = E(a.alternative);
                        if (_(f)) {
                            if (f.label) {
                                z(f.label.thedef.references, f);
                            }
                            te = true;
                            a = a.clone();
                            a.body = oe(xe, a.body, {
                                body: x(a.body).concat(m())
                            });
                            var c = g(a.alternative, f);
                            a.alternative = oe(xe, a.alternative, {
                                body: c
                            });
                            r[n] = a.transform(t);
                            continue;
                        }
                    }
                    if (a instanceof Pe && a.body instanceof Ne) {
                        var p = a.body.value;
                        if (!p && !a.alternative && (o && !u || u instanceof Ne && !u.value)) {
                            te = true;
                            r[n] = oe(ye, a.condition, {
                                body: a.condition
                            });
                            continue;
                        }
                        if (p && !a.alternative && u instanceof Ne && u.value) {
                            te = true;
                            a = a.clone();
                            a.alternative = u;
                            r.splice(n, 1, a.transform(t));
                            r.splice(s, 1);
                            continue;
                        }
                        if (p && !a.alternative && (!u && o && e || u instanceof Ne)) {
                            te = true;
                            a = a.clone();
                            a.alternative = u || oe(Ne, a, {
                                value: null
                            });
                            r.splice(n, 1, a.transform(t));
                            if (u) r.splice(s, 1);
                            continue;
                        }
                        var d = r[y(n)];
                        if (t.option("sequences") && o && !a.alternative && d instanceof Pe && d.body instanceof Ne && b(s) == r.length && u instanceof ye) {
                            te = true;
                            a = a.clone();
                            a.alternative = oe(xe, u, {
                                body: [ u, oe(Ne, u, {
                                    value: null
                                }) ]
                            });
                            r.splice(n, 1, a.transform(t));
                            r.splice(s, 1);
                            continue;
                        }
                    }
                }
                function h(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof Pe && i.body instanceof Ne) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function v(e) {
                    return !e || e instanceof sn && e.operator == "void";
                }
                function _(e) {
                    if (!e) return false;
                    var n = e instanceof Re ? t.loopcontrol_target(e) : null;
                    return e instanceof Ne && o && v(e.value) || e instanceof Ue && i === A(n) || e instanceof Ie && n instanceof xe && i === n;
                }
                function m() {
                    var e = r.slice(n + 1);
                    r.length = n + 1;
                    return e.filter(function(e) {
                        if (e instanceof je) {
                            r.push(e);
                            return false;
                        }
                        return true;
                    });
                }
                function g(e, n) {
                    var t = x(e).slice(0, -1);
                    if (n.value) {
                        t.push(oe(ye, n.value, {
                            body: n.value.expression
                        }));
                    }
                    return t;
                }
                function b(e) {
                    for (var n = e + 1, t = r.length; n < t; n++) {
                        var i = r[n];
                        if (!(i instanceof Ze && w(i))) {
                            break;
                        }
                    }
                    return n;
                }
                function y(e) {
                    for (var n = e; --n >= 0; ) {
                        var t = r[n];
                        if (!(t instanceof Ze && w(t))) {
                            break;
                        }
                    }
                    return n;
                }
            }
            function a(n, t) {
                var e;
                var i = t.self();
                for (var r = 0, o = 0, a = n.length; r < a; r++) {
                    var s = n[r];
                    if (s instanceof Re) {
                        var u = t.loopcontrol_target(s);
                        if (s instanceof Ie && !(u instanceof ke) && A(u) === i || s instanceof Ue && A(u) === i) {
                            if (s.label) {
                                z(s.label.thedef.references, s);
                            }
                        } else {
                            n[o++] = s;
                        }
                    } else {
                        n[o++] = s;
                    }
                    if (E(s)) {
                        e = n.slice(r + 1);
                        break;
                    }
                }
                n.length = o;
                te = o != a;
                if (e) e.forEach(function(e) {
                    b(t, e, n);
                });
            }
            function w(e) {
                return he(e.definitions, function(e) {
                    return !e.value;
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = V(t[0], t);
                    n[i++] = oe(ye, e, {
                        body: e
                    });
                    t = [];
                }
                for (var o = 0, a = n.length; o < a; o++) {
                    var s = n[o];
                    if (s instanceof ye) {
                        if (t.length >= e.sequences_limit) r();
                        var u = s.body;
                        if (t.length > 0) u = u.drop_side_effect_free(e);
                        if (u) h(t, u);
                    } else if (s instanceof Xe && w(s) || s instanceof je) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != a) te = true;
            }
            function p(e, n) {
                if (!(e instanceof xe)) return e;
                var t = null;
                for (var i = 0, r = e.body.length; i < r; i++) {
                    var o = e.body[i];
                    if (o instanceof Ze && w(o)) {
                        n.push(o);
                    } else if (t) {
                        return false;
                    } else {
                        t = o;
                    }
                }
                return t;
            }
            function f(e, t) {
                function n(e) {
                    i--;
                    te = true;
                    var n = r.body;
                    return V(n, [ n, e ]).transform(t);
                }
                var i = 0, r;
                for (var o = 0; o < e.length; o++) {
                    var a = e[o];
                    if (r) {
                        if (a instanceof He) {
                            a.value = n(a.value || oe(Cn, a).transform(t));
                        } else if (a instanceof Be) {
                            if (!(a.init instanceof Xe)) {
                                var s = false;
                                r.body.walk(new zn(function(e) {
                                    if (s || e instanceof Oe) return true;
                                    if (e instanceof fn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (a.init) a.init = n(a.init); else {
                                        a.init = r.body;
                                        i--;
                                        te = true;
                                    }
                                }
                            }
                        } else if (a instanceof Se) {
                            a.object = n(a.object);
                        } else if (a instanceof Pe) {
                            a.condition = n(a.condition);
                        } else if (a instanceof Ve) {
                            a.expression = n(a.expression);
                        } else if (a instanceof Te) {
                            a.expression = n(a.expression);
                        }
                    }
                    if (t.option("conditionals") && a instanceof Pe) {
                        var u = [];
                        var f = p(a.body, u);
                        var c = p(a.alternative, u);
                        if (f !== false && c !== false && u.length > 0) {
                            var l = u.length;
                            u.push(oe(Pe, a, {
                                condition: a.condition,
                                body: f || oe(Ae, a.body),
                                alternative: c
                            }));
                            u.unshift(i, 1);
                            [].splice.apply(e, u);
                            o += l;
                            i += l + 1;
                            r = null;
                            te = true;
                            continue;
                        }
                    }
                    e[i++] = a;
                    r = a instanceof ye ? a : null;
                }
                e.length = i;
            }
            function c(e, n) {
                var t;
                if (n instanceof ln) {
                    t = [ n ];
                } else if (n instanceof nn) {
                    t = n.expressions.slice();
                }
                if (!t) return;
                if (e instanceof Xe) {
                    var i = e.definitions[e.definitions.length - 1];
                    if (l(i.name, i.value, t)) return t;
                }
                for (var r = t.length - 1; --r >= 0; ) {
                    var o = t[r];
                    if (!(o instanceof ln)) continue;
                    if (o.operator != "=") continue;
                    if (!(o.left instanceof wn)) continue;
                    var a = t.slice(r + 1);
                    if (!l(o.left, o.right, a)) continue;
                    return t.slice(0, r + 1).concat(a);
                }
            }
            function l(e, n, t) {
                if (!(n instanceof dn)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof ln)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof tn)) break;
                    var o = r.left.expression;
                    if (!(o instanceof wn)) break;
                    if (e.name != o.name) break;
                    if (!r.right.is_constant_expression(ne)) break;
                    var a = r.left.property;
                    if (a instanceof _e) {
                        a = a.evaluate(u);
                    }
                    if (a instanceof _e) break;
                    a = "" + a;
                    var s = u.has_directive("use strict") ? function(e) {
                        return e.key != a && e.key.name != a;
                    } : function(e) {
                        return e.key.name != a;
                    };
                    if (!he(n.properties, s)) break;
                    n.properties.push(oe(hn, r, {
                        key: a,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function d(i) {
                var e;
                for (var n = 0, r = -1, t = i.length; n < t; n++) {
                    var o = i[n];
                    var a = i[r];
                    if (o instanceof Xe) {
                        if (a && a.TYPE == o.TYPE) {
                            a.definitions = a.definitions.concat(o.definitions);
                            te = true;
                        } else if (e && e.TYPE == o.TYPE && w(o)) {
                            e.definitions = e.definitions.concat(o.definitions);
                            te = true;
                        } else {
                            i[++r] = o;
                            e = o;
                        }
                    } else if (o instanceof He) {
                        o.value = u(o.value);
                    } else if (o instanceof Be) {
                        var s = c(a, o.init);
                        if (s) {
                            te = true;
                            o.init = s.length ? V(o.init, s) : null;
                            i[++r] = o;
                        } else if (a instanceof Ze && (!o.init || o.init.TYPE == a.TYPE)) {
                            if (o.init) {
                                a.definitions = a.definitions.concat(o.init.definitions);
                            }
                            o.init = a;
                            i[r] = o;
                            te = true;
                        } else if (e && o.init && e.TYPE == o.init.TYPE && w(o.init)) {
                            e.definitions = e.definitions.concat(o.init.definitions);
                            o.init = null;
                            i[++r] = o;
                            te = true;
                        } else {
                            i[++r] = o;
                        }
                    } else if (o instanceof Se) {
                        o.object = u(o.object);
                    } else if (o instanceof Pe) {
                        o.condition = u(o.condition);
                    } else if (o instanceof ye) {
                        var s = c(a, o.body);
                        if (s) {
                            te = true;
                            if (!s.length) continue;
                            o.body = V(o.body, s);
                        }
                        i[++r] = o;
                    } else if (o instanceof Ve) {
                        o.expression = u(o.expression);
                    } else if (o instanceof Te) {
                        o.expression = u(o.expression);
                    } else {
                        i[++r] = o;
                    }
                }
                i.length = r + 1;
                function u(e) {
                    i[++r] = o;
                    var n = c(a, e);
                    if (!n) return e;
                    te = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return V(e, n);
                }
            }
        }
        function b(n, e, t) {
            if (!(e instanceof je)) {
                n.warn("Dropping unreachable code [{file}:{line},{col}]", e.start);
            }
            e.walk(new zn(function(e) {
                if (e instanceof Xe) {
                    n.warn("Declarations in unreachable code! [{file}:{line},{col}]", e.start);
                    e.remove_initializers();
                    t.push(e);
                    return true;
                }
                if (e instanceof je) {
                    t.push(e);
                    return true;
                }
                if (e instanceof Oe) {
                    return true;
                }
            }));
        }
        function d(e) {
            if (e instanceof P) {
                return e.getValue();
            }
            if (e instanceof sn && e.operator == "void" && e.expression instanceof P) {
                return;
            }
            return e;
        }
        function g(e, n) {
            return e.is_undefined || e instanceof Cn || e instanceof sn && e.operator == "void" && !e.expression.has_side_effects(n);
        }
        (function(e) {
            e(_e, le);
            e(pn, ee);
            e(ln, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(ze, ee);
            e(dn, ee);
            e(kn, ee);
            e(nn, function() {
                return this.tail_node().is_truthy();
            });
            e(wn, function() {
                var e = this.fixed_value();
                return e && e.is_truthy();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            _e.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function t(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(_e, t);
            e(Dn, ee);
            e(Cn, ee);
            e(P, le);
            e(pn, le);
            e(dn, function(e) {
                if (!t(e)) return false;
                for (var n = this.properties.length; --n >= 0; ) if (this.properties[n].value instanceof Me) return true;
                return false;
            });
            e(ze, le);
            e(un, le);
            e(sn, function() {
                return this.operator == "void";
            });
            e(fn, function(e) {
                return (this.operator == "&&" || this.operator == "||") && (this.left._dot_throw(e) || this.right._dot_throw(e));
            });
            e(ln, function(e) {
                return this.operator == "=" && this.right._dot_throw(e);
            });
            e(cn, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(rn, function(e) {
                if (!t(e)) return false;
                var n = this.expression;
                if (n instanceof wn) n = n.fixed_value();
                return !(n instanceof ze && this.property == "prototype");
            });
            e(nn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(wn, function(e) {
                if (this.is_undefined) return true;
                if (!t(e)) return false;
                if (G(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var n = this.fixed_value();
                return !n || n._dot_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(_e, le);
            e(ln, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = de("in instanceof == != === !== < <= >= >");
            e(fn, function(e) {
                return n[this.operator] || ue[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Tn, ee);
            var t = de("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(Qe, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof rn && (t[n.property] || n.property == "test" && n.expression instanceof kn);
            });
            e(cn, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(en, le);
            e(nn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            var i = de("! delete");
            e(sn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(_e, le);
            var n = de("- * / % & | ^ << >> >>>");
            e(ln, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(fn, function(e) {
                return n[this.operator] || this.operator == "+" && this.left.is_number(e) && this.right.is_number(e);
            });
            var t = de([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(Qe, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof rn && (t[n.property] || G(n.expression) && n.expression.name == "Math");
            });
            e(cn, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(en, le);
            e(En, ee);
            e(nn, function(e) {
                return this.tail_node().is_number(e);
            });
            var i = de("+ - ~ ++ --");
            e(an, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(_e, le);
            e(An, ee);
            e(sn, function() {
                return this.operator == "typeof";
            });
            e(fn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            e(ln, function(e) {
                return (this.operator == "=" || this.operator == "+=") && this.right.is_string(e);
            });
            e(nn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(cn, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var ue = de("&& ||");
        var r = de("delete ++ --");
        function fe(e, n) {
            if (n instanceof an && r[n.operator]) return n.expression;
            if (n instanceof ln && n.left === e) return e;
        }
        (function(e) {
            function r(e, n) {
                if (e instanceof _e) return oe(e.CTOR, n, e);
                if (Array.isArray(e)) return oe(pn, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (ve(e, i)) {
                        t.push(oe(hn, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return oe(dn, n, {
                        properties: t
                    });
                }
                return L(e, n);
            }
            function a(e, n) {
                e.warn("global_defs " + n.print_to_string() + " redefined [{file}:{line},{col}]", n.start);
            }
            $e.DEFMETHOD("resolve_defines", function(o) {
                if (!o.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: o.option("ie8")
                });
                return this.transform(new nt(function(e) {
                    var n = e._find_defs(o, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof tn)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (fe(i, r)) {
                        a(o, e);
                        return;
                    }
                    return n;
                }));
            });
            e(_e, Q);
            e(rn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(vn, function(e) {
                if (!this.global()) return;
                if (ve(e.option("global_defs"), this.name)) a(e, this);
            });
            e(wn, function(e, n) {
                if (!this.global()) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (ve(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function y(e, n) {
            return e.print_to_string().length > n.print_to_string().length ? n : e;
        }
        function u(e, n) {
            return y(oe(ye, e, {
                body: e
            }), oe(ye, n, {
                body: n
            })).body;
        }
        function X(e, n, t) {
            return (q(e) ? u : y)(n, t);
        }
        function t(e) {
            for (var n in e) {
                e[n] = de(e[n]);
            }
        }
        var f = [ "constructor", "toString", "valueOf" ];
        var v = {
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(f),
            Boolean: f,
            Function: f,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(f),
            Object: f,
            RegExp: [ "test" ].concat(f),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(f)
        };
        t(v);
        var _ = {
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        };
        t(_);
        (function(e) {
            _e.DEFMETHOD("evaluate", function(e) {
                if (!e.option("evaluate")) return this;
                var n = [];
                var t = this._eval(e, n, 1);
                n.forEach(function(e) {
                    delete e._eval;
                });
                if (!t || t instanceof RegExp) return t;
                if (typeof t == "function" || typeof t == "object") return this;
                return t;
            });
            var n = de("! ~ - + void");
            _e.DEFMETHOD("is_constant", function() {
                if (this instanceof P) {
                    return !(this instanceof kn);
                } else {
                    return this instanceof sn && this.expression instanceof P && n[this.operator];
                }
            });
            e(me, function() {
                throw new Error($("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(ze, T);
            e(_e, T);
            e(P, function() {
                return this.getValue();
            });
            e(qe, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(pn, function(e, n, t) {
                if (e.option("unsafe")) {
                    var i = [];
                    for (var r = 0, o = this.elements.length; r < o; r++) {
                        var a = this.elements[r];
                        var s = a._eval(e, n, t);
                        if (a === s) return this;
                        i.push(s);
                    }
                    return i;
                }
                return this;
            });
            e(dn, function(e, n, t) {
                if (e.option("unsafe")) {
                    var i = {};
                    for (var r = 0, o = this.properties.length; r < o; r++) {
                        var a = this.properties[r];
                        var s = a.key;
                        if (s instanceof U) {
                            s = s.name;
                        } else if (s instanceof _e) {
                            s = s._eval(e, n, t);
                            if (s === a.key) return this;
                        }
                        if (typeof Object.prototype[s] === "function") {
                            return this;
                        }
                        if (a.value instanceof qe) continue;
                        i[s] = a.value._eval(e, n, t);
                        if (i[s] === a.value) return this;
                    }
                    return i;
                }
                return this;
            });
            var r = de("! typeof void");
            e(sn, function(e, n, t) {
                var i = this.expression;
                if (e.option("typeofs") && this.operator == "typeof" && (i instanceof ze || i instanceof wn && i.fixed_value() instanceof ze)) {
                    return typeof function() {};
                }
                if (!r[this.operator]) t++;
                i = i._eval(e, n, t);
                if (i === this.expression) return this;
                switch (this.operator) {
                  case "!":
                    return !i;

                  case "typeof":
                    if (i instanceof RegExp) return this;
                    return typeof i;

                  case "void":
                    return void i;

                  case "~":
                    return ~i;

                  case "-":
                    return -i;

                  case "+":
                    return +i;
                }
                return this;
            });
            var a = de("&& || === !==");
            e(fn, function(e, n, t) {
                if (!a[this.operator]) t++;
                var i = this.left._eval(e, n, t);
                if (i === this.left) return this;
                var r = this.right._eval(e, n, t);
                if (r === this.right) return this;
                var o;
                switch (this.operator) {
                  case "&&":
                    o = i && r;
                    break;

                  case "||":
                    o = i || r;
                    break;

                  case "|":
                    o = i | r;
                    break;

                  case "&":
                    o = i & r;
                    break;

                  case "^":
                    o = i ^ r;
                    break;

                  case "+":
                    o = i + r;
                    break;

                  case "*":
                    o = i * r;
                    break;

                  case "/":
                    o = i / r;
                    break;

                  case "%":
                    o = i % r;
                    break;

                  case "-":
                    o = i - r;
                    break;

                  case "<<":
                    o = i << r;
                    break;

                  case ">>":
                    o = i >> r;
                    break;

                  case ">>>":
                    o = i >>> r;
                    break;

                  case "==":
                    o = i == r;
                    break;

                  case "===":
                    o = i === r;
                    break;

                  case "!=":
                    o = i != r;
                    break;

                  case "!==":
                    o = i !== r;
                    break;

                  case "<":
                    o = i < r;
                    break;

                  case "<=":
                    o = i <= r;
                    break;

                  case ">":
                    o = i > r;
                    break;

                  case ">=":
                    o = i >= r;
                    break;

                  default:
                    return this;
                }
                return isNaN(o) && e.find_parent(Te) ? this : o;
            });
            e(cn, function(e, n, t) {
                var i = this.condition._eval(e, n, t);
                if (i === this.condition) return this;
                var r = i ? this.consequent : this.alternative;
                var o = r._eval(e, n, t);
                return o === r ? this : o;
            });
            e(wn, function(e, n, t) {
                var i = this.fixed_value();
                if (!i) return this;
                var r;
                if (n.indexOf(i) >= 0) {
                    r = i._eval();
                } else {
                    this._eval = T;
                    r = i._eval(e, n, t);
                    delete this._eval;
                    if (r === i) return this;
                    i._eval = function() {
                        return r;
                    };
                    n.push(i);
                }
                if (r && typeof r == "object") {
                    var o = this.definition().escaped;
                    if (o && t > o) return this;
                }
                return r;
            });
            var h = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var s = {
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            };
            t(s);
            e(tn, function(e, n, t) {
                if (e.option("unsafe")) {
                    var i = this.property;
                    if (i instanceof _e) {
                        i = i._eval(e, n, t);
                        if (i === this.property) return this;
                    }
                    var r = this.expression;
                    var o;
                    if (G(r)) {
                        var a = s[r.name];
                        if (!a || !a[i]) return this;
                        o = h[r.name];
                    } else {
                        o = r._eval(e, n, t + 1);
                        if (!o || o === r || !ve(o, i)) return this;
                        if (typeof o == "function") switch (i) {
                          case "name":
                            return o.node.name ? o.node.name.name : "";

                          case "length":
                            return o.node.argnames.length;

                          default:
                            return this;
                        }
                    }
                    return o[i];
                }
                return this;
            });
            e(Qe, function(n, e, t) {
                var i = this.expression;
                if (n.option("unsafe") && i instanceof tn) {
                    var r = i.property;
                    if (r instanceof _e) {
                        r = r._eval(n, e, t);
                        if (r === i.property) return this;
                    }
                    var o;
                    var a = i.expression;
                    if (G(a)) {
                        var s = _[a.name];
                        if (!s || !s[r]) return this;
                        o = h[a.name];
                    } else {
                        o = a._eval(n, e, t + 1);
                        if (o === a || !o) return this;
                        var u = v[o.constructor.name];
                        if (!u || !u[r]) return this;
                    }
                    var f = [];
                    for (var c = 0, l = this.args.length; c < l; c++) {
                        var p = this.args[c];
                        var d = p._eval(n, e, t);
                        if (p === d) return this;
                        f.push(d);
                    }
                    try {
                        return o[r].apply(o, f);
                    } catch (e) {
                        n.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this.print_to_string(),
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    }
                }
                return this;
            });
            e(en, T);
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function o(e) {
                return oe(sn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = o(e);
                if (t) {
                    var r = oe(ye, n, {
                        body: n
                    });
                    return y(i, r) === r ? n : i;
                }
                return y(i, n);
            }
            e(_e, function() {
                return o(this);
            });
            e(me, function() {
                throw new Error("Cannot negate a statement");
            });
            e(qe, function() {
                return o(this);
            });
            e(sn, function() {
                if (this.operator == "!") return this.expression;
                return o(this);
            });
            e(nn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return V(this, n);
            });
            e(cn, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(fn, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return o(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var c = de("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        Qe.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (G(n) && c[n.name]) return true;
                if (n instanceof rn && G(n.expression)) {
                    var t = _[n.expression.name];
                    return t && t[n.property];
                }
            }
            return this.pure || !e.pure_funcs(this);
        });
        _e.DEFMETHOD("is_call_pure", le);
        rn.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return;
            var n = this.expression;
            var t;
            if (n instanceof pn) {
                t = v.Array;
            } else if (n.is_boolean(e)) {
                t = v.Boolean;
            } else if (n.is_number(e)) {
                t = v.Number;
            } else if (n instanceof kn) {
                t = v.RegExp;
            } else if (n.is_string(e)) {
                t = v.String;
            } else if (!this.may_throw_on_access(e)) {
                t = v.Object;
            }
            return t && t[this.property];
        });
        (function(e) {
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].has_side_effects(n)) return true;
                return false;
            }
            e(_e, ee);
            e(pn, function(e) {
                return n(this.elements, e);
            });
            e(ln, ee);
            e(fn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(we, function(e) {
                return n(this.body, e);
            });
            e(Qe, function(e) {
                if (!this.is_expr_pure(e) && (!this.expression.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return n(this.args, e);
            });
            e(Ye, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(cn, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(P, le);
            e(Xe, function(e) {
                return n(this.definitions, e);
            });
            e(rn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(Ae, le);
            e(Pe, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(Ee, function(e) {
                return this.body.has_side_effects(e);
            });
            e(ze, le);
            e(dn, function(e) {
                return n(this.properties, e);
            });
            e(I, function(e) {
                return this.value.has_side_effects(e);
            });
            e(on, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(nn, function(e) {
                return n(this.expressions, e);
            });
            e(ye, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Ve, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(vn, le);
            e(wn, function(e) {
                return !this.is_declared(e);
            });
            e(xn, le);
            e(We, function(e) {
                return n(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(an, function(e) {
                return r[this.operator] || this.expression.has_side_effects(e);
            });
            e(Ke, function(e) {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(_e, ee);
            e(P, le);
            e(Ae, le);
            e(ze, le);
            e(vn, le);
            e(xn, le);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(pn, function(e) {
                return n(this.elements, e);
            });
            e(ln, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof wn) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(fn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e);
            });
            e(we, function(e) {
                return n(this.body, e);
            });
            e(Qe, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof ze) || n(this.expression.body, e);
            });
            e(Ye, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(cn, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(Xe, function(e) {
                return n(this.definitions, e);
            });
            e(rn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(Pe, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(Ee, function(e) {
                return this.body.may_throw(e);
            });
            e(dn, function(e) {
                return n(this.properties, e);
            });
            e(I, function(e) {
                return this.value.may_throw(e);
            });
            e(Ne, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(nn, function(e) {
                return n(this.expressions, e);
            });
            e(ye, function(e) {
                return this.body.may_throw(e);
            });
            e(on, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(Ve, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(wn, function(e) {
                return !this.is_declared(e);
            });
            e(We, function(e) {
                return this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(an, function(e) {
                if (this.operator == "typeof" && this.expression instanceof wn) return false;
                return this.expression.may_throw(e);
            });
            e(Ke, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function n(e) {
                for (var n = e.length; --n >= 0; ) if (!e[n].is_constant_expression()) return false;
                return true;
            }
            e(_e, le);
            e(P, ee);
            e(ze, function(i) {
                var r = this;
                var o = true;
                r.walk(new zn(function(e) {
                    if (!o) return true;
                    if (e instanceof wn) {
                        if (r.inlined) {
                            o = false;
                            return true;
                        }
                        var n = e.definition();
                        if (ce(n, r.enclosed) && !r.variables.has(n.name)) {
                            if (i) {
                                var t = i.find_variable(e);
                                if (n.undeclared ? !t : t === n) {
                                    o = "f";
                                    return true;
                                }
                            }
                            o = false;
                        }
                        return true;
                    }
                }));
                return o;
            });
            e(an, function() {
                return this.expression.is_constant_expression();
            });
            e(fn, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression();
            });
            e(pn, function() {
                return n(this.elements);
            });
            e(dn, function() {
                return n(this.properties);
            });
            e(I, function() {
                return this.value.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function E(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(me, O);
            e(N, T);
            function n() {
                var e = this.body.length;
                return e > 0 && E(this.body[e - 1]);
            }
            e(xe, n);
            e(R, n);
            e(Pe, function() {
                return this.alternative && E(this.body) && E(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var l = de([ "use asm", "use strict" ]);
        e(be, function(e, n) {
            if (n.option("directives") && (!l[e.value] || n.has_directive(e.value) !== e)) {
                return oe(Ae, e);
            }
            return e;
        });
        e(ge, function(e, n) {
            if (n.option("drop_debugger")) return oe(Ae, e);
            return e;
        });
        e(Ee, function(e, n) {
            if (e.body instanceof Ie && n.loopcontrol_target(e.body) === e.body) {
                return oe(Ae, e);
            }
            return e.label.references.length == 0 ? e.body : e;
        });
        e(we, function(e, n) {
            i(e.body, n);
            return e;
        });
        e(xe, function(e, n) {
            i(e.body, n);
            switch (e.body.length) {
              case 1:
                return e.body[0];

              case 0:
                return oe(Ae, e);
            }
            return e;
        });
        e(ze, function(e, n) {
            i(e.body, n);
            if (n.option("side_effects") && e.body.length == 1 && e.body[0] === n.has_directive("use strict")) {
                e.body.length = 0;
            }
            return e;
        });
        Oe.DEFMETHOD("drop_unused", function(b) {
            if (!b.option("unused")) return;
            if (b.has_directive("use asm")) return;
            var y = this;
            if (y.pinned()) return;
            var w = !(y instanceof $e) || b.toplevel.funcs;
            var x = !(y instanceof $e) || b.toplevel.vars;
            var A = /keep_assign/.test(b.option("unused")) ? le : function(e, n) {
                var t;
                if (e instanceof ln && (e.write_only || e.operator == "=")) {
                    t = e.left;
                } else if (e instanceof an && e.write_only) {
                    t = e.expression;
                }
                if (!/strict/.test(b.option("pure_getters"))) return t instanceof wn && t;
                while (t instanceof tn && !t.expression.may_throw_on_access(b)) {
                    if (t instanceof on) n.unshift(t.property);
                    t = t.expression;
                }
                return t instanceof wn && he(t.definition().orig, function(e) {
                    return !(e instanceof bn);
                }) && t;
            };
            var s = [];
            var E = Object.create(null);
            var k = Object.create(null);
            var u = Object.create(null);
            var f = Object.create(null);
            if (y instanceof $e && b.top_retain) {
                y.variables.each(function(e) {
                    if (b.top_retain(e) && !(e.id in E)) {
                        E[e.id] = true;
                        s.push(e);
                    }
                });
            }
            var D = new M();
            var i = new M();
            var F = this;
            var c = new zn(function(e, n) {
                if (e instanceof ze && e.uses_arguments && !c.has_directive("use strict")) {
                    e.argnames.forEach(function(e) {
                        var n = e.definition();
                        if (!(n.id in E)) {
                            E[n.id] = true;
                            s.push(n);
                        }
                    });
                }
                if (e === y) return;
                if (e instanceof je) {
                    var t = e.name.definition();
                    if (!w && F === y) {
                        if (!(t.id in E)) {
                            E[t.id] = true;
                            s.push(t);
                        }
                    }
                    i.add(t.id, e);
                    return true;
                }
                if (e instanceof mn && F === y) {
                    D.add(e.definition().id, e);
                }
                if (e instanceof Xe && F === y) {
                    e.definitions.forEach(function(e) {
                        var n = e.name.definition();
                        if (e.name instanceof _n) {
                            D.add(n.id, e);
                        }
                        if (!x) {
                            if (!(n.id in E)) {
                                E[n.id] = true;
                                s.push(n);
                            }
                        }
                        if (e.value) {
                            i.add(n.id, e.value);
                            if (e.value.has_side_effects(b)) {
                                e.value.walk(c);
                            }
                            if (!n.chained && e.name.fixed_value() === e.value) {
                                k[n.id] = e;
                            }
                        }
                    });
                    return true;
                }
                return r(e, n);
            });
            y.walk(c);
            c = new zn(r);
            for (var e = 0; e < s.length; e++) {
                var n = i.get(s[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(c);
                });
            }
            var C = b.option("keep_fnames") ? le : b.option("ie8") ? function(e) {
                return !b.exposed(e) && !e.references.length;
            } : function(e) {
                return !(e.id in E) || e.orig.length > 1;
            };
            var B = new nt(function(a, e, n) {
                var t = B.parent();
                if (x) {
                    var i = [], r = A(a, i);
                    if (r) {
                        var o = r.definition();
                        var s = o.id in E;
                        var u = null;
                        if (a instanceof ln) {
                            if (!s || a.left === r && o.id in k && k[o.id] !== a) {
                                u = a.right;
                            }
                        } else if (!s) {
                            u = oe(En, a, {
                                value: 0
                            });
                        }
                        if (u) {
                            i.push(u);
                            return ae(b, t, a, V(a, i.map(function(e) {
                                return e.transform(B);
                            })));
                        }
                    }
                }
                if (F !== y) return;
                if (a instanceof qe && a.name && C(a.name.definition())) {
                    a.name = null;
                }
                if (a instanceof ze && !(a instanceof Me)) {
                    var f = !b.option("keep_fargs");
                    for (var c = a.argnames, l = c.length; --l >= 0; ) {
                        var r = c[l];
                        if (!(r.definition().id in E)) {
                            r.__unused = true;
                            if (f) {
                                c.pop();
                                b[r.unreferenced() ? "warn" : "info"]("Dropping unused function argument {name} [{file}:{line},{col}]", g(r));
                            }
                        } else {
                            f = false;
                        }
                    }
                }
                if (w && a instanceof je && a !== y) {
                    var o = a.name.definition();
                    if (!(o.id in E)) {
                        b[a.name.unreferenced() ? "warn" : "info"]("Dropping unused function {name} [{file}:{line},{col}]", g(a.name));
                        o.eliminated++;
                        return oe(Ae, a);
                    }
                }
                if (a instanceof Xe && !(t instanceof Se && t.init === a)) {
                    var p = [], d = [], h = [];
                    var v = [];
                    a.definitions.forEach(function(e) {
                        if (e.value) e.value = e.value.transform(B);
                        var n = e.name.definition();
                        if (!x || n.id in E) {
                            if (e.value && n.id in k && k[n.id] !== e) {
                                e.value = e.value.drop_side_effect_free(b);
                            }
                            if (e.name instanceof _n) {
                                var t = D.get(n.id);
                                if (t.length > 1 && (!e.value || n.orig.indexOf(e.name) > n.eliminated)) {
                                    b.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", g(e.name));
                                    if (e.value) {
                                        var i = oe(wn, e.name, e.name);
                                        n.references.push(i);
                                        var r = oe(ln, e, {
                                            operator: "=",
                                            left: i,
                                            right: e.value
                                        });
                                        if (k[n.id] === e) {
                                            k[n.id] = r;
                                        }
                                        v.push(r.transform(B));
                                    }
                                    z(t, e);
                                    n.eliminated++;
                                    return;
                                }
                            }
                            if (e.value) {
                                if (v.length > 0) {
                                    if (h.length > 0) {
                                        v.push(e.value);
                                        e.value = V(e.value, v);
                                    } else {
                                        p.push(oe(ye, a, {
                                            body: V(a, v)
                                        }));
                                    }
                                    v = [];
                                }
                                h.push(e);
                            } else {
                                d.push(e);
                            }
                        } else if (n.orig[0] instanceof yn) {
                            var o = e.value && e.value.drop_side_effect_free(b);
                            if (o) v.push(o);
                            e.value = null;
                            d.push(e);
                        } else {
                            var o = e.value && e.value.drop_side_effect_free(b);
                            if (o) {
                                b.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", g(e.name));
                                v.push(o);
                            } else {
                                b[e.name.unreferenced() ? "warn" : "info"]("Dropping unused variable {name} [{file}:{line},{col}]", g(e.name));
                            }
                            n.eliminated++;
                        }
                    });
                    if (d.length > 0 || h.length > 0) {
                        a.definitions = d.concat(h);
                        p.push(a);
                    }
                    if (v.length > 0) {
                        p.push(oe(ye, a, {
                            body: V(a, v)
                        }));
                    }
                    switch (p.length) {
                      case 0:
                        return n ? pe.skip : oe(Ae, a);

                      case 1:
                        return p[0];

                      default:
                        return n ? pe.splice(p) : oe(xe, a, {
                            body: p
                        });
                    }
                }
                if (a instanceof Be) {
                    e(a, this);
                    var _;
                    if (a.init instanceof xe) {
                        _ = a.init;
                        a.init = _.body.pop();
                        _.body.push(a);
                    }
                    if (a.init instanceof ye) {
                        a.init = a.init.body;
                    } else if (Y(a.init)) {
                        a.init = null;
                    }
                    return !_ ? a : n ? pe.splice(_.body) : _;
                }
                if (a instanceof Ee && a.body instanceof Be) {
                    e(a, this);
                    if (a.body instanceof xe) {
                        var _ = a.body;
                        a.body = _.body.pop();
                        _.body.push(a);
                        return n ? pe.splice(_.body) : _;
                    }
                    return a;
                }
                if (a instanceof Oe) {
                    var m = F;
                    F = a;
                    e(a, this);
                    F = m;
                    return a;
                }
                function g(e) {
                    return {
                        name: e.name,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    };
                }
            });
            y.transform(B);
            function l(e, n, t) {
                if (e.id in E) return;
                if (n && t) {
                    E[e.id] = true;
                    s.push(e);
                } else {
                    u[e.id] = n;
                    f[e.id] = t;
                }
            }
            function r(e, n) {
                var t, i = [], r = A(e, i);
                if (r && y.variables.get(r.name) === (t = r.definition())) {
                    i.forEach(function(e) {
                        e.walk(c);
                    });
                    if (e instanceof ln) {
                        e.right.walk(c);
                        if (e.left === r) {
                            if (!t.chained && r.fixed_value() === e.right) {
                                k[t.id] = e;
                            }
                            if (!e.write_only) {
                                l(t, true, f[t.id]);
                            }
                        } else {
                            var o = r.fixed_value();
                            if (!o || !o.is_constant()) {
                                l(t, u[t.id], true);
                            }
                        }
                    }
                    return true;
                }
                if (e instanceof wn) {
                    t = e.definition();
                    if (!(t.id in E)) {
                        E[t.id] = true;
                        s.push(t);
                    }
                    return true;
                }
                if (e instanceof Oe) {
                    var a = F;
                    F = e;
                    n();
                    F = a;
                    return true;
                }
            }
        });
        Oe.DEFMETHOD("hoist_declarations", function(r) {
            if (r.has_directive("use asm")) return;
            var o = r.option("hoist_funs");
            var a = r.option("hoist_vars");
            var s = this;
            if (a) {
                var n = 0;
                s.walk(new zn(function(e) {
                    if (n > 1) return true;
                    if (e instanceof Oe && e !== s) return true;
                    if (e instanceof Ze) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) a = false;
            }
            if (!o && !a) return;
            var u = [];
            var f = [];
            var c = new M(), l = 0;
            var p = new nt(function(e) {
                if (e === s) return;
                if (e instanceof be) {
                    u.push(e);
                    return oe(Ae, e);
                }
                if (o && e instanceof je && (p.parent() === s || !r.has_directive("use strict"))) {
                    f.push(e);
                    return oe(Ae, e);
                }
                if (a && e instanceof Ze) {
                    e.definitions.forEach(function(e) {
                        c.set(e.name.name, e);
                        ++l;
                    });
                    var n = e.to_assignments(r);
                    var t = p.parent();
                    if (t instanceof Se && t.init === e) {
                        if (n) return n;
                        var i = e.definitions[0].name;
                        return oe(wn, i, i);
                    }
                    if (t instanceof Be && t.init === e) return n;
                    if (!n) return oe(Ae, e);
                    return oe(ye, e, {
                        body: n
                    });
                }
                if (e instanceof Oe) return e;
            });
            s.transform(p);
            if (l > 0) {
                var t = [];
                c.each(function(e, n) {
                    if (s instanceof ze && !he(s.argnames, function(e) {
                        return e.name != n;
                    })) {
                        c.del(n);
                    } else {
                        e = e.clone();
                        e.value = null;
                        t.push(e);
                        c.set(n, e);
                    }
                });
                if (t.length > 0) {
                    for (var e = 0; e < s.body.length; ) {
                        if (s.body[e] instanceof ye) {
                            var i = s.body[e].body, d, h;
                            if (i instanceof ln && i.operator == "=" && (d = i.left) instanceof U && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = i.right;
                                z(t, v);
                                t.push(v);
                                s.body.splice(e, 1);
                                continue;
                            }
                            if (i instanceof nn && (h = i.expressions[0]) instanceof ln && h.operator == "=" && (d = h.left) instanceof U && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = h.right;
                                z(t, v);
                                t.push(v);
                                s.body[e].body = V(i, i.expressions.slice(1));
                                continue;
                            }
                        }
                        if (s.body[e] instanceof Ae) {
                            s.body.splice(e, 1);
                            continue;
                        }
                        if (s.body[e] instanceof xe) {
                            var _ = [ e, 1 ].concat(s.body[e].body);
                            s.body.splice.apply(s.body, _);
                            continue;
                        }
                        break;
                    }
                    t = oe(Ze, s, {
                        definitions: t
                    });
                    f.push(t);
                }
            }
            s.body = u.concat(f, s.body);
        });
        Oe.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        Oe.DEFMETHOD("make_var_name", function(e) {
            var n = this.var_names();
            e = e.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var t = e;
            for (var i = 0; n[t]; i++) t = e + "$" + i;
            n[t] = true;
            return t;
        });
        Oe.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var c = this;
            var l = c instanceof $e && e.top_retain || le;
            var p = Object.create(null);
            c.transform(new nt(function(i, e) {
                if (i instanceof ln && i.operator == "=" && i.write_only && u(i.left, i.right, 1)) {
                    e(i, this);
                    var r = new M();
                    var o = [];
                    var a = [];
                    i.right.properties.forEach(function(e) {
                        var n = f(i.left, e.key);
                        a.push(oe(Ke, i, {
                            name: n,
                            value: null
                        }));
                        var t = oe(wn, i, {
                            name: n.name,
                            scope: c,
                            thedef: n.definition()
                        });
                        t.reference({});
                        o.push(oe(ln, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    p[i.left.definition().id] = r;
                    c.body.splice(c.body.indexOf(this.stack[1]) + 1, 0, oe(Ze, i, {
                        definitions: a
                    }));
                    return V(i, o);
                }
                if (i instanceof Ke && u(i.name, i.value, 0)) {
                    e(i, this);
                    var r = new M();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(oe(Ke, i, {
                            name: f(i.name, e.key),
                            value: e.value
                        }));
                    });
                    p[i.name.definition().id] = r;
                    return pe.splice(n);
                }
                if (i instanceof tn && i.expression instanceof wn) {
                    var r = p[i.expression.definition().id];
                    if (r) {
                        var t = r.get(d(i.property));
                        var s = oe(wn, i, {
                            name: t.name,
                            scope: i.expression.scope,
                            thedef: t
                        });
                        s.reference({});
                        return s;
                    }
                }
                function u(e, n, t) {
                    if (e.scope !== c) return;
                    var i = e.definition();
                    if (i.assignments != t) return;
                    if (i.direct_access) return;
                    if (i.escaped == 1) return;
                    if (i.references.length == t) return;
                    if (i.single_use) return;
                    if (l(i)) return;
                    if (e.fixed_value() !== n) return;
                    return n instanceof dn;
                }
                function f(e, n) {
                    var t = oe(_n, e, {
                        name: c.make_var_name(e.name + "_" + n),
                        scope: c
                    });
                    var i = c.def_variable(t);
                    r.set(n, i);
                    c.enclosed.push(i);
                    return t;
                }
            }));
        });
        (function(e) {
            function a(e, n, t) {
                var i = e.length;
                if (!i) return null;
                var r = [], o = false;
                for (var a = 0; a < i; a++) {
                    var s = e[a].drop_side_effect_free(n, t);
                    o |= s !== e[a];
                    if (s) {
                        r.push(s);
                        t = false;
                    }
                }
                return o ? r.length ? r : null : e;
            }
            e(_e, T);
            e(Me, O);
            e(pn, function(e, n) {
                var t = a(this.elements, e, n);
                return t && V(this, t);
            });
            e(ln, function(e) {
                var n = this.left;
                if (n.has_side_effects(e) || e.has_directive("use strict") && n instanceof tn && n.expression.is_constant()) {
                    return this;
                }
                this.write_only = true;
                if (se(n).is_constant_expression(e.find_parent(Oe))) {
                    return this.right.drop_side_effect_free(e);
                }
                return this;
            });
            e(fn, function(e, n) {
                var t = this.right.drop_side_effect_free(e);
                if (!t) return this.left.drop_side_effect_free(e, n);
                if (ue[this.operator]) {
                    if (t === this.right) return this;
                    var i = this.clone();
                    i.right = t;
                    return i;
                } else {
                    var r = this.left.drop_side_effect_free(e, n);
                    if (!r) return this.right.drop_side_effect_free(e, n);
                    return V(this, [ r, t ]);
                }
            });
            e(Qe, function(n, e) {
                if (!this.is_expr_pure(n)) {
                    if (this.expression.is_call_pure(n)) {
                        var t = this.args.slice();
                        t.unshift(this.expression.expression);
                        t = a(t, n, e);
                        return t && V(this, t);
                    }
                    if (this.expression instanceof qe && (!this.expression.name || !this.expression.name.definition().references.length)) {
                        var i = this.clone();
                        var r = i.expression;
                        r.process_expression(false, n);
                        r.walk(new zn(function(e) {
                            if (e instanceof Ne && e.value) {
                                e.value = e.value.drop_side_effect_free(n);
                                return true;
                            }
                            if (e instanceof Oe && e !== r) return true;
                        }));
                        return i;
                    }
                    return this;
                }
                if (this.pure) {
                    n.warn("Dropping __PURE__ call [{file}:{line},{col}]", this.start);
                }
                var o = a(this.args, n, e);
                return o && V(this, o);
            });
            e(cn, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                if (!n) return t ? oe(fn, this, {
                    operator: "||",
                    left: this.condition,
                    right: t
                }) : this.condition.drop_side_effect_free(e);
                if (!t) return oe(fn, this, {
                    operator: "&&",
                    left: this.condition,
                    right: n
                });
                var i = this.clone();
                i.consequent = n;
                i.alternative = t;
                return i;
            });
            e(P, O);
            e(rn, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                return this.expression.drop_side_effect_free(e, n);
            });
            e(qe, function(e) {
                return this.name && e.option("ie8") ? this : null;
            });
            e(an, function(e, n) {
                if (r[this.operator]) {
                    this.write_only = !this.expression.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && this.expression instanceof wn) return null;
                var t = this.expression.drop_side_effect_free(e, n);
                if (n && t && W(t)) {
                    if (t === this.expression && this.operator == "!") return this;
                    return t.negate(e, n);
                }
                return t;
            });
            e(dn, function(e, n) {
                var t = a(this.properties, e, n);
                return t && V(this, t);
            });
            e(I, function(e, n) {
                return this.value.drop_side_effect_free(e, n);
            });
            e(nn, function(e) {
                var n = this.tail_node();
                var t = n.drop_side_effect_free(e);
                if (t === n) return this;
                var i = this.expressions.slice(0, -1);
                if (t) i.push(t);
                return V(this, i);
            });
            e(on, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var i = this.property.drop_side_effect_free(e);
                if (!i) return t;
                return V(this, [ t, i ]);
            });
            e(wn, function(e) {
                return this.is_declared(e) ? null : this;
            });
            e(xn, O);
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(ye, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    n.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return oe(Ae, e);
                }
                if (i !== t) {
                    return oe(ye, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(Ce, function(e, n) {
            return n.option("loops") ? oe(Be, e, e).optimize(n) : e;
        });
        function w(n, e) {
            var t = false;
            var i = new zn(function(e) {
                if (t || e instanceof Oe) return true;
                if (e instanceof Re && i.loopcontrol_target(e) === n) {
                    return t = true;
                }
            });
            if (e instanceof Ee) i.push(e);
            i.push(n);
            n.body.walk(i);
            return t;
        }
        e(Fe, function(e, n) {
            if (!n.option("loops")) return e;
            var t = e.condition.is_truthy() || e.condition.tail_node().evaluate(n);
            if (!(t instanceof _e)) {
                if (t) return oe(Be, e, {
                    body: oe(xe, e.body, {
                        body: [ e.body, oe(ye, e.condition, {
                            body: e.condition
                        }) ]
                    })
                }).optimize(n);
                if (!w(e, n.parent())) {
                    return oe(xe, e.body, {
                        body: [ e.body, oe(ye, e.condition, {
                            body: e.condition
                        }) ]
                    }).optimize(n);
                }
            }
            if (e.body instanceof ye) return oe(Be, e, {
                condition: V(e.condition, [ e.body.body, e.condition ]),
                body: oe(Ae, e)
            }).optimize(n);
            return e;
        });
        function p(n, t) {
            var e = n.body instanceof xe ? n.body.body[0] : n.body;
            if (t.option("dead_code") && r(e)) {
                var i = [];
                if (n.init instanceof me) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(oe(ye, n.init, {
                        body: n.init
                    }));
                }
                if (n.condition) {
                    i.push(oe(ye, n.condition, {
                        body: n.condition
                    }));
                }
                b(t, n.body, i);
                return oe(xe, n, {
                    body: i
                });
            }
            if (e instanceof Pe) {
                if (r(e.body)) {
                    if (n.condition) {
                        n.condition = oe(fn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    o(e.alternative);
                } else if (r(e.alternative)) {
                    if (n.condition) {
                        n.condition = oe(fn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    o(e.body);
                }
            }
            return n;
            function r(e) {
                return e instanceof Ie && t.loopcontrol_target(e) === t.self();
            }
            function o(e) {
                e = x(e);
                if (n.body instanceof xe) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = oe(xe, n.body, {
                        body: e
                    }).transform(t);
                }
                n = p(n, t);
            }
        }
        e(Be, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects") && e.init) {
                e.init = e.init.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (!(t instanceof _e)) {
                    if (t) e.condition = null; else if (!n.option("dead_code")) {
                        var i = e.condition;
                        e.condition = L(t, e.condition);
                        e.condition = y(e.condition.transform(n), i);
                    }
                }
                if (t instanceof _e) {
                    t = e.condition.is_truthy() || e.condition.tail_node().evaluate(n);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        b(n, e.body, r);
                        if (e.init instanceof me) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(oe(ye, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(oe(ye, e.condition, {
                            body: e.condition
                        }));
                        return oe(xe, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof _e)) {
                    e.body = oe(xe, e.body, {
                        body: [ oe(ye, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return p(e, n);
        });
        e(Pe, function(e, n) {
            if (Y(e.alternative)) e.alternative = null;
            if (!n.option("conditionals")) return e;
            var t = e.condition.evaluate(n);
            if (!n.option("dead_code") && !(t instanceof _e)) {
                var i = e.condition;
                e.condition = L(t, i);
                e.condition = y(e.condition.transform(n), i);
            }
            if (n.option("dead_code")) {
                if (t instanceof _e) {
                    t = e.condition.is_truthy() || e.condition.tail_node().evaluate(n);
                }
                if (!t) {
                    n.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var r = [];
                    b(n, e.body, r);
                    r.push(oe(ye, e.condition, {
                        body: e.condition
                    }));
                    if (e.alternative) r.push(e.alternative);
                    return oe(xe, e, {
                        body: r
                    }).optimize(n);
                } else if (!(t instanceof _e)) {
                    n.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var r = [];
                    if (e.alternative) {
                        b(n, e.alternative, r);
                    }
                    r.push(oe(ye, e.condition, {
                        body: e.condition
                    }));
                    r.push(e.body);
                    return oe(xe, e, {
                        body: r
                    }).optimize(n);
                }
            }
            var o = e.condition.negate(n);
            var a = e.condition.print_to_string().length;
            var s = o.print_to_string().length;
            var u = s < a;
            if (e.alternative && u) {
                u = false;
                e.condition = o;
                var f = e.body;
                e.body = e.alternative || oe(Ae, e);
                e.alternative = f;
            }
            if (Y(e.body) && Y(e.alternative)) {
                return oe(ye, e.condition, {
                    body: e.condition.clone()
                }).optimize(n);
            }
            if (e.body instanceof ye && e.alternative instanceof ye) {
                return oe(ye, e, {
                    body: oe(cn, e, {
                        condition: e.condition,
                        consequent: e.body.body,
                        alternative: e.alternative.body
                    })
                }).optimize(n);
            }
            if (Y(e.alternative) && e.body instanceof ye) {
                if (a === s && !u && e.condition instanceof fn && e.condition.operator == "||") {
                    u = true;
                }
                if (u) return oe(ye, e, {
                    body: oe(fn, e, {
                        operator: "||",
                        left: o,
                        right: e.body.body
                    })
                }).optimize(n);
                return oe(ye, e, {
                    body: oe(fn, e, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.body
                    })
                }).optimize(n);
            }
            if (e.body instanceof Ae && e.alternative instanceof ye) {
                return oe(ye, e, {
                    body: oe(fn, e, {
                        operator: "||",
                        left: e.condition,
                        right: e.alternative.body
                    })
                }).optimize(n);
            }
            if (e.body instanceof He && e.alternative instanceof He && e.body.TYPE == e.alternative.TYPE) {
                return oe(e.body.CTOR, e, {
                    value: oe(cn, e, {
                        condition: e.condition,
                        consequent: e.body.value || oe(Cn, e.body),
                        alternative: e.alternative.value || oe(Cn, e.alternative)
                    }).transform(n)
                }).optimize(n);
            }
            if (e.body instanceof Pe && !e.body.alternative && !e.alternative) {
                e = oe(Pe, e, {
                    condition: oe(fn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (E(e.body)) {
                if (e.alternative) {
                    var c = e.alternative;
                    e.alternative = null;
                    return oe(xe, e, {
                        body: [ e, c ]
                    }).optimize(n);
                }
            }
            if (E(e.alternative)) {
                var r = e.body;
                e.body = e.alternative;
                e.condition = u ? o : e.condition.negate(n);
                e.alternative = null;
                return oe(xe, e, {
                    body: [ e, r ]
                }).optimize(n);
            }
            return e;
        });
        e(Ve, function(n, t) {
            if (!t.option("switches")) return n;
            var e;
            var i = n.expression.evaluate(t);
            if (!(i instanceof _e)) {
                var r = n.expression;
                n.expression = L(i, r);
                n.expression = y(n.expression.transform(t), r);
            }
            if (!t.option("dead_code")) return n;
            if (i instanceof _e) {
                i = n.expression.tail_node().evaluate(t);
            }
            var o = [];
            var a = [];
            var s;
            var u;
            for (var f = 0, c = n.body.length; f < c && !u; f++) {
                e = n.body[f];
                if (e instanceof Le) {
                    if (!s) {
                        s = e;
                    } else {
                        g(e, a[a.length - 1]);
                    }
                } else if (!(i instanceof _e)) {
                    var l = e.expression.evaluate(t);
                    if (!(l instanceof _e) && l !== i) {
                        g(e, a[a.length - 1]);
                        continue;
                    }
                    if (l instanceof _e) l = e.expression.tail_node().evaluate(t);
                    if (l === i) {
                        u = e;
                        if (s) {
                            var p = a.indexOf(s);
                            a.splice(p, 1);
                            g(s, a[p - 1]);
                            s = null;
                        }
                    }
                }
                if (E(e)) {
                    var d = a[a.length - 1];
                    if (E(d) && d.body.length == e.body.length && oe(xe, d, d).equivalent_to(oe(xe, e, e))) {
                        d.body = [];
                    }
                }
                a.push(e);
            }
            while (f < c) g(n.body[f++], a[a.length - 1]);
            if (a.length > 0) {
                a[0].body = o.concat(a[0].body);
            }
            n.body = a;
            while (e = a[a.length - 1]) {
                var h = e.body[e.body.length - 1];
                if (h instanceof Ie && t.loopcontrol_target(h) === n) e.body.pop();
                if (e.body.length || e instanceof Ye && (s || e.expression.has_side_effects(t))) break;
                if (a.pop() === s) s = null;
            }
            if (a.length == 0) {
                return oe(xe, n, {
                    body: o.concat(oe(ye, n.expression, {
                        body: n.expression
                    }))
                }).optimize(t);
            }
            if (a.length == 1 && (a[0] === u || a[0] === s)) {
                var v = false;
                var _ = new zn(function(e) {
                    if (v || e instanceof ze || e instanceof ye) return true;
                    if (e instanceof Ie && _.loopcontrol_target(e) === n) v = true;
                });
                n.walk(_);
                if (!v) {
                    var m = a[0].body.slice();
                    var l = a[0].expression;
                    if (l) m.unshift(oe(ye, l, {
                        body: l
                    }));
                    m.unshift(oe(ye, n.expression, {
                        body: n.expression
                    }));
                    return oe(xe, n, {
                        body: m
                    }).optimize(t);
                }
            }
            return n;
            function g(e, n) {
                if (n && !E(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    b(t, e, o);
                }
            }
        });
        e(We, function(e, n) {
            i(e.body, n);
            if (e.bcatch && e.bfinally && he(e.bfinally.body, Y)) e.bfinally = null;
            if (n.option("dead_code") && he(e.body, Y)) {
                var t = [];
                if (e.bcatch) {
                    b(n, e.bcatch, t);
                    t.forEach(function(e) {
                        if (!(e instanceof Xe)) return;
                        e.definitions.forEach(function(e) {
                            var n = e.name.definition().redefined();
                            if (!n) return;
                            e.name = e.name.clone();
                            e.name.thedef = n;
                        });
                    });
                }
                if (e.bfinally) t = t.concat(e.bfinally.body);
                return oe(xe, e, {
                    body: t
                }).optimize(n);
            }
            return e;
        });
        Xe.DEFMETHOD("remove_initializers", function() {
            this.definitions.forEach(function(e) {
                e.value = null;
            });
        });
        Xe.DEFMETHOD("to_assignments", function(e) {
            var i = e.option("reduce_vars");
            var n = this.definitions.reduce(function(e, n) {
                if (n.value) {
                    var t = oe(wn, n.name, n.name);
                    e.push(oe(ln, n, {
                        operator: "=",
                        left: t,
                        right: n.value
                    }));
                    if (i) t.definition().fixed = false;
                }
                n = n.name.definition();
                n.eliminated++;
                n.replaced--;
                return e;
            }, []);
            if (n.length == 0) return null;
            return V(this, n);
        });
        e(Xe, function(e, n) {
            if (e.definitions.length == 0) return oe(Ae, e);
            return e;
        });
        Qe.DEFMETHOD("lift_sequences", function(e) {
            if (!e.option("sequences")) return this;
            var n = this.expression;
            if (!(n instanceof nn)) return this;
            var t = n.tail_node();
            if (a(e, t) && !(this instanceof en)) return this;
            var i = n.expressions.slice(0, -1);
            var r = this.clone();
            r.expression = t;
            i.push(r);
            return V(this, i).optimize(e);
        });
        e(Qe, function(s, r) {
            var e = s.lift_sequences(r);
            if (e !== s) {
                return e;
            }
            var n = s.expression;
            var d = n;
            if (r.option("reduce_vars") && d instanceof wn) {
                d = d.fixed_value();
            }
            var t = d instanceof ze;
            if (r.option("unused") && t && !d.uses_arguments && !d.pinned()) {
                var i = 0, o = 0;
                for (var a = 0, u = s.args.length; a < u; a++) {
                    var f = a >= d.argnames.length;
                    if (f || d.argnames[a].__unused) {
                        var c = s.args[a].drop_side_effect_free(r);
                        if (c) {
                            s.args[i++] = c;
                        } else if (!f) {
                            s.args[i++] = oe(En, s.args[a], {
                                value: 0
                            });
                            continue;
                        }
                    } else {
                        s.args[i++] = s.args[a];
                    }
                    o = i;
                }
                s.args.length = o;
            }
            if (r.option("unsafe")) {
                if (G(n)) switch (n.name) {
                  case "Array":
                    if (s.args.length != 1) {
                        return oe(pn, s, {
                            elements: s.args
                        }).optimize(r);
                    }
                    break;

                  case "Object":
                    if (s.args.length == 0) {
                        return oe(dn, s, {
                            properties: []
                        });
                    }
                    break;

                  case "String":
                    if (s.args.length == 0) return oe(An, s, {
                        value: ""
                    });
                    if (s.args.length <= 1) return oe(fn, s, {
                        left: s.args[0],
                        operator: "+",
                        right: oe(An, s, {
                            value: ""
                        })
                    }).optimize(r);
                    break;

                  case "Number":
                    if (s.args.length == 0) return oe(En, s, {
                        value: 0
                    });
                    if (s.args.length == 1) return oe(sn, s, {
                        expression: s.args[0],
                        operator: "+"
                    }).optimize(r);

                  case "Boolean":
                    if (s.args.length == 0) return oe(On, s);
                    if (s.args.length == 1) return oe(sn, s, {
                        expression: oe(sn, s, {
                            expression: s.args[0],
                            operator: "!"
                        }),
                        operator: "!"
                    }).optimize(r);
                    break;

                  case "RegExp":
                    var l = [];
                    if (he(s.args, function(e) {
                        var n = e.evaluate(r);
                        l.unshift(n);
                        return e !== n;
                    })) {
                        try {
                            return X(r, s, oe(kn, s, {
                                value: RegExp.apply(RegExp, l)
                            }));
                        } catch (e) {
                            r.warn("Error converting {expr} [{file}:{line},{col}]", {
                                expr: s.print_to_string(),
                                file: s.start.file,
                                line: s.start.line,
                                col: s.start.col
                            });
                        }
                    }
                    break;
                } else if (n instanceof rn) switch (n.property) {
                  case "toString":
                    if (s.args.length == 0 && !n.expression.may_throw_on_access(r)) {
                        return oe(fn, s, {
                            left: oe(An, s, {
                                value: ""
                            }),
                            operator: "+",
                            right: n.expression
                        }).optimize(r);
                    }
                    break;

                  case "join":
                    if (n.expression instanceof pn) e: {
                        var p;
                        if (s.args.length > 0) {
                            p = s.args[0].evaluate(r);
                            if (p === s.args[0]) break e;
                        }
                        var h = [];
                        var v = [];
                        n.expression.elements.forEach(function(e) {
                            var n = e.evaluate(r);
                            if (n !== e) {
                                v.push(n);
                            } else {
                                if (v.length > 0) {
                                    h.push(oe(An, s, {
                                        value: v.join(p)
                                    }));
                                    v.length = 0;
                                }
                                h.push(e);
                            }
                        });
                        if (v.length > 0) {
                            h.push(oe(An, s, {
                                value: v.join(p)
                            }));
                        }
                        if (h.length == 0) return oe(An, s, {
                            value: ""
                        });
                        if (h.length == 1) {
                            if (h[0].is_string(r)) {
                                return h[0];
                            }
                            return oe(fn, h[0], {
                                operator: "+",
                                left: oe(An, s, {
                                    value: ""
                                }),
                                right: h[0]
                            });
                        }
                        if (p == "") {
                            var _;
                            if (h[0].is_string(r) || h[1].is_string(r)) {
                                _ = h.shift();
                            } else {
                                _ = oe(An, s, {
                                    value: ""
                                });
                            }
                            return h.reduce(function(e, n) {
                                return oe(fn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, _).optimize(r);
                        }
                        var c = s.clone();
                        c.expression = c.expression.clone();
                        c.expression.expression = c.expression.expression.clone();
                        c.expression.expression.elements = h;
                        return X(r, s, c);
                    }
                    break;

                  case "charAt":
                    if (n.expression.is_string(r)) {
                        var m = s.args[0];
                        var g = m ? m.evaluate(r) : 0;
                        if (g !== m) {
                            return oe(on, n, {
                                expression: n.expression,
                                property: L(g | 0, m || n)
                            }).optimize(r);
                        }
                    }
                    break;

                  case "apply":
                    if (s.args.length == 2 && s.args[1] instanceof pn) {
                        var b = s.args[1].elements.slice();
                        b.unshift(s.args[0]);
                        return oe(Qe, s, {
                            expression: oe(rn, n, {
                                expression: n.expression,
                                property: "call"
                            }),
                            args: b
                        }).optimize(r);
                    }
                    break;

                  case "call":
                    var y = n.expression;
                    if (y instanceof wn) {
                        y = y.fixed_value();
                    }
                    if (y instanceof ze && !y.contains_this()) {
                        return (s.args.length ? V(this, [ s.args[0], oe(Qe, s, {
                            expression: n.expression,
                            args: s.args.slice(1)
                        }) ]) : oe(Qe, s, {
                            expression: n.expression,
                            args: []
                        })).optimize(r);
                    }
                    break;
                }
            }
            if (r.option("unsafe_Function") && G(n) && n.name == "Function") {
                if (s.args.length == 0) return oe(qe, s, {
                    argnames: [],
                    body: []
                });
                if (he(s.args, function(e) {
                    return e instanceof An;
                })) {
                    try {
                        var w = "n(function(" + s.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join(",") + "){" + s.args[s.args.length - 1].value + "})";
                        var x = et(w);
                        var A = {
                            ie8: r.option("ie8")
                        };
                        x.figure_out_scope(A);
                        var E = new ot(r.options);
                        x = x.transform(E);
                        x.figure_out_scope(A);
                        x.compute_char_frequency(A);
                        x.mangle_names(A);
                        var k;
                        x.walk(new zn(function(e) {
                            if (k) return true;
                            if (e instanceof ze) {
                                k = e;
                                return true;
                            }
                        }));
                        var w = rt();
                        xe.prototype._codegen.call(k, k, w);
                        s.args = [ oe(An, s, {
                            value: k.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join(",")
                        }), oe(An, s.args[s.args.length - 1], {
                            value: w.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return s;
                    } catch (e) {
                        if (e instanceof Vn) {
                            r.warn("Error parsing code passed to new Function [{file}:{line},{col}]", s.args[s.args.length - 1].start);
                            r.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var D = t && d.body[0];
            var F = r.option("inline") && !s.is_expr_pure(r);
            if (F && D instanceof Ne) {
                var C = D.value;
                if (!C || C.is_constant_expression()) {
                    if (C) {
                        C = C.clone(true);
                    } else {
                        C = oe(Cn, s);
                    }
                    var b = s.args.concat(C);
                    return V(s, b).optimize(r);
                }
            }
            if (t) {
                var B, C, S, T, O = -1;
                if (F && !d.uses_arguments && !d.pinned() && !(d.name && d instanceof qe) && (C = q(D)) && (n === d || r.option("unused") && (B = n.definition()).references.length == 1 && !Z(r, B) && d.is_constant_expression(n.scope)) && !s.pure && !d.contains_this() && N()) {
                    d._squeezed = true;
                    return V(s, P()).optimize(r);
                }
                if (r.option("side_effects") && he(d.body, Y)) {
                    var b = s.args.concat(oe(Cn, s));
                    return V(s, b).optimize(r);
                }
            }
            if (r.option("drop_console")) {
                if (n instanceof tn) {
                    var $ = n.expression;
                    while ($.expression) {
                        $ = $.expression;
                    }
                    if (G($) && $.name == "console") {
                        return oe(Cn, s).optimize(r);
                    }
                }
            }
            if (r.option("negate_iife") && r.parent() instanceof ye && W(s)) {
                return s.negate(r, true);
            }
            var z = s.evaluate(r);
            if (z !== s) {
                z = L(z, s).optimize(r);
                return X(r, z, s);
            }
            return s;
            function M(e) {
                if (!e) return oe(Cn, s);
                if (e instanceof Ne) {
                    if (!e.value) return oe(Cn, s);
                    return e.value.clone(true);
                }
                if (e instanceof ye) {
                    return oe(sn, e, {
                        operator: "void",
                        expression: e.body.clone(true)
                    });
                }
            }
            function q(e) {
                var n = d.body.length;
                if (r.option("inline") < 3) {
                    return n == 1 && M(e);
                }
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = d.body[t];
                    if (i instanceof Ze) {
                        if (e && !he(i.definitions, function(e) {
                            return !e.value;
                        })) {
                            return false;
                        }
                    } else if (i instanceof Ae) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return M(e);
            }
            function j(e, n) {
                for (var t = 0, i = d.argnames.length; t < i; t++) {
                    var r = d.argnames[t];
                    if (r.__unused) continue;
                    if (!n || e[r.name] || J[r.name] || S.var_names()[r.name]) {
                        return false;
                    }
                    if (T) T.push(r.definition());
                }
                return true;
            }
            function H(e, n) {
                var t = d.body.length;
                for (var i = 0; i < t; i++) {
                    var r = d.body[i];
                    if (!(r instanceof Ze)) continue;
                    if (!n) return false;
                    for (var o = r.definitions.length; --o >= 0; ) {
                        var a = r.definitions[o].name;
                        if (e[a.name] || J[a.name] || S.var_names()[a.name]) {
                            return false;
                        }
                        if (T) T.push(a.definition());
                    }
                }
                return true;
            }
            function N() {
                var e = Object.create(null);
                do {
                    S = r.parent(++O);
                    if (S instanceof Ge) {
                        e[S.argname.name] = true;
                    } else if (S instanceof ke) {
                        T = [];
                    } else if (S instanceof wn) {
                        if (S.fixed_value() instanceof Oe) return false;
                    }
                } while (!(S instanceof Oe));
                var n = !(S instanceof $e) || r.toplevel.vars;
                var t = r.option("inline");
                if (!H(e, t >= 3 && n)) return false;
                if (!j(e, t >= 2 && n)) return false;
                return !T || T.length == 0 || !K(d, T);
            }
            function R(e, n, t, i) {
                var r = t.definition();
                S.variables.set(t.name, r);
                S.enclosed.push(r);
                if (!S.var_names()[t.name]) {
                    S.var_names()[t.name] = true;
                    e.push(oe(Ke, t, {
                        name: t,
                        value: null
                    }));
                }
                var o = oe(wn, t, t);
                r.references.push(o);
                if (i) n.push(oe(ln, s, {
                    operator: "=",
                    left: o,
                    right: i
                }));
            }
            function I(e, n) {
                var t = d.argnames.length;
                for (var i = s.args.length; --i >= t; ) {
                    n.push(s.args[i]);
                }
                for (i = t; --i >= 0; ) {
                    var r = d.argnames[i];
                    var o = s.args[i];
                    if (r.__unused || S.var_names()[r.name]) {
                        if (o) n.push(o);
                    } else {
                        var a = oe(_n, r, r);
                        r.definition().orig.push(a);
                        if (!o && T) o = oe(Cn, s);
                        R(e, n, a, o);
                    }
                }
                e.reverse();
                n.reverse();
            }
            function U(e, n) {
                var t = n.length;
                for (var i = 0, r = d.body.length; i < r; i++) {
                    var o = d.body[i];
                    if (!(o instanceof Ze)) continue;
                    for (var a = 0, s = o.definitions.length; a < s; a++) {
                        var u = o.definitions[a];
                        var f = u.name;
                        var c = f.definition().redefined();
                        if (c) {
                            f = f.clone();
                            f.thedef = c;
                        }
                        R(e, n, f, u.value);
                        if (T && he(d.argnames, function(e) {
                            return e.name != f.name;
                        })) {
                            var l = d.variables.get(f.name);
                            var p = oe(wn, f, f);
                            l.references.push(p);
                            n.splice(t++, 0, oe(ln, u, {
                                operator: "=",
                                left: p,
                                right: oe(Cn, f)
                            }));
                        }
                    }
                }
            }
            function P() {
                var e = [];
                var n = [];
                I(e, n);
                U(e, n);
                n.push(C);
                if (e.length) {
                    a = S.body.indexOf(r.parent(O - 1)) + 1;
                    S.body.splice(a, 0, oe(Ze, d, {
                        definitions: e
                    }));
                }
                return n;
            }
        });
        e(en, function(e, n) {
            var t = e.lift_sequences(n);
            if (t !== e) {
                return t;
            }
            if (n.option("unsafe")) {
                var i = e.expression;
                if (G(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return oe(Qe, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        e(nn, function(e, r) {
            if (!r.option("side_effects")) return e;
            var o = [];
            t();
            var n = o.length - 1;
            i();
            if (n == 0) {
                e = ae(r, r.parent(), r.self(), o[0]);
                if (!(e instanceof nn)) e = e.optimize(r);
                return e;
            }
            e.expressions = o;
            return e;
            function t() {
                var t = q(r);
                var i = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < i) e = e.drop_side_effect_free(r, t);
                    if (e) {
                        h(o, e);
                        t = false;
                    }
                });
            }
            function i() {
                while (n > 0 && g(o[n], r)) n--;
                if (n < o.length - 1) {
                    o[n] = oe(sn, e, {
                        operator: "void",
                        expression: o[n]
                    });
                    o.length = n + 1;
                }
            }
        });
        an.DEFMETHOD("lift_sequences", function(e) {
            if (e.option("sequences") && this.expression instanceof nn) {
                var n = this.expression.expressions.slice();
                var t = this.clone();
                t.expression = n.pop();
                n.push(t);
                return V(this, n).optimize(e);
            }
            return this;
        });
        e(un, function(e, n) {
            return e.lift_sequences(n);
        });
        e(sn, function(e, n) {
            var t = e.expression;
            if (e.operator == "delete" && !(t instanceof wn || t instanceof tn || s(t))) {
                if (t instanceof nn) {
                    t = t.expressions.slice();
                    t.push(oe($n, e));
                    return V(e, t).optimize(n);
                }
                return V(e, [ t, oe($n, e) ]).optimize(n);
            }
            var i = e.lift_sequences(n);
            if (i !== e) {
                return i;
            }
            if (n.option("side_effects") && e.operator == "void") {
                t = t.drop_side_effect_free(n);
                if (t) {
                    e.expression = t;
                    return e;
                } else {
                    return oe(Cn, e).optimize(n);
                }
            }
            if (n.option("booleans")) {
                if (e.operator == "!" && t.is_truthy()) {
                    return V(e, [ t, oe(On, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (e.operator) {
                  case "!":
                    if (t instanceof sn && t.operator == "!") {
                        return t.expression;
                    }
                    if (t instanceof fn) {
                        e = X(n, e, t.negate(n, q(n)));
                    }
                    break;

                  case "typeof":
                    n.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    return (t instanceof wn ? oe($n, e) : V(e, [ t, oe($n, e) ])).optimize(n);
                }
            }
            if (e.operator == "-" && t instanceof Sn) {
                t = t.transform(n);
            }
            if (t instanceof fn && (e.operator == "+" || e.operator == "-") && (t.operator == "*" || t.operator == "/" || t.operator == "%")) {
                return oe(fn, e, {
                    operator: t.operator,
                    left: oe(sn, t.left, {
                        operator: e.operator,
                        expression: t.left
                    }),
                    right: t.right
                });
            }
            if (e.operator != "-" || !(t instanceof En || t instanceof Sn)) {
                var r = e.evaluate(n);
                if (r !== e) {
                    r = L(r, e).optimize(n);
                    return X(n, r, e);
                }
            }
            return e;
        });
        fn.DEFMETHOD("lift_sequences", function(e) {
            if (e.option("sequences")) {
                if (this.left instanceof nn) {
                    var n = this.left.expressions.slice();
                    var t = this.clone();
                    t.left = n.pop();
                    n.push(t);
                    return V(this, n).optimize(e);
                }
                if (this.right instanceof nn && !this.left.has_side_effects(e)) {
                    var i = this.operator == "=" && this.left instanceof wn;
                    var n = this.right.expressions;
                    var r = n.length - 1;
                    for (var o = 0; o < r; o++) {
                        if (!i && n[o].has_side_effects(e)) break;
                    }
                    if (o == r) {
                        n = n.slice();
                        var t = this.clone();
                        t.right = n.pop();
                        n.push(t);
                        return V(this, n).optimize(e);
                    } else if (o > 0) {
                        var t = this.clone();
                        t.right = V(this.right, n.slice(o));
                        n = n.slice(0, o);
                        n.push(t);
                        return V(this, n).optimize(e);
                    }
                }
            }
            return this;
        });
        var k = de("== === != !== * & | ^");
        function D(e) {
            return e instanceof pn || e instanceof ze || e instanceof dn;
        }
        e(fn, function(t, n) {
            function i() {
                return t.left.is_constant() || t.right.is_constant() || !t.left.has_side_effects(n) && !t.right.has_side_effects(n);
            }
            function e(e) {
                if (i()) {
                    if (e) t.operator = e;
                    var n = t.left;
                    t.left = t.right;
                    t.right = n;
                }
            }
            if (k[t.operator]) {
                if (t.right.is_constant() && !t.left.is_constant()) {
                    if (!(t.left instanceof fn && Kn[t.left.operator] >= Kn[t.operator])) {
                        e();
                    }
                }
            }
            t = t.lift_sequences(n);
            if (n.option("comparisons")) switch (t.operator) {
              case "===":
              case "!==":
                var r = true;
                if (t.left.is_string(n) && t.right.is_string(n) || t.left.is_number(n) && t.right.is_number(n) || t.left.is_boolean(n) && t.right.is_boolean(n) || t.left.equivalent_to(t.right)) {
                    t.operator = t.operator.substr(0, 2);
                }

              case "==":
              case "!=":
                if (!r && g(t.left, n)) {
                    t.left = oe(Dn, t.left);
                } else if (n.option("typeofs") && t.left instanceof An && t.left.value == "undefined" && t.right instanceof sn && t.right.operator == "typeof") {
                    var o = t.right.expression;
                    if (o instanceof wn ? o.is_declared(n) : !(o instanceof tn && n.option("ie8"))) {
                        t.right = o;
                        t.left = oe(Cn, t.left).optimize(n);
                        if (t.operator.length == 2) t.operator += "=";
                    }
                } else if (t.left instanceof wn && t.right instanceof wn && t.left.definition() === t.right.definition() && D(t.left.fixed_value())) {
                    return oe(t.operator[0] == "=" ? $n : On, t);
                }
                break;

              case "&&":
              case "||":
                var a = t.left;
                if (a.operator == t.operator) {
                    a = a.right;
                }
                if (a instanceof fn && a.operator == (t.operator == "&&" ? "!==" : "===") && t.right instanceof fn && a.operator == t.right.operator && (g(a.left, n) && t.right.left instanceof Dn || a.left instanceof Dn && g(t.right.left, n)) && !a.right.has_side_effects(n) && a.right.equivalent_to(t.right.right)) {
                    var s = oe(fn, t, {
                        operator: a.operator.slice(0, -1),
                        left: oe(Dn, t),
                        right: a.right
                    });
                    if (a !== t.left) {
                        s = oe(fn, t, {
                            operator: t.operator,
                            left: t.left.left,
                            right: s
                        });
                    }
                    return s;
                }
                break;
            }
            if (n.option("booleans") && t.operator == "+" && n.in_boolean_context()) {
                var u = t.left.evaluate(n);
                var f = t.right.evaluate(n);
                if (u && typeof u == "string") {
                    n.warn("+ in boolean context always true [{file}:{line},{col}]", t.start);
                    return V(t, [ t.right, oe($n, t) ]).optimize(n);
                }
                if (f && typeof f == "string") {
                    n.warn("+ in boolean context always true [{file}:{line},{col}]", t.start);
                    return V(t, [ t.left, oe($n, t) ]).optimize(n);
                }
            }
            if (n.option("comparisons") && t.is_boolean(n)) {
                if (!(n.parent() instanceof fn) || n.parent() instanceof ln) {
                    var c = oe(sn, t, {
                        operator: "!",
                        expression: t.negate(n, q(n))
                    });
                    t = X(n, t, c);
                }
                switch (t.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (t.operator == "+") {
                if (t.right instanceof An && t.right.getValue() == "" && t.left.is_string(n)) {
                    return t.left;
                }
                if (t.left instanceof An && t.left.getValue() == "" && t.right.is_string(n)) {
                    return t.right;
                }
                if (t.left instanceof fn && t.left.operator == "+" && t.left.left instanceof An && t.left.left.getValue() == "" && t.right.is_string(n)) {
                    t.left = t.left.right;
                    return t.transform(n);
                }
            }
            if (n.option("evaluate")) {
                switch (t.operator) {
                  case "&&":
                    var u = _(t.left);
                    if (!u) {
                        n.warn("Condition left of && always false [{file}:{line},{col}]", t.start);
                        return ae(n, n.parent(), n.self(), t.left).optimize(n);
                    } else if (!(u instanceof _e)) {
                        n.warn("Condition left of && always true [{file}:{line},{col}]", t.start);
                        return V(t, [ t.left, t.right ]).optimize(n);
                    }
                    var f = t.right.evaluate(n);
                    if (!f) {
                        if (n.option("booleans") && n.in_boolean_context()) {
                            n.warn("Boolean && always false [{file}:{line},{col}]", t.start);
                            return V(t, [ t.left, oe(On, t) ]).optimize(n);
                        } else t.falsy = true;
                    } else if (!(f instanceof _e)) {
                        var l = n.parent();
                        if (l.operator == "&&" && l.left === n.self() || n.option("booleans") && n.in_boolean_context()) {
                            n.warn("Dropping side-effect-free && [{file}:{line},{col}]", t.start);
                            return t.left.optimize(n);
                        }
                    }
                    if (t.left.operator == "||") {
                        var p = t.left.right.evaluate(n);
                        if (!p) return oe(cn, t, {
                            condition: t.left.left,
                            consequent: t.right,
                            alternative: t.left.right
                        }).optimize(n);
                    }
                    break;

                  case "||":
                    var u = _(t.left);
                    if (!u) {
                        n.warn("Condition left of || always false [{file}:{line},{col}]", t.start);
                        return V(t, [ t.left, t.right ]).optimize(n);
                    } else if (!(u instanceof _e)) {
                        n.warn("Condition left of || always true [{file}:{line},{col}]", t.start);
                        return ae(n, n.parent(), n.self(), t.left).optimize(n);
                    }
                    var f = t.right.evaluate(n);
                    if (!f) {
                        var l = n.parent();
                        if (l.operator == "||" && l.left === n.self() || n.option("booleans") && n.in_boolean_context()) {
                            n.warn("Dropping side-effect-free || [{file}:{line},{col}]", t.start);
                            return t.left.optimize(n);
                        }
                    } else if (!(f instanceof _e)) {
                        if (n.option("booleans") && n.in_boolean_context()) {
                            n.warn("Boolean || always true [{file}:{line},{col}]", t.start);
                            return V(t, [ t.left, oe($n, t) ]).optimize(n);
                        } else t.truthy = true;
                    }
                    if (t.left.operator == "&&") {
                        var p = t.left.right.evaluate(n);
                        if (p && !(p instanceof _e)) return oe(cn, t, {
                            condition: t.left.left,
                            consequent: t.left.right,
                            alternative: t.right
                        }).optimize(n);
                    }
                    break;
                }
                var d = true;
                switch (t.operator) {
                  case "+":
                    if (t.left instanceof P && t.right instanceof fn && t.right.operator == "+" && t.right.left instanceof P && t.right.is_string(n)) {
                        t = oe(fn, t, {
                            operator: "+",
                            left: oe(An, t.left, {
                                value: "" + t.left.getValue() + t.right.left.getValue(),
                                start: t.left.start,
                                end: t.right.left.end
                            }),
                            right: t.right.right
                        });
                    }
                    if (t.right instanceof P && t.left instanceof fn && t.left.operator == "+" && t.left.right instanceof P && t.left.is_string(n)) {
                        t = oe(fn, t, {
                            operator: "+",
                            left: t.left.left,
                            right: oe(An, t.right, {
                                value: "" + t.left.right.getValue() + t.right.getValue(),
                                start: t.left.right.start,
                                end: t.right.end
                            })
                        });
                    }
                    if (t.left instanceof fn && t.left.operator == "+" && t.left.is_string(n) && t.left.right instanceof P && t.right instanceof fn && t.right.operator == "+" && t.right.left instanceof P && t.right.is_string(n)) {
                        t = oe(fn, t, {
                            operator: "+",
                            left: oe(fn, t.left, {
                                operator: "+",
                                left: t.left.left,
                                right: oe(An, t.left.right, {
                                    value: "" + t.left.right.getValue() + t.right.left.getValue(),
                                    start: t.left.right.start,
                                    end: t.right.left.end
                                })
                            }),
                            right: t.right.right
                        });
                    }
                    if (t.right instanceof sn && t.right.operator == "-" && t.left.is_number(n)) {
                        t = oe(fn, t, {
                            operator: "-",
                            left: t.left,
                            right: t.right.expression
                        });
                        break;
                    }
                    if (t.left instanceof sn && t.left.operator == "-" && i() && t.right.is_number(n)) {
                        t = oe(fn, t, {
                            operator: "-",
                            left: t.right,
                            right: t.left.expression
                        });
                        break;
                    }

                  case "*":
                    d = n.option("unsafe_math");

                  case "&":
                  case "|":
                  case "^":
                    if (t.left.is_number(n) && t.right.is_number(n) && i() && !(t.left instanceof fn && t.left.operator != t.operator && Kn[t.left.operator] >= Kn[t.operator])) {
                        var h = oe(fn, t, {
                            operator: t.operator,
                            left: t.right,
                            right: t.left
                        });
                        if (t.right instanceof P && !(t.left instanceof P)) {
                            t = X(n, h, t);
                        } else {
                            t = X(n, t, h);
                        }
                    }
                    if (d && t.is_number(n)) {
                        if (t.right instanceof fn && t.right.operator == t.operator) {
                            t = oe(fn, t, {
                                operator: t.operator,
                                left: oe(fn, t.left, {
                                    operator: t.operator,
                                    left: t.left,
                                    right: t.right.left,
                                    start: t.left.start,
                                    end: t.right.left.end
                                }),
                                right: t.right.right
                            });
                        }
                        if (t.right instanceof P && t.left instanceof fn && t.left.operator == t.operator) {
                            if (t.left.left instanceof P) {
                                t = oe(fn, t, {
                                    operator: t.operator,
                                    left: oe(fn, t.left, {
                                        operator: t.operator,
                                        left: t.left.left,
                                        right: t.right,
                                        start: t.left.left.start,
                                        end: t.right.end
                                    }),
                                    right: t.left.right
                                });
                            } else if (t.left.right instanceof P) {
                                t = oe(fn, t, {
                                    operator: t.operator,
                                    left: oe(fn, t.left, {
                                        operator: t.operator,
                                        left: t.left.right,
                                        right: t.right,
                                        start: t.left.right.start,
                                        end: t.right.end
                                    }),
                                    right: t.left.left
                                });
                            }
                        }
                        if (t.left instanceof fn && t.left.operator == t.operator && t.left.right instanceof P && t.right instanceof fn && t.right.operator == t.operator && t.right.left instanceof P) {
                            t = oe(fn, t, {
                                operator: t.operator,
                                left: oe(fn, t.left, {
                                    operator: t.operator,
                                    left: oe(fn, t.left.left, {
                                        operator: t.operator,
                                        left: t.left.right,
                                        right: t.right.left,
                                        start: t.left.right.start,
                                        end: t.right.left.end
                                    }),
                                    right: t.left.left
                                }),
                                right: t.right.right
                            });
                        }
                    }
                }
            }
            if (t.right instanceof fn && t.right.operator == t.operator && (ue[t.operator] || t.operator == "+" && (t.right.left.is_string(n) || t.left.is_string(n) && t.right.right.is_string(n)))) {
                t.left = oe(fn, t.left, {
                    operator: t.operator,
                    left: t.left,
                    right: t.right.left
                });
                t.right = t.right.right;
                return t.transform(n);
            }
            var v = t.evaluate(n);
            if (v !== t) {
                v = L(v, t).optimize(n);
                return X(n, v, t);
            }
            return t;
            function _(e) {
                if (e.truthy) return true;
                if (e.falsy) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(n);
            }
        });
        function Z(e, n) {
            var t;
            for (var i = 0; t = e.parent(i); i++) {
                if (t instanceof ze) {
                    var r = t.name;
                    if (r && r.definition() === n) break;
                }
            }
            return t;
        }
        e(wn, function(e, n) {
            if (!n.option("ie8") && G(e) && !(e.scope.uses_with && n.find_parent(Te))) {
                switch (e.name) {
                  case "undefined":
                    return oe(Cn, e).optimize(n);

                  case "NaN":
                    return oe(Fn, e).optimize(n);

                  case "Infinity":
                    return oe(Sn, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && fe(e, t) !== e) {
                var i = e.definition();
                var r = e.fixed_value();
                var o = i.single_use && !(t instanceof Qe && t.is_expr_pure(n));
                if (o && r instanceof ze) {
                    if (i.scope !== e.scope && (!n.option("reduce_funcs") || i.escaped == 1 || r.inlined)) {
                        o = false;
                    } else if (Z(n, i)) {
                        o = false;
                    } else if (i.scope !== e.scope || i.orig[0] instanceof mn) {
                        o = r.is_constant_expression(e.scope);
                        if (o == "f") {
                            var a = e.scope;
                            do {
                                if (a instanceof je || a instanceof qe) {
                                    a.inlined = true;
                                }
                            } while (a = a.parent_scope);
                        }
                    }
                }
                if (o && r) {
                    i.single_use = false;
                    if (r instanceof je) {
                        r._squeezed = true;
                        r = oe(qe, r, r);
                        r.name = oe(bn, r.name, r.name);
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = r.clone(true);
                        var u = s.name.definition();
                        var f = s.variables.get(s.name.name);
                        var c = f && f.orig[0];
                        if (!(c instanceof bn)) {
                            c = oe(bn, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            f = s.def_function(c);
                        }
                        s.walk(new zn(function(e) {
                            if (!(e instanceof wn)) return;
                            var n = e.definition();
                            if (n === u) {
                                e.thedef = f;
                                f.references.push(e);
                            } else {
                                n.single_use = false;
                            }
                        }));
                    } else {
                        s = r.optimize(n);
                        if (s === r) s = r.clone(true);
                    }
                    return s;
                }
                if (r && i.should_replace === undefined) {
                    var l;
                    if (r instanceof xn) {
                        if (!(i.orig[0] instanceof mn) && he(i.references, function(e) {
                            return i.scope === e.scope;
                        })) {
                            l = r;
                        }
                    } else {
                        var p = r.evaluate(n);
                        if (p !== r && (n.option("unsafe_regexp") || !(p instanceof RegExp))) {
                            l = L(p, r);
                        }
                    }
                    if (l) {
                        var d = l.optimize(n).print_to_string().length;
                        var h;
                        if (m(r)) {
                            h = function() {
                                var e = l.optimize(n);
                                return e === l ? e.clone(true) : e;
                            };
                        } else {
                            d = Math.min(d, r.print_to_string().length);
                            h = function() {
                                var e = y(l.optimize(n), r);
                                return e === l || e === r ? e.clone(true) : e;
                            };
                        }
                        var v = i.name.length;
                        var _ = 0;
                        if (n.option("unused") && !n.exposed(i)) {
                            _ = (v + 2 + d) / (i.references.length - i.assignments);
                        }
                        i.should_replace = d <= v + _ ? h : false;
                    } else {
                        i.should_replace = false;
                    }
                }
                if (i.should_replace) {
                    return i.should_replace();
                }
            }
            return e;
            function m(e) {
                var n;
                e.walk(new zn(function(e) {
                    if (e instanceof wn) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function F(e, n) {
            return e instanceof wn || e.TYPE === n.TYPE;
        }
        e(Cn, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = o(n, "undefined");
                if (t) {
                    var i = oe(wn, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = fe(n.self(), n.parent());
            if (r && F(r, e)) return e;
            return oe(sn, e, {
                operator: "void",
                expression: oe(En, e, {
                    value: 0
                })
            });
        });
        e(Sn, function(e, n) {
            var t = fe(n.self(), n.parent());
            if (t && F(t, e)) return e;
            if (n.option("keep_infinity") && !(t && !F(t, e)) && !o(n, "Infinity")) return e;
            return oe(fn, e, {
                operator: "/",
                left: oe(En, e, {
                    value: 1
                }),
                right: oe(En, e, {
                    value: 0
                })
            });
        });
        e(Fn, function(e, n) {
            var t = fe(n.self(), n.parent());
            if (t && !F(t, e) || o(n, "NaN")) {
                return oe(fn, e, {
                    operator: "/",
                    left: oe(En, e, {
                        value: 0
                    }),
                    right: oe(En, e, {
                        value: 0
                    })
                });
            }
            return e;
        });
        function K(t, n) {
            var i = false;
            var r = new zn(function(e) {
                if (i) return true;
                if (e instanceof wn && ce(e.definition(), n)) {
                    return i = true;
                }
            });
            var o = new zn(function(e) {
                if (i) return true;
                if (e instanceof Oe && e !== t) {
                    var n = o.parent();
                    if (n instanceof Qe && n.expression === e) return;
                    e.walk(r);
                    return true;
                }
            });
            t.walk(o);
            return i;
        }
        var C = de("+ - / * % >> << >>> | ^ &");
        var B = de("* | ^ &");
        e(ln, function(a, s) {
            var e;
            if (s.option("dead_code") && a.left instanceof wn && (e = a.left.definition()).scope === s.find_parent(ze)) {
                var n = 0, t, i = a;
                do {
                    t = i;
                    i = s.parent(n++);
                    if (i instanceof He) {
                        if (r(n, i)) break;
                        if (K(e.scope, [ e ])) break;
                        if (a.operator == "=") return a.right;
                        e.fixed = false;
                        return oe(fn, a, {
                            operator: a.operator.slice(0, -1),
                            left: a.left,
                            right: a.right
                        }).optimize(s);
                    }
                } while (i instanceof fn && i.right === t || i instanceof nn && i.tail_node() === t);
            }
            a = a.lift_sequences(s);
            if (a.operator == "=" && a.left instanceof wn && a.right instanceof fn) {
                if (a.right.left instanceof wn && a.right.left.name == a.left.name && C[a.right.operator]) {
                    a.operator = a.right.operator + "=";
                    a.right = a.right.right;
                } else if (a.right.right instanceof wn && a.right.right.name == a.left.name && B[a.right.operator] && !a.right.left.has_side_effects(s)) {
                    a.operator = a.right.operator + "=";
                    a.right = a.right.left;
                }
            }
            return a;
            function r(e, n) {
                var t = a.right;
                a.right = oe(Dn, t);
                var i = n.may_throw(s);
                a.right = t;
                var r = a.left.definition().scope;
                var o;
                while ((o = s.parent(e++)) !== r) {
                    if (o instanceof We) {
                        if (o.bfinally) return true;
                        if (i && o.bcatch) return true;
                    }
                }
            }
        });
        e(cn, function(e, n) {
            if (!n.option("conditionals")) return e;
            if (e.condition instanceof nn) {
                var t = e.condition.expressions.slice();
                e.condition = t.pop();
                t.push(e);
                return V(e, t);
            }
            var i = e.condition.is_truthy() || e.condition.tail_node().evaluate(n);
            if (!i) {
                n.warn("Condition always false [{file}:{line},{col}]", e.start);
                return V(e, [ e.condition, e.alternative ]).optimize(n);
            } else if (!(i instanceof _e)) {
                n.warn("Condition always true [{file}:{line},{col}]", e.start);
                return V(e, [ e.condition, e.consequent ]).optimize(n);
            }
            var r = i.negate(n, q(n));
            if (X(n, i, r) === r) {
                e = oe(cn, e, {
                    condition: r,
                    consequent: e.alternative,
                    alternative: e.consequent
                });
            }
            var o = e.condition;
            var a = e.consequent;
            var s = e.alternative;
            if (o instanceof wn && a instanceof wn && o.definition() === a.definition()) {
                return oe(fn, e, {
                    operator: "||",
                    left: o,
                    right: s
                });
            }
            var u = a.tail_node();
            if (u instanceof ln) {
                var f = u.operator == "=";
                var c = f ? s.tail_node() : s;
                if ((f || a instanceof ln) && c instanceof ln && u.operator == c.operator && u.left.equivalent_to(c.left) && (!o.has_side_effects(n) || f && !u.left.has_side_effects(n))) {
                    return oe(ln, e, {
                        operator: u.operator,
                        left: u.left,
                        right: oe(cn, e, {
                            condition: o,
                            consequent: g(a),
                            alternative: g(s)
                        })
                    });
                }
            }
            var l;
            if (a instanceof Qe && s.TYPE === a.TYPE && a.args.length > 0 && a.args.length == s.args.length && a.expression.equivalent_to(s.expression) && !o.has_side_effects(n) && !a.expression.has_side_effects(n) && typeof (l = m()) == "number") {
                var p = a.clone();
                p.args[l] = oe(cn, e, {
                    condition: o,
                    consequent: a.args[l],
                    alternative: s.args[l]
                });
                return p;
            }
            if (a instanceof cn && a.alternative.equivalent_to(s)) {
                return oe(cn, e, {
                    condition: oe(fn, e, {
                        left: o,
                        operator: "&&",
                        right: a.condition
                    }),
                    consequent: a.consequent,
                    alternative: s
                });
            }
            if (a.equivalent_to(s)) {
                return V(e, [ o, a ]).optimize(n);
            }
            if ((a instanceof nn || s instanceof nn) && a.tail_node().equivalent_to(s.tail_node())) {
                return V(e, [ oe(cn, e, {
                    condition: o,
                    consequent: b(a),
                    alternative: b(s)
                }), a.tail_node() ]).optimize(n);
            }
            if (a instanceof fn && a.operator == "||" && a.right.equivalent_to(s)) {
                return oe(fn, e, {
                    operator: "||",
                    left: oe(fn, e, {
                        operator: "&&",
                        left: o,
                        right: a.left
                    }),
                    right: s
                }).optimize(n);
            }
            var d = n.option("booleans") && n.in_boolean_context();
            if (v(e.consequent)) {
                if (_(e.alternative)) {
                    return h(o);
                }
                return oe(fn, e, {
                    operator: "||",
                    left: h(o),
                    right: e.alternative
                });
            }
            if (_(e.consequent)) {
                if (v(e.alternative)) {
                    return h(o.negate(n));
                }
                return oe(fn, e, {
                    operator: "&&",
                    left: h(o.negate(n)),
                    right: e.alternative
                });
            }
            if (v(e.alternative)) {
                return oe(fn, e, {
                    operator: "||",
                    left: h(o.negate(n)),
                    right: e.consequent
                });
            }
            if (_(e.alternative)) {
                return oe(fn, e, {
                    operator: "&&",
                    left: h(o),
                    right: e.consequent
                });
            }
            return e;
            function h(e) {
                if (e.is_boolean(n)) return e;
                return oe(sn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function v(e) {
                return e instanceof $n || d && e instanceof P && e.getValue() || e instanceof sn && e.operator == "!" && e.expression instanceof P && !e.expression.getValue();
            }
            function _(e) {
                return e instanceof On || d && e instanceof P && !e.getValue() || e instanceof sn && e.operator == "!" && e.expression instanceof P && e.expression.getValue();
            }
            function m() {
                var e = a.args;
                var n = s.args;
                for (var t = 0, i = e.length; t < i; t++) {
                    if (!e[t].equivalent_to(n[t])) {
                        for (var r = t + 1; r < i; r++) {
                            if (!e[r].equivalent_to(n[r])) return;
                        }
                        return t;
                    }
                }
            }
            function g(e) {
                if (!(e instanceof nn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return V(e, n);
            }
            function b(e) {
                if (!(e instanceof nn)) return oe(En, e, {
                    value: 0
                });
                return V(e, e.expressions.slice(0, -1));
            }
        });
        e(Tn, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return oe(En, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof fn && (t.operator == "==" || t.operator == "!=")) {
                n.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return oe(En, e, {
                    value: +e.value
                });
            }
            return oe(sn, e, {
                operator: "!",
                expression: oe(En, e, {
                    value: 1 - e.value
                })
            });
        });
        function S(e, n) {
            if (e instanceof wn) {
                e = e.fixed_value();
            }
            if (!e) return false;
            return !(e instanceof ze) || n.parent() instanceof en || !e.contains_this();
        }
        e(on, function(e, n) {
            var t = e.expression;
            var i = e.property;
            if (n.option("properties")) {
                var r = i.evaluate(n);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var o = parseFloat(r);
                            if (o.toString() == r) {
                                r = o;
                            }
                        }
                    }
                    i = e.property = y(i, L(r, i).transform(n));
                    var a = "" + r;
                    if (Un(a) && a.length <= i.print_to_string().length + 1) {
                        return oe(rn, e, {
                            expression: t,
                            property: a
                        }).optimize(n);
                    }
                }
            }
            var s;
            if (n.option("arguments") && t instanceof wn && t.name == "arguments" && t.definition().orig.length == 1 && (s = t.scope) instanceof ze && i instanceof En) {
                var u = i.getValue();
                var f = s.argnames[u];
                if (f && n.has_directive("use strict")) {
                    var c = f.definition();
                    if (!n.option("reduce_vars") || c.assignments || c.orig.length > 1) {
                        f = null;
                    }
                } else if (!f && !n.option("keep_fargs") && u < s.argnames.length + 5) {
                    while (u >= s.argnames.length) {
                        f = oe(mn, s, {
                            name: s.make_var_name("argument_" + s.argnames.length),
                            scope: s
                        });
                        s.argnames.push(f);
                        s.enclosed.push(s.def_variable(f));
                    }
                }
                if (f && ne(function(e) {
                    return e.name === f.name;
                }, s.argnames) === f) {
                    var l = oe(wn, e, f);
                    l.reference({});
                    delete f.__unused;
                    return l;
                }
            }
            if (fe(e, n.parent())) return e;
            if (r !== i) {
                var p = e.flatten_object(a, n);
                if (p) {
                    t = e.expression = p.expression;
                    i = e.property = p.property;
                }
            }
            if (n.option("properties") && n.option("side_effects") && i instanceof En && t instanceof pn) {
                var u = i.getValue();
                var d = t.elements;
                var h = d[u];
                if (S(h, n)) {
                    var v = true;
                    var _ = [];
                    for (var m = d.length; --m > u; ) {
                        var o = d[m].drop_side_effect_free(n);
                        if (o) {
                            _.unshift(o);
                            if (v && o.has_side_effects(n)) v = false;
                        }
                    }
                    h = h instanceof Bn ? oe(Cn, h) : h;
                    if (!v) _.unshift(h);
                    while (--m >= 0) {
                        var o = d[m].drop_side_effect_free(n);
                        if (o) _.unshift(o); else u--;
                    }
                    if (v) {
                        _.push(h);
                        return V(e, _).optimize(n);
                    } else return oe(on, e, {
                        expression: oe(pn, t, {
                            elements: _
                        }),
                        property: oe(En, i, {
                            value: u
                        })
                    });
                }
            }
            var g = e.evaluate(n);
            if (g !== e) {
                g = L(g, e).optimize(n);
                return X(n, g, e);
            }
            return e;
        });
        Oe.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new zn(function(e) {
                if (n) return true;
                if (e instanceof xn) return n = true;
                if (e !== t && e instanceof Oe) return true;
            }));
            return n;
        });
        tn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof dn) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var o = i[r];
                    if ("" + o.key == e) {
                        if (!he(i, function(e) {
                            return e instanceof hn;
                        })) break;
                        if (!S(o.value, n)) break;
                        return oe(on, this, {
                            expression: oe(pn, t, {
                                elements: i.map(function(e) {
                                    return e.value;
                                })
                            }),
                            property: oe(En, this, {
                                value: r
                            })
                        });
                    }
                }
            }
        });
        e(rn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                n.warn("Function.protoype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            if (fe(e, n.parent())) return e;
            if (n.option("unsafe_proto") && e.expression instanceof rn && e.expression.property == "prototype") {
                var t = e.expression.expression;
                if (G(t)) switch (t.name) {
                  case "Array":
                    e.expression = oe(pn, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = oe(qe, e.expression, {
                        argnames: [],
                        body: []
                    });
                    break;

                  case "Number":
                    e.expression = oe(En, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = oe(dn, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = oe(kn, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = oe(An, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var i = e.flatten_object(e.property, n);
            if (i) return i.optimize(n);
            var r = e.evaluate(n);
            if (r !== e) {
                r = L(r, e).optimize(n);
                return X(n, r, e);
            }
            return e;
        });
        e(Ne, function(e, n) {
            if (e.value && g(e.value, n)) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function x(u) {
        u = te(u, {
            file: null,
            root: null,
            orig: null,
            orig_line_diff: 0,
            dest_line_diff: 0
        }, true);
        var f = new MOZ_SourceMap.SourceMapGenerator({
            file: u.file,
            sourceRoot: u.root
        });
        var c = u.orig && Object.create(null);
        if (c) for (var e in u.orig) {
            var t = new MOZ_SourceMap.SourceMapConsumer(u.orig[e]);
            if (Array.isArray(u.orig[e].sources)) {
                t._sources.toArray().forEach(function(e) {
                    var n = t.sourceContentFor(e, true);
                    if (n) f.setSourceContent(e, n);
                });
            }
            c[e] = t;
        }
        return {
            add: function(e, n, t, i, r, o) {
                var a = c && c[e];
                if (a) {
                    var s = a.originalPositionFor({
                        line: i,
                        column: r
                    });
                    if (s.source === null) return;
                    e = s.source;
                    i = s.line;
                    r = s.column;
                    o = s.name || o;
                }
                f.addMapping({
                    name: o,
                    source: e,
                    generated: {
                        line: n + u.dest_line_diff,
                        column: t
                    },
                    original: {
                        line: i + u.orig_line_diff,
                        column: r
                    }
                });
            },
            get: function() {
                return f;
            },
            toString: function() {
                return JSON.stringify(f.toJSON());
            }
        };
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof me && e[t].body instanceof An) {
                    e[t] = new be({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof me && e[t].body instanceof An)) {
                    n = false;
                }
            }
            return e;
        }
        var i = {
            Program: function(e) {
                return new $e({
                    start: s(e),
                    end: u(e),
                    body: n(e.body.map(f))
                });
            },
            FunctionDeclaration: function(e) {
                return new je({
                    start: s(e),
                    end: u(e),
                    name: f(e.id),
                    argnames: e.params.map(f),
                    body: n(f(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new qe({
                    start: s(e),
                    end: u(e),
                    name: f(e.id),
                    argnames: e.params.map(f),
                    body: n(f(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new ye({
                    start: s(e),
                    end: u(e),
                    body: f(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new We({
                    start: s(e),
                    end: u(e),
                    body: f(e.block).body,
                    bcatch: f(n[0]),
                    bfinally: e.finalizer ? new Je(f(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: u(e.value),
                    key: n.type == "Identifier" ? n.name : n.value,
                    value: f(e.value)
                };
                if (e.kind == "init") return new hn(t);
                t.key = new ae({
                    name: t.key
                });
                t.value = new Me(t.value);
                if (e.kind == "get") return new oe(t);
                if (e.kind == "set") return new re(t);
            },
            ArrayExpression: function(e) {
                return new pn({
                    start: s(e),
                    end: u(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Bn() : f(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new dn({
                    start: s(e),
                    end: u(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return f(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new nn({
                    start: s(e),
                    end: u(e),
                    expressions: e.expressions.map(f)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? on : rn)({
                    start: s(e),
                    end: u(e),
                    property: e.computed ? f(e.property) : e.property.name,
                    expression: f(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? Ye : Le)({
                    start: s(e),
                    end: u(e),
                    expression: f(e.test),
                    body: e.consequent.map(f)
                });
            },
            VariableDeclaration: function(e) {
                return new Ze({
                    start: s(e),
                    end: u(e),
                    definitions: e.declarations.map(f)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: u(e)
                };
                if (n === null) return new Dn(t);
                var i = e.regex;
                if (i && i.pattern) {
                    t.value = new RegExp(i.pattern, i.flags);
                    t.value.raw_source = i.pattern;
                    return new kn(t);
                } else if (i) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new kn(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new An(t);

                  case "number":
                    t.value = n;
                    return new En(t);

                  case "boolean":
                    return new (n ? $n : On)(t);
                }
            },
            Identifier: function(e) {
                var n = o[o.length - 2];
                return new (n.type == "LabeledStatement" ? se : n.type == "VariableDeclarator" && n.id === e ? _n : n.type == "FunctionExpression" ? n.id === e ? bn : mn : n.type == "FunctionDeclaration" ? n.id === e ? gn : mn : n.type == "CatchClause" ? yn : n.type == "BreakStatement" || n.type == "ContinueStatement" ? ue : wn)({
                    start: s(e),
                    end: u(e),
                    name: e.name
                });
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? sn : un)({
                start: s(n),
                end: u(n),
                operator: n.operator,
                expression: f(n.argument)
            });
        };
        e("EmptyStatement", Ae);
        e("BlockStatement", xe, "body@body");
        e("IfStatement", Pe, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", Ee, "label>label, body>body");
        e("BreakStatement", Ie, "label>label");
        e("ContinueStatement", Ue, "label>label");
        e("WithStatement", Te, "object>expression, body>body");
        e("SwitchStatement", Ve, "discriminant>expression, cases@body");
        e("ReturnStatement", Ne, "argument>value");
        e("ThrowStatement", ie, "argument>value");
        e("WhileStatement", Ce, "test>condition, body>body");
        e("DoWhileStatement", Fe, "test>condition, body>body");
        e("ForStatement", Be, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", Se, "left>init, right>object, body>body");
        e("DebuggerStatement", ge);
        e("VariableDeclarator", Ke, "id>name, init>value");
        e("CatchClause", Ge, "param>argname, body%body");
        e("ThisExpression", xn);
        e("BinaryExpression", fn, "operator=operator, left>left, right>right");
        e("LogicalExpression", fn, "operator=operator, left>left, right>right");
        e("AssignmentExpression", ln, "operator=operator, left>left, right>right");
        e("ConditionalExpression", cn, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", en, "callee>expression, arguments@args");
        e("CallExpression", Qe, "callee>expression, arguments@args");
        c($e, function e(n) {
            return d("Program", n);
        });
        c(je, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(qe, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(be, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(ye, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(R, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(We, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(Ge, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(Xe, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(nn, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(tn, function e(n) {
            var t = n instanceof on;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(an, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof sn,
                argument: l(n.expression)
            };
        });
        c(fn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(pn, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(dn, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(I, function e(n) {
            var t = {
                type: "Literal",
                value: n.key instanceof ae ? n.key.name : n.key
            };
            var i;
            if (n instanceof hn) {
                i = "init";
            } else if (n instanceof oe) {
                i = "get";
            } else if (n instanceof re) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                key: t,
                value: l(n.value)
            };
        });
        c(U, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t ? t.mangled_name || t.name : n.name
            };
        });
        c(kn, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(P, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(a, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        Tn.DEFMETHOD("to_mozilla_ast", P.prototype.to_mozilla_ast);
        Dn.DEFMETHOD("to_mozilla_ast", P.prototype.to_mozilla_ast);
        Bn.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        we.DEFMETHOD("to_mozilla_ast", xe.prototype.to_mozilla_ast);
        ze.DEFMETHOD("to_mozilla_ast", qe.prototype.to_mozilla_ast);
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new j({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function u(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new j({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function e(e, n, t) {
            var o = "function From_Moz_" + e + "(M){\n";
            o += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var a = "function To_Moz_" + e + "(M){\n";
            a += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                o += ",\n" + r + ": ";
                a += ",\n" + t + ": ";
                switch (i) {
                  case "@":
                    o += "M." + t + ".map(from_moz)";
                    a += "M." + r + ".map(to_moz)";
                    break;

                  case ">":
                    o += "from_moz(M." + t + ")";
                    a += "to_moz(M." + r + ")";
                    break;

                  case "=":
                    o += "M." + t;
                    a += "M." + r;
                    break;

                  case "%":
                    o += "from_moz(M." + t + ").body";
                    a += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            o += "\n})\n}";
            a += "\n}\n}";
            o = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + o + ")")(h, s, u, f);
            a = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + a + ")")(l, p, d);
            i[e] = o;
            c(n, a);
        }
        var o = null;
        function f(e) {
            o.push(e);
            var n = e != null ? i[e.type](e) : null;
            o.pop();
            return n;
        }
        _e.from_mozilla_ast = function(e) {
            var n = o;
            o = [];
            var t = f(e);
            o = n;
            t.walk(new zn(function(e) {
                if (e instanceof ue) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof Oe) break;
                        if (t instanceof Ee && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        Ln("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var i = e.start;
            var r = e.end;
            if (i.pos != null && r.endpos != null) {
                n.range = [ i.pos, r.endpos ];
            }
            if (i.line) {
                n.loc = {
                    start: {
                        line: i.line,
                        column: i.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (i.file) {
                    n.loc.source = i.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function d(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof ye && n.body[0].body instanceof An) {
                t.unshift(l(new Ae(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function A(n) {
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        function t(e) {
            v(n, e);
        }
    }
    function E(e, n) {
        e.walk(new zn(function(e) {
            if (e instanceof hn && e.quote) {
                t(e.key);
            } else if (e instanceof on) {
                k(e.property, t);
            }
        }));
        function t(e) {
            v(n, e);
        }
    }
    function k(e, n) {
        e.walk(new zn(function(e) {
            if (e instanceof nn) {
                k(e.tail_node(), n);
            } else if (e instanceof An) {
                n(e.value);
            } else if (e instanceof cn) {
                k(e.consequent, n);
                k(e.alternative, n);
            }
            return true;
        }));
    }
    function D(e, n) {
        n = te(n, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            only_cache: false,
            regex: null,
            reserved: null
        }, true);
        var t = n.reserved;
        if (!Array.isArray(t)) t = [];
        if (!n.builtins) A(t);
        var i = -1;
        var r;
        if (n.cache) {
            r = n.cache.props;
            r.each(function(e) {
                v(t, e);
            });
        } else {
            r = new M();
        }
        var o = n.regex;
        var a = n.debug !== false;
        var s;
        if (a) s = n.debug === true ? "" : n.debug;
        var u = [];
        var f = [];
        e.walk(new zn(function(e) {
            if (e instanceof hn) {
                p(e.key);
            } else if (e instanceof I) {
                p(e.key.name);
            } else if (e instanceof rn) {
                p(e.property);
            } else if (e instanceof on) {
                k(e.property, p);
            } else if (e instanceof Qe && e.expression.print_to_string() == "Object.defineProperty") {
                k(e.args[1], p);
            }
        }));
        return e.transform(new nt(function(e) {
            if (e instanceof hn) {
                e.key = d(e.key);
            } else if (e instanceof I) {
                e.key.name = d(e.key.name);
            } else if (e instanceof rn) {
                e.property = d(e.property);
            } else if (!n.keep_quoted && e instanceof on) {
                e.property = h(e.property);
            } else if (e instanceof Qe && e.expression.print_to_string() == "Object.defineProperty") {
                e.args[1] = h(e.args[1]);
            }
        }));
        function c(e) {
            if (f.indexOf(e) >= 0) return false;
            if (t.indexOf(e) >= 0) return false;
            if (n.only_cache) return r.has(e);
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (o && !o.test(e)) return false;
            if (t.indexOf(e) >= 0) return false;
            return r.has(e) || u.indexOf(e) >= 0;
        }
        function p(e) {
            if (c(e)) v(u, e);
            if (!l(e)) v(f, e);
        }
        function d(e) {
            if (!l(e)) {
                return e;
            }
            var n = r.get(e);
            if (!n) {
                if (a) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = w(++i);
                } while (!c(n));
                r.set(e, n);
            }
            return n;
        }
        function h(e) {
            return e.transform(new nt(function(e) {
                if (e instanceof nn) {
                    var n = e.expressions.length - 1;
                    e.expressions[n] = h(e.expressions[n]);
                } else if (e instanceof An) {
                    e.value = d(e.value);
                } else if (e instanceof cn) {
                    e.consequent = h(e.consequent);
                    e.alternative = h(e.alternative);
                }
                return e;
            }));
        }
    }
    "use strict";
    var F = typeof atob == "undefined" ? function(e) {
        return new Buffer(e, "base64").toString();
    } : atob;
    var C = typeof btoa == "undefined" ? function(e) {
        return new Buffer(e).toString("base64");
    } : btoa;
    function B(e, n) {
        var t = /\n\/\/# sourceMappingURL=data:application\/json(;.*?)?;base64,(.*)/.exec(n);
        if (!t) {
            _e.warn("inline source map not found: " + e);
            return null;
        }
        return F(t[2]);
    }
    function S(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function at(n, t, e) {
        if (t[n]) {
            e.forEach(function(e) {
                if (t[e]) {
                    if (typeof t[e] != "object") t[e] = {};
                    if (!(n in t[e])) t[e][n] = t[n];
                }
            });
        }
    }
    function st(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new M();
        } else if (!(e.props instanceof M)) {
            e.props = M.fromObject(e.props);
        }
    }
    function ut(e) {
        return {
            props: e.props.toObject()
        };
    }
    function ft(e, n) {
        var t = _e.warn_function;
        try {
            n = te(n, {
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                warnings: false,
                wrap: false
            }, true);
            var i = n.timings && {
                start: Date.now()
            };
            if (n.rename === undefined) {
                n.rename = n.compress && n.mangle;
            }
            at("ie8", n, [ "compress", "mangle", "output" ]);
            at("keep_fnames", n, [ "compress", "mangle" ]);
            at("toplevel", n, [ "compress", "mangle" ]);
            at("warnings", n, [ "compress" ]);
            var r;
            if (n.mangle) {
                n.mangle = te(n.mangle, {
                    cache: n.nameCache && (n.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false
                }, true);
                if (n.mangle.properties) {
                    if (typeof n.mangle.properties != "object") {
                        n.mangle.properties = {};
                    }
                    if (n.mangle.properties.keep_quoted) {
                        r = n.mangle.properties.reserved;
                        if (!Array.isArray(r)) r = [];
                        n.mangle.properties.reserved = r;
                    }
                    if (n.nameCache && !("cache" in n.mangle.properties)) {
                        n.mangle.properties.cache = n.nameCache.props || {};
                    }
                }
                st(n.mangle.cache);
                st(n.mangle.properties.cache);
            }
            if (n.sourceMap) {
                n.sourceMap = te(n.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    root: null,
                    url: null
                }, true);
            }
            var o = [];
            if (n.warnings && !_e.warn_function) {
                _e.warn_function = function(e) {
                    o.push(e);
                };
            }
            if (i) i.parse = Date.now();
            var a, s;
            if (e instanceof $e) {
                s = e;
            } else {
                if (typeof e == "string") {
                    e = [ e ];
                }
                n.parse = n.parse || {};
                n.parse.toplevel = null;
                var u = n.sourceMap && n.sourceMap.content;
                if (typeof u == "string" && u != "inline") {
                    u = S(u);
                }
                a = u && Object.create(null);
                for (var f in e) if (ve(e, f)) {
                    n.parse.filename = f;
                    n.parse.toplevel = et(e[f], n.parse);
                    if (a) {
                        if (u == "inline") {
                            var c = B(f, e[f]);
                            if (c) {
                                a[f] = S(c);
                            }
                        } else {
                            a[f] = u;
                        }
                    }
                }
                s = n.parse.toplevel;
            }
            if (r) {
                E(s, r);
            }
            if (n.wrap) {
                s = s.wrap_commonjs(n.wrap);
            }
            if (n.enclose) {
                s = s.wrap_enclose(n.enclose);
            }
            if (i) i.rename = Date.now();
            if (n.rename) {
                s.figure_out_scope(n.mangle);
                s.expand_names(n.mangle);
            }
            if (i) i.compress = Date.now();
            if (n.compress) s = new ot(n.compress).compress(s);
            if (i) i.scope = Date.now();
            if (n.mangle) s.figure_out_scope(n.mangle);
            if (i) i.mangle = Date.now();
            if (n.mangle) {
                s.compute_char_frequency(n.mangle);
                s.mangle_names(n.mangle);
            }
            if (i) i.properties = Date.now();
            if (n.mangle && n.mangle.properties) {
                s = D(s, n.mangle.properties);
            }
            if (i) i.output = Date.now();
            var l = {};
            if (n.output.ast) {
                l.ast = s;
            }
            if (!ve(n.output, "code") || n.output.code) {
                if (n.sourceMap) {
                    n.output.source_map = x({
                        file: n.sourceMap.filename,
                        orig: a,
                        root: n.sourceMap.root
                    });
                    if (n.sourceMap.includeSources) {
                        if (e instanceof $e) {
                            throw new Error("original source content unavailable");
                        } else for (var f in e) if (ve(e, f)) {
                            n.output.source_map.get().setSourceContent(f, e[f]);
                        }
                    } else {
                        n.output.source_map.get()._sourcesContents = null;
                    }
                }
                delete n.output.ast;
                delete n.output.code;
                var p = rt(n.output);
                s.print(p);
                l.code = p.get();
                if (n.sourceMap) {
                    l.map = n.output.source_map.toString();
                    if (n.sourceMap.url == "inline") {
                        l.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + C(l.map);
                    } else if (n.sourceMap.url) {
                        l.code += "\n//# sourceMappingURL=" + n.sourceMap.url;
                    }
                }
            }
            if (n.nameCache && n.mangle) {
                if (n.mangle.cache) n.nameCache.vars = ut(n.mangle.cache);
                if (n.mangle.properties && n.mangle.properties.cache) {
                    n.nameCache.props = ut(n.mangle.properties.cache);
                }
            }
            if (i) {
                i.end = Date.now();
                l.timings = {
                    parse: .001 * (i.rename - i.parse),
                    rename: .001 * (i.compress - i.rename),
                    compress: .001 * (i.scope - i.compress),
                    scope: .001 * (i.mangle - i.scope),
                    mangle: .001 * (i.properties - i.mangle),
                    properties: .001 * (i.output - i.properties),
                    output: .001 * (i.end - i.output),
                    total: .001 * (i.end - i.start)
                };
            }
            if (o.length) {
                l.warnings = o;
            }
            return l;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            _e.warn_function = t;
        }
    }
    h["Dictionary"] = M;
    h["minify"] = ft;
    h["parse"] = et;
    h["push_uniq"] = v;
    h["TreeTransformer"] = nt;
    h["TreeWalker"] = zn;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
